create or replace FUNCTION GERA_DATA_PROG_EPI
   (P_NRVINCULOM IN SST_HISTORICOEPI.NRVINCULOM%TYPE,
    P_NREPI IN SST_HISTORICOEPI.NREPI%TYPE,
    P_QTDIASANTECIPA IN SST_ITEMPERFILEPI.QTDIASANTECIPA%TYPE,
    P_QTPERIODMESES IN SST_ITEMPERFILEPI.QTPERIODMESES%TYPE,
    P_DTINICIAL IN SST_FORMPROGEPI.DTINICIAL%TYPE,
    P_DTFINAL IN SST_FORMPROGEPI.DTFINAL%TYPE,
    P_NRORG IN SST_FORMPROGEPI.NRORG%TYPE)
RETURN DATE

IS
   V_DTENTREGAEPI SST_HISTORICOEPI.DTENTREGAEPI%TYPE;
   V_DTULTENTREGA SST_HISTORICOEPI.DTENTREGAEPI%TYPE;

BEGIN
   --BUSCA A DATA DE ENTREGA MAIS RECENTE DO EPI NO HISTÓRICO
   BEGIN
      SELECT MAX(NVL(HEP.DTEFETIVA, HEP.DTENTREGAEPI))
        INTO V_DTULTENTREGA
        FROM SST_HISTORICOEPI HEP
       WHERE HEP.NREPI = P_NREPI
         AND HEP.NRVINCULOM = P_NRVINCULOM
         AND HEP.NRORG = P_NRORG
   AND NVL(HEP.DTEFETIVA, HEP.DTENTREGAEPI) <= P_DTINICIAL;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_DTULTENTREGA := NULL;
   END;

   --CASO NAO ENCONTRE DATA DE ENTREGA MAIS RECENTE(EPI NUNCA FOI ENTREGUE) BUSCA A DATA INICIO DA OCUPAÇÃO MAIS RECENTE DO VÍNCULO
   IF V_DTULTENTREGA IS NULL THEN
      BEGIN
         SELECT MAX(AOC.DTINIOCUPACAO)
           INTO V_DTULTENTREGA
           FROM GPE_ALTEOCUPACAO AOC
          WHERE AOC.NRVINCULOM = P_NRVINCULOM
            AND AOC.NRORG = P_NRORG
            AND AOC.DTFIMOCUPACAO IS NULL
   AND AOC.DTINIOCUPACAO <= P_DTINICIAL;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_DTULTENTREGA := NULL;
      END;
   END IF;

   IF V_DTULTENTREGA IS NOT NULL THEN
      --ADICIONA O PERIODO(EM MESES) DE ENTREGA DO EPI ENQUANTO A DATA(V_DTULTENTREGA) FOR MENOR QUE A DATA INICIAL DO PERÍODO
      WHILE V_DTULTENTREGA < P_DTINICIAL LOOP
         V_DTULTENTREGA := ADD_MONTHS(V_DTULTENTREGA, P_QTPERIODMESES);
         V_DTENTREGAEPI := V_DTULTENTREGA;
      END LOOP;
      --RETIRA A QUANTIDADES DE DIAS A SEREM ANTECIPADAS NA DATA
      V_DTENTREGAEPI := V_DTENTREGAEPI - NVL(P_QTDIASANTECIPA, 0);

      --SE A DATA FINAL OBTIDA FOR MAIOR QUE A DATA FINAL DO PERÍODO, A DATA DE ENTREGA É DEFINIDA COMO NULA
      IF V_DTENTREGAEPI > P_DTFINAL THEN
         V_DTENTREGAEPI := NULL;
      END IF;
   ELSE
      V_DTENTREGAEPI := NULL;
   END IF;

   RETURN V_DTENTREGAEPI;
END;
/