/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_CARG                                                     */
/* Tabela : CARGO                                                             */
/*                                                                            */
/* Criao:                                                                   */
/* 08/12/2003 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_CARG
BEFORE INSERT OR UPDATE OR DELETE
ON CARGO FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUCARG := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDCARGO,0) <> NVL(:NEW.CDCARGO,0)) OR
         (NVL(:OLD.NMCARGO,0) <> NVL(:NEW.NMCARGO,0)) THEN
         :NEW.DTULTATUCARG := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('CARGO', '', 'CDCARGO='||:OLD.CDCARGO||';', SYSDATE);
   END IF;

END;
/

ALTER TABLE CARGO MODIFY DTULTATUCARG DEFAULT SYSDATE
/
