IF EXISTS (SELECT * 
             FROM SYSOBJECTS O, SYSUSERS U
            WHERE O.NAME = 'MOVIMENTACAO_ESTOQUE'
              AND TYPE = 'P'
              AND U.UID = O.UID
              AND U.NAME = USER)

  DROP PROCEDURE MOVIMENTACAO_ESTOQUE
  GO

CREATE PROCEDURE MOVIMENTACAO_ESTOQUE @P_FILIAL       VARCHAR(4),
                                      @P_CDALMOXARIFE VARCHAR(06),
                                      @P_CDLOCALESTOQ VARCHAR(06),
                                      @P_NRLOTEESTQ   VARCHAR(20),
                                      @P_TAMNIVEL     INTEGER,
                                      @P_DTINICIAL    DATETIME,
                                      @P_DTFINAL      DATETIME,
                                      @P_PRODINI      VARCHAR(20),
                                      @P_PRODFIM      VARCHAR(20),
                                      @P_IDLANCTO     INTEGER,
                                      @P_IDCUSTO      INTEGER,
                                      @P_SEQUMOVI     VARCHAR(10),
                                      @P_MOVCONSOLID  VARCHAR(1) = 'N',
                                      @P_CUSTOALMOX   VARCHAR(1) = 'N',
                                      @P_DELMOVIMEN   VARCHAR(1) = 'S'

AS

   DECLARE @V_CDPRODUTO  VARCHAR(20);
   DECLARE @V_NRLOTEESTQ VARCHAR(20);
   DECLARE @V_NRSUBLOTE  VARCHAR(04);
   DECLARE @V_SGUNIDADE VARCHAR(10);
   DECLARE @V_COUNT     NUMERIC(9);
   DECLARE @V_QTATUAL   NUMERIC(15,5);
   DECLARE @V_CUSTMEES  DOUBLE PRECISION;
   DECLARE @V_VRATUAL   NUMERIC(15,5);
   DECLARE @V_QTMOVI    DOUBLE PRECISION;
   DECLARE @V_CUSTMED   DOUBLE PRECISION;
   DECLARE @V_CUSTANT   DOUBLE PRECISION;
   DECLARE @V_QTDEANT   DOUBLE PRECISION;
   DECLARE @V_CUSTZERO  DOUBLE PRECISION;
   DECLARE @V_QTMOVANT  DOUBLE PRECISION;
   DECLARE @V_VRMOVANT  DOUBLE PRECISION;
   DECLARE @V_DIFCUSTSAI   DOUBLE PRECISION;
   DECLARE @V_ULTCUSTENT   DOUBLE PRECISION;
   DECLARE @V_VRDIFCUSSAID DOUBLE PRECISION;
   DECLARE @V_VRCUSTSEGANT DOUBLE PRECISION;
   DECLARE @V_VRCUSTLOGANT DOUBLE PRECISION;
   DECLARE @V_VRMOVLOGANT  DOUBLE PRECISION;
   DECLARE @V_VRMOVSEGANT  DOUBLE PRECISION;
   DECLARE @V_VRANTEST     DOUBLE PRECISION;
   DECLARE @V_VRDIFCUSTEME DOUBLE PRECISION;
   DECLARE @V_VRATUEST     DOUBLE PRECISION;
   /* VARIVEIS DO CURSOR C_MOVIMENTA */

   DECLARE @V_NRRELATMOVI      VARCHAR(10)  ;
   DECLARE @V_CDFILIMOVIEST    VARCHAR(4)   ;
   DECLARE @V_CDFILLANCMEST    VARCHAR(4)   ;
   DECLARE @V_NRLANCMOVIEST    VARCHAR(10)  ;
   DECLARE @V_NRSEQUMOVIEST    VARCHAR(4)   ;
   DECLARE @V_CDPRODMOVIEST    VARCHAR(20)  ;
   DECLARE @V_DTLANCMOVIEST    DATETIME     ;
   DECLARE @V_IDTIPOMOVIEST    VARCHAR(1)   ;
   DECLARE @V_QTDEMOVIEST      DOUBLE PRECISION;
   DECLARE @V_VRCUSTMEDI       DOUBLE PRECISION;
   DECLARE @V_VRCUSTMOVIEST    DOUBLE PRECISION;
   DECLARE @V_QTLANCAMENTO     DOUBLE PRECISION;
   DECLARE @V_VRCUSTBRUT       DOUBLE PRECISION;
   DECLARE @V_VRCUSTMEES       DOUBLE PRECISION;
   DECLARE @V_VRCUSTMEBR       DOUBLE PRECISION;
   DECLARE @V_QTLANCMOVIEST    DOUBLE PRECISION;
   DECLARE @V_VRLANCMOVIEST    DOUBLE PRECISION;
   DECLARE @V_VRBRUTMOVIEST    DOUBLE PRECISION;
   DECLARE @V_CDTOTMOVIEST     VARCHAR(10)  ;
   DECLARE @V_NMPRODMOVIEST    VARCHAR(50)  ;
   DECLARE @V_IDORDEMCALC      VARCHAR(1)   ;
   DECLARE @V_IDALTCMEDMOV     VARCHAR(1)   ;
   DECLARE @V_VRDIFECUST       DOUBLE PRECISION;
   DECLARE @V_CDALMOXARIRM     VARCHAR(06);
   DECLARE @V_CDLOCALESTRM     VARCHAR(06);
   DECLARE @V_NRLOTEESTQME     VARCHAR(20);
   DECLARE @V_NRSUBLOTEME      VARCHAR(04);
   DECLARE @V_CDTIPORETIME     VARCHAR(02);
   DECLARE @V_NMTIPORETIME     VARCHAR(40);
   DECLARE @V_IDENTRSAIDME     VARCHAR(01);
   DECLARE @V_CDTIPOOPERME     VARCHAR(02);
   DECLARE @V_VRQTDETOTAL      DOUBLE PRECISION;
   DECLARE @V_VALORQTTOT       DOUBLE PRECISION;
   DECLARE @V_SGUNIDMOVI       VARCHAR(10);
   DECLARE @V_INSERT           VARCHAR(01);
   DECLARE @V_VRSOMSATUAN      DOUBLE PRECISION;
   DECLARE @V_VRQTDESATUAN     DOUBLE PRECISION;
   DECLARE @V_VRTOTALANT       DOUBLE PRECISION;
   DECLARE @V_VRUNILANCEST     DOUBLE PRECISION;
   DECLARE @V_VRTOTLANCEST     DOUBLE PRECISION;
   DECLARE @V_QTTOTALANT       DOUBLE PRECISION;
   DECLARE @V_VRCUSTENTRME     DOUBLE PRECISION;

   /* VARIVEIS DO CURSOR C_TOTALMOVI */

   DECLARE @V_VRCUSTTOTAL      DOUBLE PRECISION;
   DECLARE @V_QTDEAJUSTE       DOUBLE PRECISION;
   DECLARE @V_VLRESTOAJU       DOUBLE PRECISION;
   DECLARE @V_VLRBRUTAJU       DOUBLE PRECISION;

   /* VARIVEIS PARA PROCEDURE GRAVA_RELAT_MOVIEST*/
   DECLARE @V_MCDFILIAL          VARCHAR(4);
   DECLARE @V_MCDPRODUTO         VARCHAR(20);
   DECLARE @V_MNRLOTEESTQ        VARCHAR(20);
   DECLARE @V_MNRSUBLOTE         VARCHAR(04);
   DECLARE @V_MDTLANCAMEN        DATETIME;
   DECLARE @V_MIDTIPOLANC        VARCHAR(01);
   DECLARE @V_MCDFILLANC         VARCHAR(4);
   DECLARE @V_MNRLANCAMEN        VARCHAR(10);
   DECLARE @V_MNRSEQULANC        VARCHAR(04);
   DECLARE @V_MQTDEESTO          DOUBLE PRECISION;
   DECLARE @V_MCUSTMEDI          DOUBLE PRECISION;
   DECLARE @V_MCUSTESTO          DOUBLE PRECISION;
   DECLARE @V_MQTLANCAMEN        DOUBLE PRECISION;
   DECLARE @V_MCUSTBRUT          DOUBLE PRECISION;
   DECLARE @V_MCUSTMEES          DOUBLE PRECISION;
   DECLARE @V_MCUSTMEBR          DOUBLE PRECISION;
   DECLARE @V_MIDALTCMEDMV       VARCHAR(01);
   DECLARE @V_MQTLANCTOEST       DOUBLE PRECISION;
   DECLARE @V_MVRLANCTOEST       DOUBLE PRECISION;
   DECLARE @V_MVRLANCTOBRUT      DOUBLE PRECISION;
   DECLARE @V_MIDORDEMCLC        VARCHAR(01);
   DECLARE @V_MNVPROD            VARCHAR(20);
   DECLARE @V_MNMPRODUTO         VARCHAR(50);
   DECLARE @V_MSGUNIDADE         VARCHAR(10);
   DECLARE @V_MSEQUMOVI          VARCHAR(10);
   DECLARE @V_MVRUNILANCTO       DOUBLE PRECISION;
   DECLARE @V_MVRTOTLANCTO       DOUBLE PRECISION;
   DECLARE @V_MVRTOTALANTE       DOUBLE PRECISION;
   DECLARE @V_MQTTOTALANTE       DOUBLE PRECISION;
   DECLARE @V_MCDALMOXARIFE      VARCHAR(06);
   DECLARE @V_MCDLOCALESTOQ      VARCHAR(06);
   DECLARE @V_MVRCUSTENTRME      DOUBLE PRECISION;
   DECLARE @V_MCDTIPORETIME      VARCHAR(02);
   DECLARE @V_MNMTIPORETIME      VARCHAR(40);
   DECLARE @V_MIDENTRSAIDME      VARCHAR(1);
   DECLARE @V_MCDTIPOOPERME      VARCHAR(02);

   DECLARE @V_PRODUTO            VARCHAR(10);
   DECLARE @V_CDALMOXLCEST       VARCHAR(12);
   DECLARE @V_CDPRODESTO         VARCHAR(10);
   DECLARE @V_TIPCUSTEST         DOUBLE PRECISION;
   DECLARE @V_CUSTESTOQ          DOUBLE PRECISION;
   DECLARE @V_DATAPROC           DATETIME;
   DECLARE @V_TAMARV             DOUBLE PRECISION;
   DECLARE @V_MOVCDPRODUTO       VARCHAR(10);

   DECLARE @V_VRQTANT            DOUBLE PRECISION;
   DECLARE @V_VRESTOANT          DOUBLE PRECISION;

   DECLARE @V_VRCUSTLOGEME       DOUBLE PRECISION;
   DECLARE @V_VRCUSTSEGEME       DOUBLE PRECISION;
   DECLARE @V_VRPESOBRUTME       DOUBLE PRECISION;
   DECLARE @V_VRCUSTLOGLME       DOUBLE PRECISION;
   DECLARE @V_VRCUSTSEGLME       DOUBLE PRECISION;
   DECLARE @V_MVRCUSTLOGLME      DOUBLE PRECISION;
   DECLARE @V_MVRCUSTSEGLME      DOUBLE PRECISION;
   DECLARE @V_MCUSTLOGESTO       DOUBLE PRECISION;
   DECLARE @V_MCUSTSEGESTO       DOUBLE PRECISION;
   DECLARE @V_MVRPESOBRUTME      DOUBLE PRECISION;
   DECLARE @V_VRDIFSAID          DOUBLE PRECISION;
   DECLARE @V_DTLANCMOVIESTD     DATETIME;
   DECLARE @V_CDPRODTOTAMOVI     VARCHAR(21);
   DECLARE @V_CDFILISUBGR        VARCHAR(04);
   DECLARE @V_CDGRUPPRMOVEST     VARCHAR(10);
   DECLARE @V_CUSTTOTENTR        DOUBLE PRECISION;
   DECLARE @V_CUSTOMEDIO         DOUBLE PRECISION;
   DECLARE @V_CUSTOANTCONS       DOUBLE PRECISION;
   
BEGIN
   SET @V_TIPCUSTEST  = 3;
   SET @V_DATAPROC    = NULL;
   SET @V_CDPRODESTO  = NULL;
   SET @V_COUNT       = 0;
   SET @V_TAMARV      = NULL;

   SELECT @V_TIPCUSTEST = ISNULL(MAX(CONVERT(NUMERIC,P.CDTIPCUSTEST)),3),
          @V_DATAPROC   = CASE MAX(PG.IDUTILDTPROC) WHEN 'S' THEN MAX(ISNULL(P.DTPROCESSA, GETDATE())) ELSE GETDATE() END,
          @V_CDGRUPPRMOVEST = MAX(P.CDGRUPPRMOVEST)
   FROM PARAMFILIAL P, PARAMGERAL PG
   WHERE P.CDFILIAL = @P_FILIAL;


   /*Verifica se filial tem sub-grupo especfico*/
   DECLARE C_FILGRUPO CURSOR FOR
      SELECT DISTINCT CDFILISUBGR
        FROM PRSUBGRPROD
       WHERE CDGRUPPROD = @V_CDGRUPPRMOVEST
       ORDER BY CDFILISUBGR ASC;
   OPEN C_FILGRUPO;
   FETCH NEXT FROM C_FILGRUPO INTO @V_CDFILISUBGR;
   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @V_CDFILISUBGR = @P_FILIAL BEGIN
         BREAK;
      END
      ELSE BEGIN
         SET @V_CDFILISUBGR = 'P';
      END;
      FETCH NEXT FROM C_FILGRUPO INTO @V_CDFILISUBGR;
   END;
   DEALLOCATE C_FILGRUPO;
   
---------------------------------------------------------------------------------
-- DELETA OS REGISTROS DAS TABELA TEMPORARIAS                                  --
---------------------------------------------------------------------------------
   IF ISNULL(@P_DELMOVIMEN, 'S') = 'S' BEGIN
      DELETE FROM RELAT_MOVIEST
      WHERE NRRELATMOVI = @P_SEQUMOVI;

      DELETE FROM RELAT_DESCMOVI
      WHERE NRRELATDESC = @P_SEQUMOVI;

      DELETE FROM RELAT_TOTAMOVI
      WHERE NRRELATTOTA = @P_SEQUMOVI;

      DELETE FROM RELAT_ANALMOVI
      WHERE NRRELATANAL = @P_SEQUMOVI;
   END;

---------------------------------------------------------------------------------
-- INSERE PRODUTOS NA TABELA RELAT_MOVIEST DA POSIESTDIA E ITLANCTOEST         --
---------------------------------------------------------------------------------

   IF (ISNULL(@P_MOVCONSOLID,'N') = 'N') BEGIN
      IF @V_CDGRUPPRMOVEST IS NULL BEGIN
         DECLARE C_POSESTDIA CURSOR FOR
            SELECT A.CDFILIAL,
                   B.CDARVPROD AS CDPRODUTO,
                   (CASE LEN(A.NRLOTEESTQ) WHEN 0 THEN ' ' ELSE A.NRLOTEESTQ END) AS NRLOTEESTQ,
                   (CASE LEN(A.NRSUBLOTE) WHEN 0 THEN ' ' ELSE A.NRSUBLOTE END) AS NRSUBLOTE,
                   A.DTPOSIESTQ AS DTLANCAMEN,
                   '-' AS IDTIPOLANC,
                   '----' AS CDFILLANC,
                   '----------' AS NRLANCAMEN,
                   '0001' AS NRSEQULANC,
                   A.QTESTOQDIA AS QTDEESTO,
                   (CASE A.QTESTOQDIA WHEN 0 THEN 0 ELSE ((CASE @P_IDCUSTO WHEN 1 THEN A.VRESTOQDIA ELSE A.VRESTOQBRUT END)/A.QTESTOQDIA) END) AS CUSTMEDI,
                   (CASE A.QTESTOQDIA WHEN 0 THEN 0 ELSE A.VRESTOQDIA END) AS CUSTESTO,
                   A.QTESTOQDIA AS QTLANCAMEN,
                   (CASE A.QTESTOQDIA WHEN 0 THEN VRBRUTOANT ELSE A.VRESTOQBRUT END) AS CUSTBRUT,
                   (CASE A.QTESTOQDIA WHEN 0 THEN (CASE QTESTOQANT WHEN 0 THEN 0 ELSE (VRESTOQANT/QTESTOQANT) END) ELSE A.VRESTOQDIA/A.QTESTOQDIA END) AS CUSTMEES,
                   (CASE A.QTESTOQDIA WHEN 0 THEN (CASE QTESTOQANT WHEN 0 THEN 0 ELSE (VRBRUTOANT/QTESTOQANT) END) ELSE A.VRESTOQBRUT/A.QTESTOQDIA END) AS CUSTMEBR,
                   ' ' AS IDALTCMEDMV,
                   0.0 AS QTLANCTOEST,
                   0.0 AS VRLANCTOEST,
                   0.0 AS VRLANCTOBRUT,
                   '-' AS IDORDEMCLC,
                   SUBSTRING(B.CDARVPROD,1, @P_TAMNIVEL) AS NVPROD,
                   B.NMPRODUTO,
                   B.SGUNIDADE,
                   0.0 AS VRUNILANCTO,
                   0.0 AS VRTOTLANCTO,
                   0.0 AS VRTOTALANTE,
                   0.0 AS QTTOTALANTE,
                   A.CDALMOXARIFE AS CDALMOXARIFE,
                   A.CDLOCALESTOQ AS CDLOCALESTOQ,
                   0.0 AS VRCUSTENTRME,
                   '--' AS CDTIPORETIME,
                   '------------------------------' AS NMTIPORETIME,
                   '-' AS IDENTRSAIDME,
                   '--' AS CDTIPOOPERME,
                   0 AS VRCUSTLOGLME,
                   0 AS VRCUSTSEGLME,
                   ISNULL(VRPESOBRUTPR,0) AS VRPESOBRUTME,
                   ISNULL(A.VRCLOGDIA,0) AS CUSTLOGESTO,
                   ISNULL(A.VRSEGUDIA,0) AS CUSTSEGESTO
              FROM PRODUTO B, POSESTDIA A,
                   (SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, CDPRODUTO, 
                           NRLOTEESTQ, NRSUBLOTE, MAX(DTPOSIESTQ) AS DTPOSIESTQ
                      FROM POSESTDIA
                     WHERE CDFILIAL = @P_FILIAL
                       AND ((CDALMOXARIFE = @P_CDALMOXARIFE) OR (@P_CDALMOXARIFE IS NULL)) 
                       AND ((CDLOCALESTOQ = @P_CDLOCALESTOQ) OR (@P_CDLOCALESTOQ IS NULL)) 
                       AND ((NRLOTEESTQ = @P_NRLOTEESTQ) OR (@P_NRLOTEESTQ IS NULL))
                       AND DTPOSIESTQ <= @P_DTINICIAL
                     GROUP BY CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, CDPRODUTO, 
                              NRLOTEESTQ, NRSUBLOTE) C
             WHERE (A.CDFILIAL = @P_FILIAL)
               AND ((A.CDALMOXARIFE = @P_CDALMOXARIFE) OR (@P_CDALMOXARIFE IS NULL)) 
               AND ((A.CDLOCALESTOQ = @P_CDLOCALESTOQ) OR (@P_CDLOCALESTOQ IS NULL)) 
               AND ((A.NRLOTEESTQ = @P_NRLOTEESTQ) OR (@P_NRLOTEESTQ IS NULL))
               AND (B.CDARVPROD >= @P_PRODINI)
               AND (B.CDARVPROD <= @P_PRODFIM)
               AND (B.CDPRODUTO = A.CDPRODUTO)
               AND (A.CDFILIAL = C.CDFILIAL)
               AND (A.CDALMOXARIFE = C.CDALMOXARIFE) 
               AND (A.CDLOCALESTOQ = C.CDLOCALESTOQ) 
               AND (A.CDPRODUTO = C.CDPRODUTO)
               AND (A.NRLOTEESTQ = C.NRLOTEESTQ)
               AND (A.NRSUBLOTE = C.NRSUBLOTE) 
               AND (A.DTPOSIESTQ = C.DTPOSIESTQ);
         OPEN C_POSESTDIA;
         FETCH NEXT FROM C_POSESTDIA INTO @V_MCDFILIAL,     @V_MCDPRODUTO,    @V_MNRLOTEESTQ,   @V_MNRSUBLOTE,    @V_MDTLANCAMEN,
                                          @V_MIDTIPOLANC,   @V_MCDFILLANC,    @V_MNRLANCAMEN,   @V_MNRSEQULANC,   @V_MQTDEESTO,
                                          @V_MCUSTMEDI,     @V_MCUSTESTO,     @V_MQTLANCAMEN,   @V_MCUSTBRUT,     @V_MCUSTMEES,
                                          @V_MCUSTMEBR,     @V_MIDALTCMEDMV,  @V_MQTLANCTOEST,  @V_MVRLANCTOEST,  @V_MVRLANCTOBRUT,
                                          @V_MIDORDEMCLC,   @V_MNVPROD,       @V_MNMPRODUTO,    @V_MSGUNIDADE,
                                          @V_MVRUNILANCTO,  @V_MVRTOTLANCTO,  @V_MVRTOTALANTE,  @V_MQTTOTALANTE,  @V_MCDALMOXARIFE,
                                          @V_MCDLOCALESTOQ, @V_MVRCUSTENTRME, @V_MCDTIPORETIME, @V_MNMTIPORETIME, @V_MIDENTRSAIDME,
                                          @V_MCDTIPOOPERME,@V_MVRCUSTLOGLME, @V_MVRCUSTSEGLME, @V_MCUSTLOGESTO,  @V_MCUSTSEGESTO,
                                          @V_MVRPESOBRUTME;


         WHILE (@@FETCH_STATUS = 0) BEGIN
            EXEC TEKNISA.GRAVA_RELAT_MOVIEST   @V_MCDFILIAL,     @V_MCDPRODUTO,    @V_MNRLOTEESTQ,   @V_MNRSUBLOTE,    @V_MDTLANCAMEN,
                                               @V_MIDTIPOLANC,   @V_MCDFILLANC,    @V_MNRLANCAMEN,   @V_MNRSEQULANC,   @V_MQTDEESTO,
                                               @V_MCUSTMEDI,     @V_MCUSTESTO,     @V_MQTLANCAMEN,   @V_MCUSTBRUT,     @V_MCUSTMEES,
                                               @V_MCUSTMEBR,     @V_MIDALTCMEDMV,  @V_MQTLANCTOEST,  @V_MVRLANCTOEST,  @V_MVRLANCTOBRUT,
                                               @V_MIDORDEMCLC,   @V_MNVPROD,       @V_MNMPRODUTO,    @V_MSGUNIDADE,    @P_SEQUMOVI,
                                               @V_MVRUNILANCTO,  @V_MVRTOTLANCTO,  @V_MVRTOTALANTE,  @V_MQTTOTALANTE,  @V_MCDALMOXARIFE,
                                               @V_MCDLOCALESTOQ, @V_MVRCUSTENTRME, @V_MCDTIPORETIME, @V_MNMTIPORETIME, @V_MIDENTRSAIDME,
                                               @V_MCDTIPOOPERME,@V_MVRCUSTLOGLME, @V_MVRCUSTSEGLME, @V_MCUSTLOGESTO,  @V_MCUSTSEGESTO,
                                               @V_MVRPESOBRUTME;

            FETCH NEXT FROM C_POSESTDIA INTO @V_MCDFILIAL,     @V_MCDPRODUTO,    @V_MNRLOTEESTQ,   @V_MNRSUBLOTE,    @V_MDTLANCAMEN,
                                             @V_MIDTIPOLANC,   @V_MCDFILLANC,    @V_MNRLANCAMEN,   @V_MNRSEQULANC,   @V_MQTDEESTO,
                                             @V_MCUSTMEDI,     @V_MCUSTESTO,     @V_MQTLANCAMEN,   @V_MCUSTBRUT,     @V_MCUSTMEES,
                                             @V_MCUSTMEBR,     @V_MIDALTCMEDMV,  @V_MQTLANCTOEST,  @V_MVRLANCTOEST,  @V_MVRLANCTOBRUT,
                                             @V_MIDORDEMCLC,   @V_MNVPROD,       @V_MNMPRODUTO,    @V_MSGUNIDADE,
                                             @V_MVRUNILANCTO,  @V_MVRTOTLANCTO,  @V_MVRTOTALANTE,  @V_MQTTOTALANTE,  @V_MCDALMOXARIFE,
                                             @V_MCDLOCALESTOQ, @V_MVRCUSTENTRME, @V_MCDTIPORETIME, @V_MNMTIPORETIME, @V_MIDENTRSAIDME,
                                             @V_MCDTIPOOPERME, @V_MVRCUSTLOGLME, @V_MVRCUSTSEGLME, @V_MCUSTLOGESTO,  @V_MCUSTSEGESTO,
                                             @V_MVRPESOBRUTME;

         END;
         CLOSE C_POSESTDIA;
         DEALLOCATE C_POSESTDIA;
      END
      ELSE BEGIN
         DECLARE C_POSESTDIA_GRUP CURSOR FOR
            SELECT A.CDFILIAL,
                   P.CDARVPROD AS CDPRODUTO,
                   (CASE LEN(A.NRLOTEESTQ) WHEN 0 THEN ' ' ELSE A.NRLOTEESTQ END) AS NRLOTEESTQ,
                   (CASE LEN(A.NRSUBLOTE) WHEN 0 THEN ' ' ELSE A.NRSUBLOTE END) AS NRSUBLOTE,
                   A.DTPOSIESTQ AS DTLANCAMEN,
                   '-' AS IDTIPOLANC,
                   '----' AS CDFILLANC,
                   '----------' AS NRLANCAMEN,
                   '0001' AS NRSEQULANC,
                   A.QTESTOQDIA AS QTDEESTO,
                   (CASE A.QTESTOQDIA WHEN 0 THEN 0 ELSE ((CASE @P_IDCUSTO WHEN 1 THEN A.VRESTOQDIA ELSE A.VRESTOQBRUT END)/A.QTESTOQDIA) END) AS CUSTMEDI,
                   (CASE A.QTESTOQDIA WHEN 0 THEN 0 ELSE A.VRESTOQDIA END) AS CUSTESTO,
                   A.QTESTOQDIA AS QTLANCAMEN,
                   (CASE A.QTESTOQDIA WHEN 0 THEN VRBRUTOANT ELSE A.VRESTOQBRUT END) AS CUSTBRUT,
                   (CASE A.QTESTOQDIA WHEN 0 THEN (CASE QTESTOQANT WHEN 0 THEN 0 ELSE (VRESTOQANT/QTESTOQANT) END) ELSE A.VRESTOQDIA/A.QTESTOQDIA END) AS CUSTMEES,
                   (CASE A.QTESTOQDIA WHEN 0 THEN (CASE QTESTOQANT WHEN 0 THEN 0 ELSE (VRBRUTOANT/QTESTOQANT) END) ELSE A.VRESTOQBRUT/A.QTESTOQDIA END) AS CUSTMEBR,
                   ' ' AS IDALTCMEDMV,
                   0.0 AS QTLANCTOEST,
                   0.0 AS VRLANCTOEST,
                   0.0 AS VRLANCTOBRUT,
                   '-' AS IDORDEMCLC,
                   P.CDSUBGRPROD AS NVPROD,
                   P.NMPRODUTO,
                   P.SGUNIDADE,
                   0.0 AS VRUNILANCTO,
                   0.0 AS VRTOTLANCTO,
                   0.0 AS VRTOTALANTE,
                   0.0 AS QTTOTALANTE,
                   A.CDALMOXARIFE AS CDALMOXARIFE,
                   A.CDLOCALESTOQ AS CDLOCALESTOQ,
                   0.0 AS VRCUSTENTRME,
                   '--' AS CDTIPORETIME,
                   '------------------------------' AS NMTIPORETIME,
                   '-' AS IDENTRSAIDME,
                   '--' AS CDTIPOOPERME,
                   0 AS VRCUSTLOGLME,
                   0 AS VRCUSTSEGLME,
                   ISNULL(VRPESOBRUTPR,0) AS VRPESOBRUTME,
                   ISNULL(A.VRCLOGDIA,0) AS CUSTLOGESTO,
                   ISNULL(A.VRSEGUDIA,0) AS CUSTSEGESTO
             FROM POSESTDIA A,
                  (SELECT X.CDPRODUTO, B.CDARVPROD, B.NMPRODUTO, B.SGUNIDADE, X.CDSUBGRPROD, B.VRPESOBRUTPR
                     FROM PRODUTO B, PRSUBGRPROD X
                    WHERE B.CDPRODUTO = X.CDPRODUTO
                      AND X.CDGRUPPROD = @V_CDGRUPPRMOVEST
                      AND X.CDFILISUBGR = @V_CDFILISUBGR
                      AND B.CDARVPROD BETWEEN @P_PRODINI AND @P_PRODFIM) P,
                  (SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, CDPRODUTO, 
                          NRLOTEESTQ, NRSUBLOTE, MAX(DTPOSIESTQ) AS DTPOSIESTQ
                     FROM POSESTDIA
                    WHERE DTPOSIESTQ <= @P_DTINICIAL
                    GROUP BY CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, CDPRODUTO, 
                             NRLOTEESTQ, NRSUBLOTE) C
            WHERE (A.CDFILIAL = @P_FILIAL)
              AND ((A.CDALMOXARIFE = @P_CDALMOXARIFE) OR (@P_CDALMOXARIFE IS NULL))
              AND ((A.CDLOCALESTOQ = @P_CDLOCALESTOQ) OR (@P_CDLOCALESTOQ IS NULL))
              AND ((A.NRLOTEESTQ = @P_NRLOTEESTQ) OR (@P_NRLOTEESTQ IS NULL))
              AND (P.CDPRODUTO = A.CDPRODUTO)
              AND (A.CDFILIAL = C.CDFILIAL)
              AND (A.CDALMOXARIFE = C.CDALMOXARIFE) 
              AND (A.CDLOCALESTOQ = C.CDLOCALESTOQ) 
              AND (A.CDPRODUTO = C.CDPRODUTO)
              AND (A.NRLOTEESTQ = C.NRLOTEESTQ)
              AND (A.NRSUBLOTE = C.NRSUBLOTE) 
              AND (A.DTPOSIESTQ = C.DTPOSIESTQ);
         OPEN C_POSESTDIA_GRUP;
         FETCH NEXT FROM C_POSESTDIA_GRUP INTO @V_MCDFILIAL, @V_MCDPRODUTO, @V_MNRLOTEESTQ, @V_MNRSUBLOTE, @V_MDTLANCAMEN,
                                               @V_MIDTIPOLANC, @V_MCDFILLANC, @V_MNRLANCAMEN, @V_MNRSEQULANC, @V_MQTDEESTO,
                                               @V_MCUSTMEDI, @V_MCUSTESTO, @V_MQTLANCAMEN, @V_MCUSTBRUT, @V_MCUSTMEES,
                                               @V_MCUSTMEBR, @V_MIDALTCMEDMV, @V_MQTLANCTOEST, @V_MVRLANCTOEST, @V_MVRLANCTOBRUT,
                                               @V_MIDORDEMCLC, @V_MNVPROD, @V_MNMPRODUTO, @V_MSGUNIDADE, @V_MVRUNILANCTO, 
                                               @V_MVRTOTLANCTO, @V_MVRTOTALANTE, @V_MQTTOTALANTE, @V_MCDALMOXARIFE, @V_MCDLOCALESTOQ,
                                               @V_MVRCUSTENTRME, @V_MCDTIPORETIME, @V_MNMTIPORETIME, @V_MIDENTRSAIDME, @V_MCDTIPOOPERME,
                                               @V_MVRCUSTLOGLME, @V_MVRCUSTSEGLME, @V_MCUSTLOGESTO, @V_MCUSTSEGESTO, @V_MVRPESOBRUTME;

         WHILE (@@FETCH_STATUS = 0) BEGIN
            EXEC TEKNISA.GRAVA_RELAT_MOVIEST @V_MCDFILIAL, @V_MCDPRODUTO, @V_MNRLOTEESTQ, @V_MNRSUBLOTE, @V_MDTLANCAMEN,
                                             @V_MIDTIPOLANC, @V_MCDFILLANC, @V_MNRLANCAMEN, @V_MNRSEQULANC, @V_MQTDEESTO,
                                             @V_MCUSTMEDI, @V_MCUSTESTO, @V_MQTLANCAMEN, @V_MCUSTBRUT, @V_MCUSTMEES,
                                             @V_MCUSTMEBR, @V_MIDALTCMEDMV, @V_MQTLANCTOEST, @V_MVRLANCTOEST, @V_MVRLANCTOBRUT,
                                             @V_MIDORDEMCLC, @V_MNVPROD, @V_MNMPRODUTO, @V_MSGUNIDADE, @P_SEQUMOVI, @V_MVRUNILANCTO,
                                             @V_MVRTOTLANCTO, @V_MVRTOTALANTE, @V_MQTTOTALANTE, @V_MCDALMOXARIFE, @V_MCDLOCALESTOQ, 
                                             @V_MVRCUSTENTRME, @V_MCDTIPORETIME, @V_MNMTIPORETIME, @V_MIDENTRSAIDME, @V_MCDTIPOOPERME,
                                             @V_MVRCUSTLOGLME, @V_MVRCUSTSEGLME, @V_MCUSTLOGESTO, @V_MCUSTSEGESTO, @V_MVRPESOBRUTME;

            FETCH NEXT FROM C_POSESTDIA_GRUP INTO @V_MCDFILIAL, @V_MCDPRODUTO, @V_MNRLOTEESTQ, @V_MNRSUBLOTE, @V_MDTLANCAMEN,
                                                  @V_MIDTIPOLANC, @V_MCDFILLANC, @V_MNRLANCAMEN, @V_MNRSEQULANC, @V_MQTDEESTO,
                                                  @V_MCUSTMEDI, @V_MCUSTESTO, @V_MQTLANCAMEN, @V_MCUSTBRUT, @V_MCUSTMEES,
                                                  @V_MCUSTMEBR, @V_MIDALTCMEDMV, @V_MQTLANCTOEST, @V_MVRLANCTOEST, @V_MVRLANCTOBRUT,
                                                  @V_MIDORDEMCLC, @V_MNVPROD, @V_MNMPRODUTO, @V_MSGUNIDADE, @V_MVRUNILANCTO,
                                                  @V_MVRTOTLANCTO, @V_MVRTOTALANTE, @V_MQTTOTALANTE, @V_MCDALMOXARIFE, @V_MCDLOCALESTOQ,
                                                  @V_MVRCUSTENTRME, @V_MCDTIPORETIME, @V_MNMTIPORETIME, @V_MIDENTRSAIDME, @V_MCDTIPOOPERME,
                                                  @V_MVRCUSTLOGLME, @V_MVRCUSTSEGLME, @V_MCUSTLOGESTO, @V_MCUSTSEGESTO, @V_MVRPESOBRUTME;
         END;
         CLOSE C_POSESTDIA_GRUP;
         DEALLOCATE C_POSESTDIA_GRUP;
      END
   END
   ELSE BEGIN
      IF (LEN(@P_CDALMOXARIFE) = 0 ) BEGIN
         IF @V_CDGRUPPRMOVEST IS NULL  BEGIN
            DECLARE C_POSESTCONS CURSOR FOR
               SELECT A.CDFILIAL,
                      B.CDARVPROD AS CDPRODUTO,
                      ' ' AS NRLOTEESTQ,
                      ' ' AS NRSUBLOTE,
                      A.DTPOSESTCON AS DTLANCAMEN,
                      '-' AS IDTIPOLANC,
                      '----' AS CDFILLANC,
                      '----------' AS NRLANCAMEN,
                      '0001' AS NRSEQULANC,
                      A.QTESTDIACON AS QTDEESTO,
                      (CASE A.QTESTDIACON WHEN 0 THEN 0 ELSE (A.VRESTDIACON/A.QTESTDIACON) END) AS CUSTMEDI,
                      (CASE A.QTESTDIACON WHEN 0 THEN VRESTANTCON ELSE A.VRESTDIACON END) AS CUSTESTO,
                      A.QTESTDIACON AS QTLANCAMEN,
                      (CASE A.QTESTDIACON WHEN 0 THEN VRBRUTANTCON ELSE VRESTBRUTCON END) AS CUSTBRUT,
                      (CASE A.QTESTDIACON WHEN 0 THEN (CASE QTESTANTCON WHEN 0 THEN 0 ELSE (VRESTANTCON/QTESTANTCON) END) ELSE (A.VRESTDIACON/A.QTESTDIACON) END) AS CUSTMEES,
                      (CASE A.QTESTDIACON WHEN 0 THEN (CASE QTESTANTCON WHEN 0 THEN 0 ELSE (VRBRUTANTCON/QTESTANTCON)END) ELSE (VRESTBRUTCON/A.QTESTDIACON) END) AS CUSTMEBR,
                      ' ' AS IDALTCMEDMV,
                      0.0 AS QTLANCTOEST,
                      0.0 AS VRLANCTOEST,
                      0.0 AS VRLANCTOBRUT,
                      '-' AS IDORDEMCLC,
                      SUBSTRING(B.CDARVPROD,1, @P_TAMNIVEL) AS NVPROD,
                      B.NMPRODUTO,
                      B.SGUNIDADE,
                      SUBSTRING(@P_SEQUMOVI,1,10) AS NRRELATMOVI,
                      0.0 AS VRUNILANCTO,
                      0.0 AS VRTOTLANCTO,
                      0.0 AS VRTOTALANTE,
                      0.0 AS QTTOTALANTE,
                      ' ' AS CDALMOXARIFE,
                      ' ' AS CDLOCALESTOQ,
                      0.0 AS VRCUSTENTRME,
                      '--' AS CDTIPORETIME,
                      '------------------------------' AS NMTIPORETIME,
                      '-' AS IDENTRSAIDME,
                      '--' AS CDTIPOOPERME,
                      ISNULL(VRCLOGCON,0) AS VRCUSTLOGLME,
                      ISNULL(VRSEGUCON,0) AS VRCUSTSEGLME,
                      ISNULL(VRPESOBRUTPR,0) AS VRPESOBRUTME,
                      (CASE A.QTESTDIACON WHEN 0 THEN VRCLOGCONANT ELSE A.VRCLOGCON END) AS CUSTLOGESTO,
                      (CASE A.QTESTDIACON WHEN 0 THEN VRSEGUCONANT ELSE A.VRSEGUCON END) AS CUSTSEGESTO
                 FROM PRODUTO B, POSESTCONS A,
                      (SELECT CDFILIAL, CDPRODUTO, MAX(DTPOSESTCON) AS DTPOSESTCON
                         FROM POSESTCONS
                        WHERE CDFILIAL = @P_FILIAL
                          AND DTPOSESTCON <= @P_DTINICIAL
                        GROUP BY CDFILIAL, CDPRODUTO) C
                WHERE (A.CDFILIAL = @P_FILIAL)
                  AND (B.CDARVPROD >= @P_PRODINI)
                  AND (B.CDARVPROD <= @P_PRODFIM)
                  AND (B.CDPRODUTO = A.CDPRODUTO)    
                  AND (A.CDFILIAL = C.CDFILIAL)
                  AND (A.CDPRODUTO = C.CDPRODUTO)
                  AND (A.DTPOSESTCON = C.DTPOSESTCON);

            OPEN C_POSESTCONS;
            FETCH NEXT FROM C_POSESTCONS INTO @V_MCDFILIAL,    @V_MCDPRODUTO,    @V_MNRLOTEESTQ,   @V_MNRSUBLOTE,    @V_MDTLANCAMEN,
                                              @V_MIDTIPOLANC,  @V_MCDFILLANC,    @V_MNRLANCAMEN,   @V_MNRSEQULANC,   @V_MQTDEESTO,
                                              @V_MCUSTMEDI,    @V_MCUSTESTO,     @V_MQTLANCAMEN,   @V_MCUSTBRUT,     @V_MCUSTMEES,
                                              @V_MCUSTMEBR,    @V_MIDALTCMEDMV,  @V_MQTLANCTOEST,  @V_MVRLANCTOEST,  @V_MVRLANCTOBRUT,
                                              @V_MIDORDEMCLC,  @V_MNVPROD,       @V_MNMPRODUTO,    @V_MSGUNIDADE,    @V_MSEQUMOVI,
                                              @V_MVRUNILANCTO, @V_MVRTOTLANCTO,  @V_MVRTOTALANTE,  @V_MQTTOTALANTE,  @V_MCDALMOXARIFE,
                                              @V_MCDLOCALESTOQ,@V_MVRCUSTENTRME, @V_MCDTIPORETIME, @V_MNMTIPORETIME, @V_MIDENTRSAIDME,
                                              @V_MCDTIPOOPERME,@V_MVRCUSTLOGLME, @V_MVRCUSTSEGLME, @V_MCUSTLOGESTO,  @V_MCUSTSEGESTO,
                                              @V_MVRPESOBRUTME;

            WHILE (@@FETCH_STATUS = 0) BEGIN
               EXEC  TEKNISA.GRAVA_RELAT_MOVIEST @V_MCDFILIAL,    @V_MCDPRODUTO,    @V_MNRLOTEESTQ,   @V_MNRSUBLOTE,    @V_MDTLANCAMEN,
                                                 @V_MIDTIPOLANC,  @V_MCDFILLANC,    @V_MNRLANCAMEN,   @V_MNRSEQULANC,   @V_MQTDEESTO,
                                                 @V_MCUSTMEDI,    @V_MCUSTESTO,     @V_MQTLANCAMEN,   @V_MCUSTBRUT,     @V_MCUSTMEES,
                                                 @V_MCUSTMEBR,    @V_MIDALTCMEDMV,  @V_MQTLANCTOEST,  @V_MVRLANCTOEST,  @V_MVRLANCTOBRUT,
                                                 @V_MIDORDEMCLC,  @V_MNVPROD,       @V_MNMPRODUTO,    @V_MSGUNIDADE,    @P_SEQUMOVI,
                                                 @V_MVRUNILANCTO, @V_MVRTOTLANCTO,  @V_MVRTOTALANTE,  @V_MQTTOTALANTE,  @V_MCDALMOXARIFE,
                                                 @V_MCDLOCALESTOQ,@V_MVRCUSTENTRME, @V_MCDTIPORETIME, @V_MNMTIPORETIME, @V_MIDENTRSAIDME,
                                                 @V_MCDTIPOOPERME,@V_MVRCUSTLOGLME, @V_MVRCUSTSEGLME, @V_MCUSTLOGESTO,  @V_MCUSTSEGESTO,
                                                 @V_MVRPESOBRUTME;

               FETCH NEXT FROM C_POSESTCONS INTO @V_MCDFILIAL,    @V_MCDPRODUTO,    @V_MNRLOTEESTQ,   @V_MNRSUBLOTE,    @V_MDTLANCAMEN,
                                                 @V_MIDTIPOLANC,  @V_MCDFILLANC,    @V_MNRLANCAMEN,   @V_MNRSEQULANC,   @V_MQTDEESTO,
                                                 @V_MCUSTMEDI,    @V_MCUSTESTO,     @V_MQTLANCAMEN,   @V_MCUSTBRUT,     @V_MCUSTMEES,
                                                 @V_MCUSTMEBR,    @V_MIDALTCMEDMV,  @V_MQTLANCTOEST,  @V_MVRLANCTOEST,  @V_MVRLANCTOBRUT,
                                                 @V_MIDORDEMCLC,  @V_MNVPROD,       @V_MNMPRODUTO,    @V_MSGUNIDADE,    @V_MSEQUMOVI,
                                                 @V_MVRUNILANCTO, @V_MVRTOTLANCTO,  @V_MVRTOTALANTE,  @V_MQTTOTALANTE,  @V_MCDALMOXARIFE,
                                                 @V_MCDLOCALESTOQ,@V_MVRCUSTENTRME, @V_MCDTIPORETIME, @V_MNMTIPORETIME, @V_MIDENTRSAIDME,
                                                 @V_MCDTIPOOPERME,@V_MVRCUSTLOGLME, @V_MVRCUSTSEGLME, @V_MCUSTLOGESTO,  @V_MCUSTSEGESTO,
                                                 @V_MVRPESOBRUTME;

            END;
            CLOSE C_POSESTCONS;
            DEALLOCATE C_POSESTCONS;
         END
         ELSE BEGIN
            DECLARE C_POSESTCONS_GRUP CURSOR FOR
               SELECT A.CDFILIAL,
                      P.CDARVPROD AS CDPRODUTO,
                      ' ' AS NRLOTEESTQ,
                      ' ' AS NRSUBLOTE,
                      A.DTPOSESTCON AS DTLANCAMEN,
                      '-' AS IDTIPOLANC,
                      '----' AS CDFILLANC,
                      '----------' AS NRLANCAMEN,
                      '0001' AS NRSEQULANC,
                      A.QTESTDIACON AS QTDEESTO,
                      (CASE A.QTESTDIACON WHEN 0 THEN 0 ELSE (A.VRESTDIACON/A.QTESTDIACON) END) AS CUSTMEDI,
                      (CASE A.QTESTDIACON WHEN 0 THEN VRESTANTCON ELSE A.VRESTDIACON END) AS CUSTESTO,
                      A.QTESTDIACON AS QTLANCAMEN,
                      (CASE A.QTESTDIACON WHEN 0 THEN VRBRUTANTCON ELSE VRESTBRUTCON END) AS CUSTBRUT,
                      (CASE A.QTESTDIACON WHEN 0 THEN (CASE QTESTANTCON WHEN 0 THEN 0 ELSE (VRESTANTCON/QTESTANTCON) END) ELSE (A.VRESTDIACON/A.QTESTDIACON) END) AS CUSTMEES,
                      (CASE A.QTESTDIACON WHEN 0 THEN (CASE QTESTANTCON WHEN 0 THEN 0 ELSE (VRBRUTANTCON/QTESTANTCON)END) ELSE (VRESTBRUTCON/A.QTESTDIACON) END) AS CUSTMEBR,
                      ' ' AS IDALTCMEDMV,
                      0.0 AS QTLANCTOEST,
                      0.0 AS VRLANCTOEST,
                      0.0 AS VRLANCTOBRUT,
                      '-' AS IDORDEMCLC,
                      P.CDSUBGRPROD AS NVPROD,
                      P.NMPRODUTO,
                      P.SGUNIDADE,
                      SUBSTRING(@P_SEQUMOVI,1,10) AS NRRELATMOVI,
                      0.0 AS VRUNILANCTO,
                      0.0 AS VRTOTLANCTO,
                      0.0 AS VRTOTALANTE,
                      0.0 AS QTTOTALANTE,
                      ' ' AS CDALMOXARIFE,
                      ' ' AS CDLOCALESTOQ,
                      0.0 AS VRCUSTENTRME,
                      '--' AS CDTIPORETIME,
                      '------------------------------' AS NMTIPORETIME,
                      '-' AS IDENTRSAIDME,
                      '--' AS CDTIPOOPERME,
                      ISNULL(VRCLOGCON,0) AS VRCUSTLOGLME,
                      ISNULL(VRSEGUCON,0) AS VRCUSTSEGLME,
                      ISNULL(VRPESOBRUTPR,0) AS VRPESOBRUTME,
                      (CASE A.QTESTDIACON WHEN 0 THEN VRCLOGCONANT ELSE A.VRCLOGCON END) AS CUSTLOGESTO,
                      (CASE A.QTESTDIACON WHEN 0 THEN VRSEGUCONANT ELSE A.VRSEGUCON END) AS CUSTSEGESTO
                 FROM POSESTCONS A,
                      (SELECT X.CDPRODUTO, X.CDSUBGRPROD, B.VRPESOBRUTPR, B.CDARVPROD, 
                              B.NMPRODUTO, B.SGUNIDADE
                         FROM PRODUTO B, PRSUBGRPROD X
                        WHERE B.CDPRODUTO = X.CDPRODUTO
                          AND X.CDGRUPPROD = @V_CDGRUPPRMOVEST
                          AND X.CDFILISUBGR = @V_CDFILISUBGR
                          AND B.CDARVPROD BETWEEN @P_PRODINI AND @P_PRODFIM) P,
                      (SELECT CDFILIAL, CDPRODUTO, MAX(DTPOSESTCON) AS DTPOSESTCON
                         FROM POSESTCONS
                        WHERE CDFILIAL = @P_FILIAL
                          AND DTPOSESTCON <= @P_DTINICIAL
                        GROUP BY CDFILIAL, CDPRODUTO) C
                WHERE (A.CDFILIAL = @P_FILIAL)
                  AND (P.CDPRODUTO = A.CDPRODUTO)
                  AND (A.CDFILIAL = C.CDFILIAL)
                  AND (A.CDPRODUTO = C.CDPRODUTO)
                  AND (A.DTPOSESTCON = C.DTPOSESTCON);
            OPEN C_POSESTCONS_GRUP;
            FETCH NEXT FROM C_POSESTCONS_GRUP INTO @V_MCDFILIAL, @V_MCDPRODUTO, @V_MNRLOTEESTQ, @V_MNRSUBLOTE, @V_MDTLANCAMEN,
                                                   @V_MIDTIPOLANC, @V_MCDFILLANC, @V_MNRLANCAMEN, @V_MNRSEQULANC, @V_MQTDEESTO,
                                                   @V_MCUSTMEDI, @V_MCUSTESTO, @V_MQTLANCAMEN, @V_MCUSTBRUT, @V_MCUSTMEES,
                                                   @V_MCUSTMEBR, @V_MIDALTCMEDMV, @V_MQTLANCTOEST, @V_MVRLANCTOEST, @V_MVRLANCTOBRUT,
                                                   @V_MIDORDEMCLC, @V_MNVPROD, @V_MNMPRODUTO, @V_MSGUNIDADE, @V_MSEQUMOVI, @V_MVRUNILANCTO,
                                                   @V_MVRTOTLANCTO, @V_MVRTOTALANTE, @V_MQTTOTALANTE, @V_MCDALMOXARIFE, @V_MCDLOCALESTOQ,
                                                   @V_MVRCUSTENTRME, @V_MCDTIPORETIME, @V_MNMTIPORETIME, @V_MIDENTRSAIDME, @V_MCDTIPOOPERME,
                                                   @V_MVRCUSTLOGLME, @V_MVRCUSTSEGLME, @V_MCUSTLOGESTO, @V_MCUSTSEGESTO, @V_MVRPESOBRUTME;

            WHILE (@@FETCH_STATUS = 0) BEGIN
               EXEC  TEKNISA.GRAVA_RELAT_MOVIEST @V_MCDFILIAL, @V_MCDPRODUTO, @V_MNRLOTEESTQ, @V_MNRSUBLOTE, @V_MDTLANCAMEN,
                                                 @V_MIDTIPOLANC, @V_MCDFILLANC, @V_MNRLANCAMEN, @V_MNRSEQULANC, @V_MQTDEESTO,
                                                 @V_MCUSTMEDI, @V_MCUSTESTO, @V_MQTLANCAMEN, @V_MCUSTBRUT, @V_MCUSTMEES,
                                                 @V_MCUSTMEBR, @V_MIDALTCMEDMV, @V_MQTLANCTOEST, @V_MVRLANCTOEST, @V_MVRLANCTOBRUT,
                                                 @V_MIDORDEMCLC, @V_MNVPROD, @V_MNMPRODUTO, @V_MSGUNIDADE, @P_SEQUMOVI, @V_MVRUNILANCTO,
                                                 @V_MVRTOTLANCTO, @V_MVRTOTALANTE, @V_MQTTOTALANTE, @V_MCDALMOXARIFE, @V_MCDLOCALESTOQ,
                                                 @V_MVRCUSTENTRME, @V_MCDTIPORETIME, @V_MNMTIPORETIME, @V_MIDENTRSAIDME, @V_MCDTIPOOPERME,
                                                 @V_MVRCUSTLOGLME, @V_MVRCUSTSEGLME, @V_MCUSTLOGESTO, @V_MCUSTSEGESTO, @V_MVRPESOBRUTME;

               FETCH NEXT FROM C_POSESTCONS_GRUP INTO @V_MCDFILIAL, @V_MCDPRODUTO, @V_MNRLOTEESTQ, @V_MNRSUBLOTE, @V_MDTLANCAMEN,
                                                      @V_MIDTIPOLANC, @V_MCDFILLANC, @V_MNRLANCAMEN, @V_MNRSEQULANC, @V_MQTDEESTO,
                                                      @V_MCUSTMEDI, @V_MCUSTESTO, @V_MQTLANCAMEN, @V_MCUSTBRUT, @V_MCUSTMEES,
                                                      @V_MCUSTMEBR, @V_MIDALTCMEDMV, @V_MQTLANCTOEST, @V_MVRLANCTOEST, @V_MVRLANCTOBRUT,
                                                      @V_MIDORDEMCLC, @V_MNVPROD, @V_MNMPRODUTO, @V_MSGUNIDADE, @V_MSEQUMOVI, @V_MVRUNILANCTO,
                                                      @V_MVRTOTLANCTO, @V_MVRTOTALANTE, @V_MQTTOTALANTE, @V_MCDALMOXARIFE, @V_MCDLOCALESTOQ,
                                                      @V_MVRCUSTENTRME, @V_MCDTIPORETIME, @V_MNMTIPORETIME, @V_MIDENTRSAIDME, @V_MCDTIPOOPERME,
                                                      @V_MVRCUSTLOGLME, @V_MVRCUSTSEGLME, @V_MCUSTLOGESTO,  @V_MCUSTSEGESTO, @V_MVRPESOBRUTME;
            END;
            CLOSE C_POSESTCONS_GRUP;
            DEALLOCATE C_POSESTCONS_GRUP;
         END
      END
      ELSE BEGIN
         IF @V_CDGRUPPRMOVEST IS NULL  BEGIN
            DECLARE C_POSESTALMOX CURSOR FOR
               SELECT A.CDFILIAL,
                      B.CDARVPROD AS CDPRODUTO,
                      (CASE ISNULL(@P_MOVCONSOLID,'N') WHEN 'S' THEN ' ' ELSE ISNULL(@P_NRLOTEESTQ, A.NRLOTEESTQ) END)  AS NRLOTEESTQ,
                      (CASE ISNULL(@P_MOVCONSOLID,'N') WHEN 'S' THEN ' ' ELSE A.NRSUBLOTE END) AS NRSUBLOTE,
                      (CASE ISNULL(@P_MOVCONSOLID,'N') WHEN 'S' THEN @P_DTINICIAL ELSE A.DTPOSIESTQ END) AS DTLANCAMEN,
                      '-' AS IDTIPOLANC,
                      '----' AS CDFILLANC,
                      '----------' AS NRLANCAMEN,
                      '0001' AS NRSEQULANC,
                      SUM(A.QTESTOQDIA) AS QTDEESTO,
                      (CASE SUM(A.QTESTOQDIA) WHEN 0 THEN 0 ELSE (SUM(A.VRESTOQDIA)/SUM(A.QTESTOQDIA)) END) AS CUSTMEDI,
                      (CASE SUM(A.QTESTOQDIA) WHEN 0 THEN SUM(VRESTOQANT) ELSE SUM(A.VRESTOQDIA) END) AS CUSTESTO,
                      SUM(A.QTESTOQDIA) AS QTLANCAMEN,
                      (CASE SUM(A.QTESTOQDIA) WHEN 0 THEN SUM(VRBRUTOANT) ELSE SUM(A.VRESTOQBRUT) END) AS CUSTBRUT,
                      (CASE SUM(A.QTESTOQDIA) WHEN 0 THEN (CASE SUM(QTESTOQANT) WHEN 0 THEN 0 ELSE (SUM(VRESTOQANT)/SUM(QTESTOQANT)) END) ELSE (SUM(A.VRESTOQDIA)/SUM(A.QTESTOQDIA)) END) AS CUSTMEES,
                      (CASE SUM(A.QTESTOQDIA) WHEN 0 THEN (CASE SUM(QTESTOQANT) WHEN 0 THEN 0 ELSE (SUM(VRBRUTOANT)/SUM(QTESTOQANT)) END) ELSE (SUM(A.VRESTOQBRUT)/SUM(A.QTESTOQDIA)) END) AS CUSTMEBR,
                      ' ' AS IDALTCMEDMV,
                      0.0 AS QTLANCTOEST,
                      0.0 AS VRLANCTOEST,
                      0.0 AS VRLANCTOBRUT,
                      '-' AS IDORDEMCLC,
                      SUBSTRING(B.CDARVPROD,1, @P_TAMNIVEL) AS NVPROD,
                      B.NMPRODUTO,
                      B.SGUNIDADE,
                      SUBSTRING(@P_SEQUMOVI,1,10) AS NRRELATMOVI,
                      0.0 AS VRUNILANCTO,
                      0.0 AS VRTOTLANCTO,
                      0.0 AS VRTOTALANTE,
                      0.0 AS QTTOTALANTE,
                      (CASE ISNULL(@P_MOVCONSOLID,'N') WHEN 'S' THEN ' ' ELSE A.CDALMOXARIFE END) AS CDALMOXARIFE,
                      (CASE ISNULL(@P_MOVCONSOLID,'N') WHEN 'S' THEN ' ' ELSE A.CDLOCALESTOQ END) AS CDLOCALESTOQ,
                      0.0 AS VRCUSTENTRME,
                      '--' AS CDTIPORETIME,
                      '------------------------------' AS NMTIPORETIME,
                      '-' AS IDENTRSAIDME,
                      '--' AS CDTIPOOPERME,
                      0 AS VRCUSTLOGLME,
                      0 AS VRCUSTSEGLME,
                      MAX(ISNULL(VRPESOBRUTPR,0)) AS VRPESOBRUTME,
                      SUM(ISNULL(A.VRCLOGDIA,0)) AS CUSTLOGESTO,
                      SUM(ISNULL(A.VRSEGUDIA,0)) AS CUSTSEGESTO
                 FROM PRODUTO B, POSESTDIA A,
                      (SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, CDPRODUTO,
                              NRLOTEESTQ, NRSUBLOTE, MAX(DTPOSIESTQ) AS DTPOSIESTQ
                         FROM POSESTDIA
                        WHERE CDFILIAL = @P_FILIAL
                          AND ((CDALMOXARIFE = @P_CDALMOXARIFE) OR (@P_CDALMOXARIFE IS NULL)) 
                          AND ((CDLOCALESTOQ = @P_CDLOCALESTOQ) OR (@P_CDLOCALESTOQ IS NULL)) 
                          AND ((NRLOTEESTQ = @P_NRLOTEESTQ) OR (@P_NRLOTEESTQ IS NULL))
                          AND DTPOSIESTQ <= @P_DTINICIAL
                        GROUP BY CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, CDPRODUTO,
                                 NRLOTEESTQ, NRSUBLOTE) C
                WHERE (A.CDFILIAL = @P_FILIAL)
                  AND ((A.CDALMOXARIFE = @P_CDALMOXARIFE) OR (@P_CDALMOXARIFE IS NULL)) 
                  AND ((A.CDLOCALESTOQ = @P_CDLOCALESTOQ) OR (@P_CDLOCALESTOQ IS NULL)) 
                  AND ((A.NRLOTEESTQ = @P_NRLOTEESTQ) OR (@P_NRLOTEESTQ IS NULL))
                  AND (B.CDARVPROD >= @P_PRODINI)
                  AND (B.CDARVPROD <= @P_PRODFIM)
                  AND (B.CDPRODUTO = A.CDPRODUTO)
                  AND (A.CDFILIAL = C.CDFILIAL)
                  AND (A.CDALMOXARIFE = C.CDALMOXARIFE) 
                  AND (A.CDLOCALESTOQ = C.CDLOCALESTOQ) 
                  AND (A.CDPRODUTO = C.CDPRODUTO)
                  AND (A.NRLOTEESTQ = C.NRLOTEESTQ)
                  AND (A.NRSUBLOTE = C.NRSUBLOTE)
                  AND (A.DTPOSIESTQ = C.DTPOSIESTQ)
                GROUP BY A.CDFILIAL, B.CDARVPROD,
                         (CASE ISNULL(@P_MOVCONSOLID,'N') WHEN  'S' THEN ' ' ELSE( ISNULL(@P_NRLOTEESTQ, A.NRLOTEESTQ)) END),
                         (CASE ISNULL(@P_MOVCONSOLID,'N') WHEN  'S' THEN ' ' ELSE  A.NRSUBLOTE END),
                         (CASE ISNULL(@P_MOVCONSOLID,'N') WHEN  'S' THEN ' ' ELSE  A.CDALMOXARIFE END),
                         (CASE ISNULL(@P_MOVCONSOLID,'N') WHEN  'S' THEN ' ' ELSE A.CDLOCALESTOQ END),
                         (CASE ISNULL(@P_MOVCONSOLID,'N') WHEN  'S' THEN @P_DTINICIAL ELSE A.DTPOSIESTQ END),
                         SUBSTRING(B.CDARVPROD,1, 1), B.NMPRODUTO, B.SGUNIDADE;
            OPEN C_POSESTALMOX ;
            FETCH NEXT FROM C_POSESTALMOX  INTO @V_MCDFILIAL,    @V_MCDPRODUTO,    @V_MNRLOTEESTQ,   @V_MNRSUBLOTE,    @V_MDTLANCAMEN,
                                                @V_MIDTIPOLANC,  @V_MCDFILLANC,    @V_MNRLANCAMEN,   @V_MNRSEQULANC,   @V_MQTDEESTO,
                                                @V_MCUSTMEDI,    @V_MCUSTESTO,     @V_MQTLANCAMEN,   @V_MCUSTBRUT,     @V_MCUSTMEES,
                                                @V_MCUSTMEBR,    @V_MIDALTCMEDMV,  @V_MQTLANCTOEST,  @V_MVRLANCTOEST,  @V_MVRLANCTOBRUT,
                                                @V_MIDORDEMCLC,  @V_MNVPROD,       @V_MNMPRODUTO,    @V_MSGUNIDADE,    @V_MSEQUMOVI,
                                                @V_MVRUNILANCTO, @V_MVRTOTLANCTO,  @V_MVRTOTALANTE,  @V_MQTTOTALANTE,  @V_MCDALMOXARIFE,
                                                @V_MCDLOCALESTOQ,@V_MVRCUSTENTRME, @V_MCDTIPORETIME, @V_MNMTIPORETIME, @V_MIDENTRSAIDME,
                                                @V_MCDTIPOOPERME,@V_MVRCUSTLOGLME, @V_MVRCUSTSEGLME, @V_MCUSTLOGESTO,  @V_MCUSTSEGESTO,
                                                @V_MVRPESOBRUTME;
            WHILE (@@FETCH_STATUS = 0) BEGIN
               EXEC TEKNISA.GRAVA_RELAT_MOVIEST @V_MCDFILIAL, @V_MCDPRODUTO,    @V_MNRLOTEESTQ,   @V_MNRSUBLOTE,    @V_MDTLANCAMEN,
                                                @V_MIDTIPOLANC,  @V_MCDFILLANC,    @V_MNRLANCAMEN,   @V_MNRSEQULANC,   @V_MQTDEESTO,
                                                @V_MCUSTMEDI,    @V_MCUSTESTO,     @V_MQTLANCAMEN,   @V_MCUSTBRUT,     @V_MCUSTMEES,
                                                @V_MCUSTMEBR,    @V_MIDALTCMEDMV,  @V_MQTLANCTOEST,  @V_MVRLANCTOEST,  @V_MVRLANCTOBRUT,
                                                @V_MIDORDEMCLC,  @V_MNVPROD,       @V_MNMPRODUTO,    @V_MSGUNIDADE,    @P_SEQUMOVI,
                                                @V_MVRUNILANCTO, @V_MVRTOTLANCTO,  @V_MVRTOTALANTE,  @V_MQTTOTALANTE,  @V_MCDALMOXARIFE,
                                                @V_MCDLOCALESTOQ,@V_MVRCUSTENTRME, @V_MCDTIPORETIME, @V_MNMTIPORETIME, @V_MIDENTRSAIDME,
                                                @V_MCDTIPOOPERME,@V_MVRCUSTLOGLME, @V_MVRCUSTSEGLME, @V_MCUSTLOGESTO,  @V_MCUSTSEGESTO,
                                                @V_MVRPESOBRUTME;

               FETCH NEXT FROM C_POSESTALMOX  INTO @V_MCDFILIAL,    @V_MCDPRODUTO,    @V_MNRLOTEESTQ,   @V_MNRSUBLOTE,    @V_MDTLANCAMEN,
                                                   @V_MIDTIPOLANC,  @V_MCDFILLANC,    @V_MNRLANCAMEN,   @V_MNRSEQULANC,   @V_MQTDEESTO,
                                                   @V_MCUSTMEDI,    @V_MCUSTESTO,     @V_MQTLANCAMEN,   @V_MCUSTBRUT,     @V_MCUSTMEES,
                                                   @V_MCUSTMEBR,    @V_MIDALTCMEDMV,  @V_MQTLANCTOEST,  @V_MVRLANCTOEST,  @V_MVRLANCTOBRUT,
                                                   @V_MIDORDEMCLC,  @V_MNVPROD,       @V_MNMPRODUTO,    @V_MSGUNIDADE,    @V_MSEQUMOVI,
                                                   @V_MVRUNILANCTO, @V_MVRTOTLANCTO,  @V_MVRTOTALANTE,  @V_MQTTOTALANTE,  @V_MCDALMOXARIFE,
                                                   @V_MCDLOCALESTOQ,@V_MVRCUSTENTRME, @V_MCDTIPORETIME, @V_MNMTIPORETIME, @V_MIDENTRSAIDME,
                                                   @V_MCDTIPOOPERME,@V_MVRCUSTLOGLME, @V_MVRCUSTSEGLME, @V_MCUSTLOGESTO,  @V_MCUSTSEGESTO,
                                                   @V_MVRPESOBRUTME;

            END;
            CLOSE C_POSESTALMOX;
            DEALLOCATE C_POSESTALMOX;
         END
         ELSE BEGIN
            DECLARE C_POSESTALMOX_GRUP CURSOR FOR
               SELECT A.CDFILIAL,
                      P.CDARVPROD AS CDPRODUTO,
                      (CASE ISNULL(@P_MOVCONSOLID,'N') WHEN 'S' THEN ' ' ELSE  ISNULL(@P_NRLOTEESTQ, A.NRLOTEESTQ) END) AS NRLOTEESTQ,
                      (CASE ISNULL(@P_MOVCONSOLID,'N') WHEN 'S' THEN ' ' ELSE  A.NRSUBLOTE END) AS NRSUBLOTE,
                      (CASE ISNULL(@P_MOVCONSOLID,'N') WHEN 'S' THEN @P_DTINICIAL ELSE A.DTPOSIESTQ END) AS DTLANCAMEN,
                      '-' AS IDTIPOLANC,
                      '----' AS CDFILLANC,
                      '----------' AS NRLANCAMEN,
                      '0001' AS NRSEQULANC,
                      SUM(A.QTESTOQDIA) AS QTDEESTO,
                      (CASE SUM(A.QTESTOQDIA) WHEN 0 THEN 0 ELSE (SUM(A.VRESTOQDIA)/SUM(A.QTESTOQDIA)) END) AS CUSTMEDI,
                      (CASE SUM(A.QTESTOQDIA) WHEN 0 THEN SUM(VRESTOQANT) ELSE SUM(A.VRESTOQDIA) END) AS CUSTESTO,
                      SUM(A.QTESTOQDIA) AS QTLANCAMEN,
                      (CASE SUM(A.QTESTOQDIA) WHEN 0 THEN SUM(VRBRUTOANT) ELSE SUM(A.VRESTOQBRUT) END) AS CUSTBRUT,
                      (CASE SUM(A.QTESTOQDIA) WHEN 0 THEN (CASE SUM(QTESTOQANT) WHEN 0 THEN 0 ELSE (SUM(VRESTOQANT)/SUM(QTESTOQANT)) END) ELSE (SUM(A.VRESTOQDIA)/SUM(A.QTESTOQDIA)) END) AS CUSTMEES,
                      (CASE SUM(A.QTESTOQDIA) WHEN 0 THEN (CASE SUM(QTESTOQANT) WHEN 0 THEN 0 ELSE (SUM(VRBRUTOANT)/SUM(QTESTOQANT)) END) ELSE (SUM(A.VRESTOQBRUT)/SUM(A.QTESTOQDIA)) END) AS CUSTMEBR,
                      ' ' AS IDALTCMEDMV,
                      0.0 AS QTLANCTOEST,
                      0.0 AS VRLANCTOEST,
                      0.0 AS VRLANCTOBRUT,
                      '-' AS IDORDEMCLC,
                      P.CDSUBGRPROD AS NVPROD,
                      P.NMPRODUTO,
                      P.SGUNIDADE,
                      SUBSTRING(@P_SEQUMOVI,1,10) AS NRRELATMOVI,
                      0.0 AS VRUNILANCTO,
                      0.0 AS VRTOTLANCTO,
                      0.0 AS VRTOTALANTE,
                      0.0 AS QTTOTALANTE,
                      (CASE ISNULL(@P_MOVCONSOLID,'N') WHEN 'S' THEN ' ' ELSE A.CDALMOXARIFE END) AS CDALMOXARIFE,
                      (CASE ISNULL(@P_MOVCONSOLID,'N') WHEN 'S' THEN ' ' ELSE A.CDLOCALESTOQ END) AS CDLOCALESTOQ,
                      0.0 AS VRCUSTENTRME,
                      '--' AS CDTIPORETIME,
                      '------------------------------' AS NMTIPORETIME,
                      '-' AS IDENTRSAIDME,
                      '--' AS CDTIPOOPERME,
                      0 AS VRCUSTLOGLME,
                      0 AS VRCUSTSEGLME,
                      MAX(ISNULL(VRPESOBRUTPR,0)) AS VRPESOBRUTME,
                      SUM(ISNULL(A.VRCLOGDIA,0)) AS CUSTLOGESTO,
                      SUM(ISNULL(A.VRSEGUDIA,0)) AS CUSTSEGESTO
                 FROM POSESTDIA A,
                      (SELECT X.CDPRODUTO, X.CDSUBGRPROD, B.VRPESOBRUTPR, B.CDARVPROD, B.NMPRODUTO, B.SGUNIDADE
                         FROM PRODUTO B, PRSUBGRPROD X
                        WHERE B.CDPRODUTO = X.CDPRODUTO
                          AND X.CDGRUPPROD = @V_CDGRUPPRMOVEST
                          AND X.CDFILISUBGR = @V_CDFILISUBGR
                          AND B.CDARVPROD BETWEEN @P_PRODINI AND @P_PRODFIM) P,
                      (SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, CDPRODUTO,
                              NRLOTEESTQ, NRSUBLOTE, MAX(DTPOSIESTQ) AS DTPOSIESTQ
                         FROM POSESTDIA
                        WHERE CDFILIAL = @P_FILIAL
                          AND ((CDALMOXARIFE = @P_CDALMOXARIFE) OR (@P_CDALMOXARIFE IS NULL))
                          AND ((CDLOCALESTOQ = @P_CDLOCALESTOQ) OR (@P_CDLOCALESTOQ IS NULL))
                          AND ((NRLOTEESTQ = @P_NRLOTEESTQ) OR (@P_NRLOTEESTQ IS NULL))
                          AND DTPOSIESTQ <= @P_DTINICIAL
                        GROUP BY CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, CDPRODUTO, NRLOTEESTQ, NRSUBLOTE) C
               WHERE (A.CDFILIAL = @P_FILIAL)
                 AND ((A.CDALMOXARIFE = @P_CDALMOXARIFE) OR (@P_CDALMOXARIFE IS NULL))
                 AND ((A.CDLOCALESTOQ = @P_CDLOCALESTOQ) OR (@P_CDLOCALESTOQ IS NULL))
                 AND ((A.NRLOTEESTQ = @P_NRLOTEESTQ) OR (@P_NRLOTEESTQ IS NULL))
                 AND (P.CDPRODUTO = A.CDPRODUTO)
                 AND (A.CDFILIAL = C.CDFILIAL)
                 AND (A.CDALMOXARIFE = C.CDALMOXARIFE) 
                 AND (A.CDLOCALESTOQ = C.CDLOCALESTOQ) 
                 AND (A.CDPRODUTO = C.CDPRODUTO)
                 AND (A.NRLOTEESTQ = C.NRLOTEESTQ)
                 AND (A.NRSUBLOTE = C.NRSUBLOTE)
                 AND (A.DTPOSIESTQ = C.DTPOSIESTQ)
               GROUP BY A.CDFILIAL, P.CDARVPROD, P.CDSUBGRPROD,
                        (CASE ISNULL(@P_MOVCONSOLID,'N') WHEN  'S' THEN ' ' ELSE(ISNULL(@P_NRLOTEESTQ, A.NRLOTEESTQ)) END),
                        (CASE ISNULL(@P_MOVCONSOLID,'N') WHEN  'S' THEN ' ' ELSE  A.NRSUBLOTE END),
                        (CASE ISNULL(@P_MOVCONSOLID,'N') WHEN  'S' THEN ' ' ELSE  A.CDALMOXARIFE END),
                        (CASE ISNULL(@P_MOVCONSOLID,'N') WHEN  'S' THEN ' ' ELSE A.CDLOCALESTOQ END),
                        (CASE ISNULL(@P_MOVCONSOLID,'N') WHEN  'S' THEN @P_DTINICIAL ELSE A.DTPOSIESTQ END),
                        SUBSTRING(P.CDARVPROD,1, 1), P.NMPRODUTO, P.SGUNIDADE;

            OPEN C_POSESTALMOX_GRUP;
            FETCH NEXT FROM C_POSESTALMOX_GRUP INTO @V_MCDFILIAL,    @V_MCDPRODUTO,    @V_MNRLOTEESTQ,   @V_MNRSUBLOTE,    @V_MDTLANCAMEN,
                                                @V_MIDTIPOLANC,  @V_MCDFILLANC,    @V_MNRLANCAMEN,   @V_MNRSEQULANC,   @V_MQTDEESTO,
                                                @V_MCUSTMEDI,    @V_MCUSTESTO,     @V_MQTLANCAMEN,   @V_MCUSTBRUT,     @V_MCUSTMEES,
                                                @V_MCUSTMEBR,    @V_MIDALTCMEDMV,  @V_MQTLANCTOEST,  @V_MVRLANCTOEST,  @V_MVRLANCTOBRUT,
                                                @V_MIDORDEMCLC,  @V_MNVPROD,       @V_MNMPRODUTO,    @V_MSGUNIDADE,    @V_MSEQUMOVI,
                                                @V_MVRUNILANCTO, @V_MVRTOTLANCTO,  @V_MVRTOTALANTE,  @V_MQTTOTALANTE,  @V_MCDALMOXARIFE,
                                                @V_MCDLOCALESTOQ,@V_MVRCUSTENTRME, @V_MCDTIPORETIME, @V_MNMTIPORETIME, @V_MIDENTRSAIDME,
                                                @V_MCDTIPOOPERME,@V_MVRCUSTLOGLME, @V_MVRCUSTSEGLME, @V_MCUSTLOGESTO,  @V_MCUSTSEGESTO,
                                                @V_MVRPESOBRUTME;
            WHILE (@@FETCH_STATUS = 0) BEGIN
               EXEC TEKNISA.GRAVA_RELAT_MOVIEST @V_MCDFILIAL, @V_MCDPRODUTO,    @V_MNRLOTEESTQ,   @V_MNRSUBLOTE,    @V_MDTLANCAMEN,
                                                @V_MIDTIPOLANC,  @V_MCDFILLANC,    @V_MNRLANCAMEN,   @V_MNRSEQULANC,   @V_MQTDEESTO,
                                                @V_MCUSTMEDI,    @V_MCUSTESTO,     @V_MQTLANCAMEN,   @V_MCUSTBRUT,     @V_MCUSTMEES,
                                                @V_MCUSTMEBR,    @V_MIDALTCMEDMV,  @V_MQTLANCTOEST,  @V_MVRLANCTOEST,  @V_MVRLANCTOBRUT,
                                                @V_MIDORDEMCLC,  @V_MNVPROD,       @V_MNMPRODUTO,    @V_MSGUNIDADE,    @P_SEQUMOVI,
                                                @V_MVRUNILANCTO, @V_MVRTOTLANCTO,  @V_MVRTOTALANTE,  @V_MQTTOTALANTE,  @V_MCDALMOXARIFE,
                                                @V_MCDLOCALESTOQ,@V_MVRCUSTENTRME, @V_MCDTIPORETIME, @V_MNMTIPORETIME, @V_MIDENTRSAIDME,
                                                @V_MCDTIPOOPERME,@V_MVRCUSTLOGLME, @V_MVRCUSTSEGLME, @V_MCUSTLOGESTO,  @V_MCUSTSEGESTO,
                                                @V_MVRPESOBRUTME;

               FETCH NEXT FROM C_POSESTALMOX_GRUP  INTO @V_MCDFILIAL,    @V_MCDPRODUTO,    @V_MNRLOTEESTQ,   @V_MNRSUBLOTE,    @V_MDTLANCAMEN,
                                                   @V_MIDTIPOLANC,  @V_MCDFILLANC,    @V_MNRLANCAMEN,   @V_MNRSEQULANC,   @V_MQTDEESTO,
                                                   @V_MCUSTMEDI,    @V_MCUSTESTO,     @V_MQTLANCAMEN,   @V_MCUSTBRUT,     @V_MCUSTMEES,
                                                   @V_MCUSTMEBR,    @V_MIDALTCMEDMV,  @V_MQTLANCTOEST,  @V_MVRLANCTOEST,  @V_MVRLANCTOBRUT,
                                                   @V_MIDORDEMCLC,  @V_MNVPROD,       @V_MNMPRODUTO,    @V_MSGUNIDADE,    @V_MSEQUMOVI,
                                                   @V_MVRUNILANCTO, @V_MVRTOTLANCTO,  @V_MVRTOTALANTE,  @V_MQTTOTALANTE,  @V_MCDALMOXARIFE,
                                                   @V_MCDLOCALESTOQ,@V_MVRCUSTENTRME, @V_MCDTIPORETIME, @V_MNMTIPORETIME, @V_MIDENTRSAIDME,
                                                   @V_MCDTIPOOPERME,@V_MVRCUSTLOGLME, @V_MVRCUSTSEGLME, @V_MCUSTLOGESTO,  @V_MCUSTSEGESTO,
                                                   @V_MVRPESOBRUTME;

            END;
            CLOSE C_POSESTALMOX_GRUP;
            DEALLOCATE C_POSESTALMOX_GRUP;
         END
      END;
   END;

   IF NOT @V_CDGRUPPRMOVEST IS NULL  BEGIN
      DECLARE C_ITLANCTOEST_GRUP CURSOR FOR
         SELECT D.CDFILIMOVI AS CDFILIAL,
                E.CDARVPROD AS CDPRODUTO,
                (CASE LEN(D.NRLOTEESTQ) WHEN 0 THEN ' ' ELSE D.NRLOTEESTQ END) AS NRLOTEESTQ,
                (CASE LEN(D.NRSUBLOTE) WHEN 0 THEN ' ' ELSE D.NRSUBLOTE END) AS NRSUBLOTE,
                D.DTLANCMOVI AS DTLANCAMEN,
                D.IDTIPOMOVI AS IDTIPOLANC,
                D.CDFILIAL AS CDFILLANC,
                D.NRLANCESTQ AS NRLANCAMEN,
                D.NRSEQUITEM AS NRSEQULANC,
                0.0 AS QTDEESTO,
                0.0 AS CUSTMEDI,
                0.0 AS CUSTESTO,
                0.0 AS QTLANCAMEN,
                0.0 AS CUSTBRUT,
                0.0 AS CUSTMEES,
                0.0 AS CUSTMEBR,
                D.IDALTCMEDMV,
                D.QTLANCTOEST,
                ISNULL(D.VRLANCTOEST ,0) AS VRLANCTOEST,
                ISNULL(D.VRLANCTOBRUT,0) AS VRLANCTOBRUT,
                D.IDORDEMCLC,
                P.CDSUBGRPROD AS NVPROD,
                E.NMPRODUTO,
                E.SGUNIDADE,
                SUBSTRING(@P_SEQUMOVI,1,10) AS NRRELATMOVI,
                ISNULL(D.VRUNILANCTO,0) AS VRUNILANCTO,
                ISNULL(D.VRTOTLANCTO,0) AS VRTOTLANCTO,
                0.0 AS VRTOTALANTE,
                0.0 AS QTTOTALANTE,
                D.CDALMOXARIFE,
                D.CDLOCALESTOQ,
                (D.VRLANCTOEST * D.QTLANCTOEST) AS VRCUSTENTRME,
                ISNULL(D.CDTIPORETI,'--') AS CDTIPORETIME,
                ISNULL(T.NMTIPORETI,'-') AS NMTIPORETIME,
                ISNULL(D.IDENTRSAIDOP,'-') AS IDENTRSAIDME,
                ISNULL(L.CDTIPOOPER,'--') AS CDTIPOOPERME,
                ISNULL(VRCUSTLOGLAN,0) AS VRCUSTLOGLME,
                ISNULL(VRSEGULOGLAN,0) AS VRCUSTSEGLME,
                ISNULL(VRPESOBRUTPR,0) AS VRPESOBRUTME,
                0.0 AS CUSTLOGESTO,
                0.0 AS CUSTSEGESTO
           FROM PRODUTO E, PRSUBGRPROD P, ITLANCTOEST D LEFT JOIN PRODFILI C  ON 
                                                            (D.CDFILIMOVI = C.CDFILIAL)  
                                                        AND (D.CDPRODMOVI = C.CDPRODUTO)
                                                        LEFT JOIN TIPORETI T ON
                                                            (D.CDTIPORETI = T.CDTIPORETI),
                LANCTOESTOQ L
          WHERE (D.CDFILIMOVI = @P_FILIAL)
            AND ((D.CDALMOXARIFE = @P_CDALMOXARIFE) OR (@P_CDALMOXARIFE IS NULL))
            AND ((D.CDLOCALESTOQ = @P_CDLOCALESTOQ) OR (@P_CDLOCALESTOQ IS NULL))
            AND ((D.NRLOTEESTQ = @P_NRLOTEESTQ) OR (@P_NRLOTEESTQ IS NULL))
            AND (E.CDPRODUTO = D.CDPRODMOVI)
            AND (E.CDARVPROD BETWEEN @P_PRODINI AND @P_PRODFIM)
            AND (ISNULL(IDEVOLESTOQ,'S') = 'S')
            AND (ISNULL(C.IDCNTRESTOQ,'S') = 'S')
            AND (P.CDGRUPPROD = @V_CDGRUPPRMOVEST)
            AND (P.CDPRODUTO = E.CDPRODUTO)
            AND (P.CDFILISUBGR  = @V_CDFILISUBGR)
            AND (D.DTLANCMOVI BETWEEN @P_DTINICIAL AND @P_DTFINAL)
            AND (D.IDTIPOMOVI <> '0')
            AND (D.CDFILIAL = L.CDFILIAL)
            AND (D.NRLANCESTQ = L.NRLANCESTQ);
      OPEN C_ITLANCTOEST_GRUP;
      FETCH NEXT FROM C_ITLANCTOEST_GRUP INTO @V_MCDFILIAL,    @V_MCDPRODUTO,    @V_MNRLOTEESTQ,   @V_MNRSUBLOTE,    @V_MDTLANCAMEN,
                                         @V_MIDTIPOLANC,  @V_MCDFILLANC,    @V_MNRLANCAMEN,   @V_MNRSEQULANC,   @V_MQTDEESTO,
                                         @V_MCUSTMEDI,    @V_MCUSTESTO,     @V_MQTLANCAMEN,   @V_MCUSTBRUT,     @V_MCUSTMEES,
                                         @V_MCUSTMEBR,    @V_MIDALTCMEDMV,  @V_MQTLANCTOEST,  @V_MVRLANCTOEST,  @V_MVRLANCTOBRUT,
                                         @V_MIDORDEMCLC,  @V_MNVPROD,       @V_MNMPRODUTO,    @V_MSGUNIDADE,    @V_MSEQUMOVI,
                                         @V_MVRUNILANCTO, @V_MVRTOTLANCTO,  @V_MVRTOTALANTE,  @V_MQTTOTALANTE,  @V_MCDALMOXARIFE,
                                         @V_MCDLOCALESTOQ,@V_MVRCUSTENTRME, @V_MCDTIPORETIME, @V_MNMTIPORETIME, @V_MIDENTRSAIDME,
                                         @V_MCDTIPOOPERME,@V_MVRCUSTLOGLME, @V_MVRCUSTSEGLME, @V_MCUSTLOGESTO,  @V_MCUSTSEGESTO,
                                         @V_MVRPESOBRUTME;

      WHILE (@@FETCH_STATUS = 0) BEGIN
         IF (@V_TIPCUSTEST = 3) OR (@V_TIPCUSTEST = 42) BEGIN
            SET @V_CUSTTOTENTR = @V_MVRCUSTENTRME;
         END
         ELSE BEGIN
            SELECT @V_CDPRODESTO = MAX(CDPRODESTO)
              FROM PRODUTO
             WHERE CDARVPROD = @V_MCDPRODUTO;
               SET @V_CUSTTOTENTR = TEKNISA.CUSTO_PRODUTO_LCEST(@V_MCDFILIAL, @V_CDPRODESTO, @V_TIPCUSTEST, @V_MDTLANCAMEN, @V_DATAPROC,
                                                   @V_MCDALMOXARIFE, @V_MCDLOCALESTOQ, @V_MNRLOTEESTQ, @V_MNRSUBLOTE) * @V_MQTLANCTOEST;
         END;

         EXEC TEKNISA.GRAVA_RELAT_MOVIEST @V_MCDFILIAL, @V_MCDPRODUTO, @V_MNRLOTEESTQ, @V_MNRSUBLOTE, @V_MDTLANCAMEN,
                                          @V_MIDTIPOLANC, @V_MCDFILLANC, @V_MNRLANCAMEN, @V_MNRSEQULANC, @V_MQTDEESTO,
                                          @V_MCUSTMEDI, @V_MCUSTESTO, @V_MQTLANCAMEN, @V_MCUSTBRUT, @V_MCUSTMEES,
                                          @V_MCUSTMEBR, @V_MIDALTCMEDMV, @V_MQTLANCTOEST, @V_MVRLANCTOEST, @V_MVRLANCTOBRUT,
                                          @V_MIDORDEMCLC, @V_MNVPROD, @V_MNMPRODUTO, @V_MSGUNIDADE, @P_SEQUMOVI, @V_MVRUNILANCTO,
                                          @V_MVRTOTLANCTO, @V_MVRTOTALANTE, @V_MQTTOTALANTE, @V_MCDALMOXARIFE, @V_MCDLOCALESTOQ,
                                          @V_CUSTTOTENTR, @V_MCDTIPORETIME, @V_MNMTIPORETIME, @V_MIDENTRSAIDME, @V_MCDTIPOOPERME,
                                          @V_MVRCUSTLOGLME, @V_MVRCUSTSEGLME, @V_MCUSTLOGESTO, @V_MCUSTSEGESTO, @V_MVRPESOBRUTME;

         FETCH NEXT FROM C_ITLANCTOEST_GRUP INTO @V_MCDFILIAL, @V_MCDPRODUTO, @V_MNRLOTEESTQ, @V_MNRSUBLOTE, @V_MDTLANCAMEN,
                                                 @V_MIDTIPOLANC, @V_MCDFILLANC, @V_MNRLANCAMEN, @V_MNRSEQULANC, @V_MQTDEESTO,
                                                 @V_MCUSTMEDI, @V_MCUSTESTO, @V_MQTLANCAMEN, @V_MCUSTBRUT, @V_MCUSTMEES,
                                                 @V_MCUSTMEBR, @V_MIDALTCMEDMV, @V_MQTLANCTOEST, @V_MVRLANCTOEST, @V_MVRLANCTOBRUT,
                                                 @V_MIDORDEMCLC, @V_MNVPROD, @V_MNMPRODUTO, @V_MSGUNIDADE, @V_MSEQUMOVI, @V_MVRUNILANCTO,
                                                 @V_MVRTOTLANCTO, @V_MVRTOTALANTE, @V_MQTTOTALANTE, @V_MCDALMOXARIFE, @V_MCDLOCALESTOQ,
                                                 @V_MVRCUSTENTRME, @V_MCDTIPORETIME, @V_MNMTIPORETIME, @V_MIDENTRSAIDME, @V_MCDTIPOOPERME,
                                                 @V_MVRCUSTLOGLME, @V_MVRCUSTSEGLME, @V_MCUSTLOGESTO, @V_MCUSTSEGESTO, @V_MVRPESOBRUTME;
      END;
      CLOSE C_ITLANCTOEST_GRUP;
      DEALLOCATE C_ITLANCTOEST_GRUP;

      DECLARE C_IMPLANTACAO_GRUP CURSOR FOR
         SELECT D.CDFILIMOVI AS CDFILIAL,
                E.CDARVPROD AS CDPRODUTO,
                (CASE LEN(D.NRLOTEESTQ) WHEN 0 THEN ' ' ELSE D.NRLOTEESTQ END) AS NRLOTEESTQ,
                (CASE LEN(D.NRSUBLOTE) WHEN 0 THEN ' ' ELSE D.NRSUBLOTE END) AS NRSUBLOTE,
                D.DTLANCMOVI AS DTLANCAMEN,
                D.IDTIPOMOVI AS IDTIPOLANC,
                D.CDFILIAL AS CDFILLANC,
                D.NRLANCESTQ AS NRLANCAMEN,
                '0000' AS NRSEQULANC,
                0.0 AS QTDEESTO,
                0.0 AS CUSTMEDI,
                0.0 AS CUSTESTO,
                0.0 AS QTLANCAMEN,
                0.0 AS CUSTBRUT,
                0.0 AS CUSTMEES,
                0.0 AS CUSTMEBR,
                D.IDALTCMEDMV,
                SUM(QTLANCTOEST) AS QTLANCTOEST,
                SUM(ISNULL(VRLANCTOEST,0)) AS VRLANCTOEST,
                SUM(ISNULL(VRLANCTOBRUT,0)) AS VRLANCTOBRUT,
                D.IDORDEMCLC,
                P.CDSUBGRPROD AS NVPROD,
                E.NMPRODUTO,
                E.SGUNIDADE,
                SUBSTRING(@P_SEQUMOVI,1,10) AS NRRELATMOVI,
                ISNULL(SUM(VRTOTLANCTO),0) / (CASE SUM(QTLANCTOEST) WHEN 0 THEN 1 ELSE SUM(QTLANCTOEST) END) AS VRUNILANCTO,
                ISNULL(SUM(VRTOTLANCTO),0) AS VRTOTLANCTO,
                0.0 AS VRTOTALANTE,
                0.0 AS QTTOTALANTE,
                D.CDALMOXARIFE,
                D.CDLOCALESTOQ,
                0.0 AS VRCUSTENTRME,
                ISNULL(D.CDTIPORETI,'--') AS CDTIPORETIME,
                ISNULL(T.NMTIPORETI,'-') AS NMTIPORETIME,
                ISNULL(D.IDENTRSAIDOP,'-') AS IDENTRSAIDME,
                ISNULL(D.CDTIPOOPER,'--') AS CDTIPOOPERME,
                0.0 AS VRCUSTLOGLME,
                0.0 AS VRCUSTSEGLME,
                ISNULL(VRPESOBRUTPR,0) AS VRPESOBRUTME,
                0.0 AS CUSTLOGESTO,
                0.0 AS CUSTSEGESTO
           FROM PRODUTO E, PRSUBGRPROD P, ITLANCTOEST D LEFT JOIN PRODFILI C ON
                                                            (D.CDFILIMOVI = C.CDFILIAL)
                                                        AND (D.CDPRODMOVI = C.CDPRODUTO)
                                                        LEFT JOIN TIPORETI T ON
                                                            (D.CDTIPORETI = T.CDTIPORETI)
          WHERE (D.CDFILIMOVI = @P_FILIAL)
            AND (D.CDALMOXARIFE = ISNULL(@P_CDALMOXARIFE,D.CDALMOXARIFE))
            AND (D.CDLOCALESTOQ = ISNULL(@P_CDLOCALESTOQ,D.CDLOCALESTOQ))
            AND (D.NRLOTEESTQ = ISNULL(@P_NRLOTEESTQ, D.NRLOTEESTQ))
            AND (E.CDPRODUTO = D.CDPRODMOVI)
            AND (E.CDARVPROD BETWEEN @P_PRODINI AND @P_PRODFIM)
            AND (ISNULL(IDEVOLESTOQ,'S') = 'S')
            AND (ISNULL(C.IDCNTRESTOQ,'S') = 'S')
            AND (D.DTLANCMOVI BETWEEN @P_DTINICIAL AND @P_DTFINAL)
            AND (P.CDGRUPPROD = @V_CDGRUPPRMOVEST)
            AND (P.CDPRODUTO = E.CDPRODUTO)
            AND (P.CDFILISUBGR = @V_CDFILISUBGR)
            AND (D.IDTIPOMOVI = '0')
          GROUP BY D.CDFILIMOVI, E.CDARVPROD, P.CDSUBGRPROD, D.NRLOTEESTQ, D.NRSUBLOTE, D.DTLANCMOVI,
                   D.IDTIPOMOVI, D.CDFILIAL, D.NRLANCESTQ, D.IDALTCMEDMV, D.IDORDEMCLC, D.CDPRODMOVI,
                   E.NMPRODUTO, E.SGUNIDADE, D.CDALMOXARIFE, D.CDLOCALESTOQ, D.CDTIPORETI,
                   T.NMTIPORETI, D.IDENTRSAIDOP, D.CDTIPOOPER, VRPESOBRUTPR;

      OPEN C_IMPLANTACAO_GRUP;
      FETCH NEXT FROM C_IMPLANTACAO_GRUP INTO @V_MCDFILIAL, @V_MCDPRODUTO, @V_MNRLOTEESTQ, @V_MNRSUBLOTE, @V_MDTLANCAMEN,
                                              @V_MIDTIPOLANC, @V_MCDFILLANC, @V_MNRLANCAMEN, @V_MNRSEQULANC, @V_MQTDEESTO,
                                              @V_MCUSTMEDI, @V_MCUSTESTO, @V_MQTLANCAMEN, @V_MCUSTBRUT, @V_MCUSTMEES,
                                              @V_MCUSTMEBR, @V_MIDALTCMEDMV, @V_MQTLANCTOEST, @V_MVRLANCTOEST, @V_MVRLANCTOBRUT,
                                              @V_MIDORDEMCLC, @V_MNVPROD, @V_MNMPRODUTO, @V_MSGUNIDADE, @V_MSEQUMOVI, @V_MVRUNILANCTO,
                                              @V_MVRTOTLANCTO, @V_MVRTOTALANTE, @V_MQTTOTALANTE, @V_MCDALMOXARIFE, @V_MCDLOCALESTOQ,
                                              @V_MVRCUSTENTRME, @V_MCDTIPORETIME, @V_MNMTIPORETIME, @V_MIDENTRSAIDME, @V_MCDTIPOOPERME,
                                              @V_MVRCUSTLOGLME, @V_MVRCUSTSEGLME, @V_MCUSTLOGESTO, @V_MCUSTSEGESTO, @V_MVRPESOBRUTME;
      WHILE (@@FETCH_STATUS = 0) BEGIN
         EXEC TEKNISA.GRAVA_RELAT_MOVIEST @V_MCDFILIAL, @V_MCDPRODUTO, @V_MNRLOTEESTQ, @V_MNRSUBLOTE, @V_MDTLANCAMEN, @V_MIDTIPOLANC,
                                          @V_MCDFILLANC, @V_MNRLANCAMEN, @V_MNRSEQULANC, @V_MQTDEESTO, @V_MCUSTMEDI, @V_MCUSTESTO,
                                          @V_MQTLANCAMEN, @V_MCUSTBRUT, @V_MCUSTMEES, @V_MCUSTMEBR, @V_MIDALTCMEDMV, @V_MQTLANCTOEST,
                                          @V_MVRLANCTOEST, @V_MVRLANCTOBRUT, @V_MIDORDEMCLC, @V_MNVPROD, @V_MNMPRODUTO, @V_MSGUNIDADE,
                                          @P_SEQUMOVI, @V_MVRUNILANCTO, @V_MVRTOTLANCTO, @V_MVRTOTALANTE, @V_MQTTOTALANTE, @V_MCDALMOXARIFE,
                                          @V_MCDLOCALESTOQ, @V_MVRCUSTENTRME, @V_MCDTIPORETIME, @V_MNMTIPORETIME, @V_MIDENTRSAIDME, @V_MCDTIPOOPERME, 
                                          @V_MVRCUSTLOGLME, @V_MVRCUSTSEGLME, @V_MCUSTLOGESTO, @V_MCUSTSEGESTO, @V_MVRPESOBRUTME;

         FETCH NEXT FROM C_IMPLANTACAO_GRUP INTO @V_MCDFILIAL, @V_MCDPRODUTO, @V_MNRLOTEESTQ, @V_MNRSUBLOTE, @V_MDTLANCAMEN,
                                                 @V_MIDTIPOLANC, @V_MCDFILLANC, @V_MNRLANCAMEN, @V_MNRSEQULANC, @V_MQTDEESTO,
                                                 @V_MCUSTMEDI, @V_MCUSTESTO, @V_MQTLANCAMEN, @V_MCUSTBRUT, @V_MCUSTMEES,
                                                 @V_MCUSTMEBR, @V_MIDALTCMEDMV, @V_MQTLANCTOEST, @V_MVRLANCTOEST, @V_MVRLANCTOBRUT,
                                                 @V_MIDORDEMCLC, @V_MNVPROD, @V_MNMPRODUTO, @V_MSGUNIDADE, @V_MSEQUMOVI, @V_MVRUNILANCTO,
                                                 @V_MVRTOTLANCTO, @V_MVRTOTALANTE, @V_MQTTOTALANTE, @V_MCDALMOXARIFE, @V_MCDLOCALESTOQ,
                                                 @V_MVRCUSTENTRME, @V_MCDTIPORETIME, @V_MNMTIPORETIME, @V_MIDENTRSAIDME, @V_MCDTIPOOPERME,
                                                 @V_MVRCUSTLOGLME, @V_MVRCUSTSEGLME, @V_MCUSTLOGESTO, @V_MCUSTSEGESTO, @V_MVRPESOBRUTME;
      END;
      CLOSE C_IMPLANTACAO_GRUP;
      DEALLOCATE C_IMPLANTACAO_GRUP;
   END
   ELSE BEGIN
      DECLARE C_ITLANCTOEST CURSOR FOR
         SELECT D.CDFILIMOVI AS CDFILIAL,
                E.CDARVPROD AS CDPRODUTO,
                (CASE LEN(D.NRLOTEESTQ) WHEN 0 THEN ' ' ELSE D.NRLOTEESTQ END) AS NRLOTEESTQ,
                (CASE LEN(D.NRSUBLOTE) WHEN 0 THEN ' ' ELSE D.NRSUBLOTE END) AS NRSUBLOTE,
                D.DTLANCMOVI AS DTLANCAMEN,
                D.IDTIPOMOVI AS IDTIPOLANC,
                D.CDFILIAL AS CDFILLANC ,
                D.NRLANCESTQ AS NRLANCAMEN,
                D.NRSEQUITEM AS NRSEQULANC,
                0.0 AS QTDEESTO,
                0.0 AS CUSTMEDI,
                0.0 AS CUSTESTO,
                0.0 AS QTLANCAMEN,
                0.0 AS CUSTBRUT,
                0.0 AS CUSTMEES,
                0.0 AS CUSTMEBR,
                D.IDALTCMEDMV,
                D.QTLANCTOEST,
                ISNULL(D.VRLANCTOEST ,0) AS VRLANCTOEST,
                ISNULL(D.VRLANCTOBRUT,0) AS VRLANCTOBRUT,
                D.IDORDEMCLC,
                SUBSTRING(E.CDARVPROD,1, @P_TAMNIVEL) AS NVPROD,
                E.NMPRODUTO,
                E.SGUNIDADE,
                SUBSTRING(@P_SEQUMOVI,1,10) AS NRRELATMOVI,
                ISNULL(D.VRUNILANCTO,0) AS VRUNILANCTO,
                ISNULL(D.VRTOTLANCTO,0) AS VRTOTLANCTO,
                0.0 AS VRTOTALANTE,
                0.0 AS QTTOTALANTE,
                D.CDALMOXARIFE,
                D.CDLOCALESTOQ,
                (D.VRLANCTOEST * D.QTLANCTOEST) AS VRCUSTENTRME,
                ISNULL(D.CDTIPORETI,'--') AS CDTIPORETIME,
                ISNULL(T.NMTIPORETI  ,'-') AS NMTIPORETIME,
                ISNULL(D.IDENTRSAIDOP,'-') AS IDENTRSAIDME,
                ISNULL(D.CDTIPOOPER  ,'--') AS CDTIPOOPERME,
                ISNULL(VRCUSTLOGLAN,0) AS VRCUSTLOGLME,
                ISNULL(VRSEGULOGLAN,0) AS VRCUSTSEGLME,
                ISNULL(VRPESOBRUTPR,0) AS VRPESOBRUTME,
                0.0 AS CUSTLOGESTO,
                0.0 AS CUSTSEGESTO
           FROM PRODUTO E,
                ITLANCTOEST D LEFT JOIN PRODFILI C ON
                              (D.CDFILIMOVI = C.CDFILIAL)
                          AND (D.CDPRODMOVI = C.CDPRODUTO)
                              LEFT JOIN TIPORETI T ON
                              (D.CDTIPORETI = T.CDTIPORETI)
          WHERE (D.CDFILIMOVI = @P_FILIAL)
            AND ((D.CDALMOXARIFE = @P_CDALMOXARIFE) OR (@P_CDALMOXARIFE IS NULL)) 
            AND ((D.CDLOCALESTOQ = @P_CDLOCALESTOQ) OR (@P_CDLOCALESTOQ IS NULL)) 
            AND ((D.NRLOTEESTQ = @P_NRLOTEESTQ) OR (@P_NRLOTEESTQ IS NULL))
            AND (E.CDPRODUTO = D.CDPRODMOVI)
            AND (E.CDARVPROD >= @P_PRODINI)
            AND (E.CDARVPROD <= @P_PRODFIM)
            AND (ISNULL(IDEVOLESTOQ,'S') = 'S')
            AND (ISNULL(C.IDCNTRESTOQ,'S') = 'S')
            AND (D.DTLANCMOVI BETWEEN @P_DTINICIAL AND @P_DTFINAL)
            AND (D.IDTIPOMOVI <> '0');

      OPEN C_ITLANCTOEST;
      FETCH NEXT FROM C_ITLANCTOEST INTO @V_MCDFILIAL,    @V_MCDPRODUTO,    @V_MNRLOTEESTQ,   @V_MNRSUBLOTE,    @V_MDTLANCAMEN,
                                         @V_MIDTIPOLANC,  @V_MCDFILLANC,    @V_MNRLANCAMEN,   @V_MNRSEQULANC,   @V_MQTDEESTO,
                                         @V_MCUSTMEDI,    @V_MCUSTESTO,     @V_MQTLANCAMEN,   @V_MCUSTBRUT,     @V_MCUSTMEES,
                                         @V_MCUSTMEBR,    @V_MIDALTCMEDMV,  @V_MQTLANCTOEST,  @V_MVRLANCTOEST,  @V_MVRLANCTOBRUT,
                                         @V_MIDORDEMCLC,  @V_MNVPROD,       @V_MNMPRODUTO,    @V_MSGUNIDADE,    @V_MSEQUMOVI,
                                         @V_MVRUNILANCTO, @V_MVRTOTLANCTO,  @V_MVRTOTALANTE,  @V_MQTTOTALANTE,  @V_MCDALMOXARIFE,
                                         @V_MCDLOCALESTOQ,@V_MVRCUSTENTRME, @V_MCDTIPORETIME, @V_MNMTIPORETIME, @V_MIDENTRSAIDME,
                                         @V_MCDTIPOOPERME,@V_MVRCUSTLOGLME, @V_MVRCUSTSEGLME, @V_MCUSTLOGESTO,  @V_MCUSTSEGESTO,
                                         @V_MVRPESOBRUTME;


      WHILE (@@FETCH_STATUS = 0) BEGIN
         IF (@V_TIPCUSTEST = 3) OR (@V_TIPCUSTEST = 42) BEGIN
            SET @V_CUSTTOTENTR = @V_MVRCUSTENTRME;
         END
         ELSE BEGIN
            SELECT @V_CDPRODESTO = MAX(CDPRODESTO)
              FROM PRODUTO
             WHERE CDARVPROD = @V_MCDPRODUTO;

             SET @V_CUSTTOTENTR = TEKNISA.CUSTO_PRODUTO_LCEST(@V_MCDFILIAL, @V_CDPRODESTO, @V_TIPCUSTEST, @V_MDTLANCAMEN, @V_DATAPROC,
                                                             @V_MCDALMOXARIFE, @V_MCDLOCALESTOQ, @V_MNRLOTEESTQ, @V_MNRSUBLOTE) * @V_MQTLANCTOEST;
         END;
         EXEC TEKNISA.GRAVA_RELAT_MOVIEST @V_MCDFILIAL, @V_MCDPRODUTO, @V_MNRLOTEESTQ, @V_MNRSUBLOTE, @V_MDTLANCAMEN,
                                          @V_MIDTIPOLANC, @V_MCDFILLANC, @V_MNRLANCAMEN, @V_MNRSEQULANC, @V_MQTDEESTO,
                                          @V_MCUSTMEDI, @V_MCUSTESTO, @V_MQTLANCAMEN, @V_MCUSTBRUT, @V_MCUSTMEES,
                                          @V_MCUSTMEBR, @V_MIDALTCMEDMV, @V_MQTLANCTOEST, @V_MVRLANCTOEST, @V_MVRLANCTOBRUT,
                                          @V_MIDORDEMCLC, @V_MNVPROD, @V_MNMPRODUTO, @V_MSGUNIDADE, @P_SEQUMOVI, @V_MVRUNILANCTO,
                                          @V_MVRTOTLANCTO, @V_MVRTOTALANTE, @V_MQTTOTALANTE, @V_MCDALMOXARIFE, @V_MCDLOCALESTOQ,
                                          @V_CUSTTOTENTR, @V_MCDTIPORETIME, @V_MNMTIPORETIME, @V_MIDENTRSAIDME, @V_MCDTIPOOPERME,
                                          @V_MVRCUSTLOGLME, @V_MVRCUSTSEGLME, @V_MCUSTLOGESTO, @V_MCUSTSEGESTO, @V_MVRPESOBRUTME;

         FETCH NEXT FROM C_ITLANCTOEST INTO @V_MCDFILIAL, @V_MCDPRODUTO, @V_MNRLOTEESTQ, @V_MNRSUBLOTE, @V_MDTLANCAMEN,
                                            @V_MIDTIPOLANC, @V_MCDFILLANC, @V_MNRLANCAMEN, @V_MNRSEQULANC, @V_MQTDEESTO,
                                            @V_MCUSTMEDI, @V_MCUSTESTO, @V_MQTLANCAMEN, @V_MCUSTBRUT, @V_MCUSTMEES,
                                            @V_MCUSTMEBR, @V_MIDALTCMEDMV, @V_MQTLANCTOEST, @V_MVRLANCTOEST, @V_MVRLANCTOBRUT,
                                            @V_MIDORDEMCLC, @V_MNVPROD, @V_MNMPRODUTO, @V_MSGUNIDADE, @V_MSEQUMOVI, @V_MVRUNILANCTO,
                                            @V_MVRTOTLANCTO, @V_MVRTOTALANTE, @V_MQTTOTALANTE, @V_MCDALMOXARIFE, @V_MCDLOCALESTOQ,
                                            @V_MVRCUSTENTRME, @V_MCDTIPORETIME, @V_MNMTIPORETIME, @V_MIDENTRSAIDME, @V_MCDTIPOOPERME,
                                            @V_MVRCUSTLOGLME, @V_MVRCUSTSEGLME, @V_MCUSTLOGESTO, @V_MCUSTSEGESTO, @V_MVRPESOBRUTME;
      END;
      CLOSE C_ITLANCTOEST;
      DEALLOCATE C_ITLANCTOEST;

      DECLARE C_IMPLANTACAO CURSOR FOR
         SELECT D.CDFILIMOVI AS CDFILIAL,
                E.CDARVPROD AS CDPRODUTO,
                (CASE LEN(D.NRLOTEESTQ) WHEN 0 THEN ' ' ELSE D.NRLOTEESTQ END) AS NRLOTEESTQ,
                (CASE LEN(D.NRSUBLOTE) WHEN 0 THEN ' ' ELSE D.NRSUBLOTE END) AS NRSUBLOTE,
                D.DTLANCMOVI AS DTLANCAMEN,
                D.IDTIPOMOVI AS IDTIPOLANC,
                D.CDFILIAL AS CDFILLANC,
                D.NRLANCESTQ AS NRLANCAMEN,
                '0000' AS NRSEQULANC,
                0.0 AS QTDEESTO,
                0.0 AS CUSTMEDI,
                0.0 AS CUSTESTO,
                0.0 AS QTLANCAMEN,
                0.0 AS CUSTBRUT,
                0.0 AS CUSTMEES,
                0.0 AS CUSTMEBR,
                D.IDALTCMEDMV,
                SUM(QTLANCTOEST) AS QTLANCTOEST,
                SUM(ISNULL(VRLANCTOEST,0)) AS VRLANCTOEST,
                SUM(ISNULL(VRLANCTOBRUT,0)) AS VRLANCTOBRUT,
                D.IDORDEMCLC,
                SUBSTRING(E.CDARVPROD,1, @P_TAMNIVEL) AS NVPROD,
                E.NMPRODUTO,
                E.SGUNIDADE,
                SUBSTRING(@P_SEQUMOVI,1,10) AS NRRELATMOVI,
                ISNULL(SUM(VRTOTLANCTO),0) / (CASE SUM(QTLANCTOEST) WHEN 0 THEN 1 ELSE SUM(QTLANCTOEST) END) AS VRUNILANCTO,
                ISNULL(SUM(VRTOTLANCTO),0) AS VRTOTLANCTO,
                0.0 AS VRTOTALANTE,
                0.0 AS QTTOTALANTE,
                D.CDALMOXARIFE,
                D.CDLOCALESTOQ,
                0.0 AS VRCUSTENTRME,
                ISNULL(D.CDTIPORETI,'--') AS CDTIPORETIME,
                ISNULL(T.NMTIPORETI,'-') AS NMTIPORETIME,
                ISNULL(D.IDENTRSAIDOP,'-') AS IDENTRSAIDME,
                ISNULL(D.CDTIPOOPER,'--') AS CDTIPOOPERME,
                0.0 AS VRCUSTLOGLME,
                0.0 AS VRCUSTSEGLME,
                ISNULL(VRPESOBRUTPR,0) AS VRPESOBRUTME,
                0.0 AS CUSTLOGESTO,
                0.0 AS CUSTSEGESTO
           FROM PRODUTO E, ITLANCTOEST D LEFT JOIN PRODFILI C ON
                                        (D.CDFILIMOVI = C.CDFILIAL)
                                    AND (D.CDPRODMOVI = C.CDPRODUTO)
                                         LEFT JOIN TIPORETI T ON
                                        (D.CDTIPORETI = T.CDTIPORETI)
          WHERE (D.CDFILIMOVI = @P_FILIAL)
            AND (D.CDALMOXARIFE = ISNULL(@P_CDALMOXARIFE,D.CDALMOXARIFE)) 
            AND (D.CDLOCALESTOQ = ISNULL(@P_CDLOCALESTOQ,D.CDLOCALESTOQ)) 
            AND (D.NRLOTEESTQ = ISNULL(@P_NRLOTEESTQ,D.NRLOTEESTQ))
            AND (E.CDPRODUTO = D.CDPRODMOVI)
            AND (E.CDARVPROD >= @P_PRODINI)
            AND (E.CDARVPROD <= @P_PRODFIM)
            AND (ISNULL(IDEVOLESTOQ,'S') = 'S')
            AND (ISNULL(C.IDCNTRESTOQ,'S') = 'S')
            AND (D.DTLANCMOVI BETWEEN @P_DTINICIAL AND @P_DTFINAL)
            AND (D.IDTIPOMOVI = '0')
          GROUP BY D.CDFILIMOVI, E.CDARVPROD, D.NRLOTEESTQ, D.NRSUBLOTE, D.DTLANCMOVI, D.IDTIPOMOVI, D.CDFILIAL, 
                   D.NRLANCESTQ, D.IDALTCMEDMV, D.IDORDEMCLC, D.CDPRODMOVI, E.NMPRODUTO, E.SGUNIDADE, D.CDALMOXARIFE, 
                   D.CDLOCALESTOQ, D.CDTIPORETI, T.NMTIPORETI, D.IDENTRSAIDOP, D.CDTIPOOPER, VRPESOBRUTPR;

      OPEN C_IMPLANTACAO;
      FETCH NEXT FROM C_IMPLANTACAO INTO @V_MCDFILIAL,    @V_MCDPRODUTO,    @V_MNRLOTEESTQ,   @V_MNRSUBLOTE,    @V_MDTLANCAMEN,
                                         @V_MIDTIPOLANC,  @V_MCDFILLANC,    @V_MNRLANCAMEN,   @V_MNRSEQULANC,   @V_MQTDEESTO,
                                         @V_MCUSTMEDI,    @V_MCUSTESTO,     @V_MQTLANCAMEN,   @V_MCUSTBRUT,     @V_MCUSTMEES,
                                         @V_MCUSTMEBR,    @V_MIDALTCMEDMV,  @V_MQTLANCTOEST,  @V_MVRLANCTOEST,  @V_MVRLANCTOBRUT,
                                         @V_MIDORDEMCLC,  @V_MNVPROD,       @V_MNMPRODUTO,    @V_MSGUNIDADE,    @V_MSEQUMOVI,
                                         @V_MVRUNILANCTO, @V_MVRTOTLANCTO,  @V_MVRTOTALANTE,  @V_MQTTOTALANTE,  @V_MCDALMOXARIFE,
                                         @V_MCDLOCALESTOQ,@V_MVRCUSTENTRME, @V_MCDTIPORETIME, @V_MNMTIPORETIME, @V_MIDENTRSAIDME,
                                         @V_MCDTIPOOPERME,@V_MVRCUSTLOGLME, @V_MVRCUSTSEGLME, @V_MCUSTLOGESTO,  @V_MCUSTSEGESTO,
                                         @V_MVRPESOBRUTME;
      WHILE (@@FETCH_STATUS = 0) BEGIN

         EXEC TEKNISA.GRAVA_RELAT_MOVIEST @V_MCDFILIAL,     @V_MCDPRODUTO,    @V_MNRLOTEESTQ,   @V_MNRSUBLOTE,    @V_MDTLANCAMEN,
                                          @V_MIDTIPOLANC,   @V_MCDFILLANC,    @V_MNRLANCAMEN,   @V_MNRSEQULANC,   @V_MQTDEESTO,
                                          @V_MCUSTMEDI,     @V_MCUSTESTO,     @V_MQTLANCAMEN,   @V_MCUSTBRUT,     @V_MCUSTMEES,
                                          @V_MCUSTMEBR,     @V_MIDALTCMEDMV,  @V_MQTLANCTOEST,  @V_MVRLANCTOEST,  @V_MVRLANCTOBRUT,
                                          @V_MIDORDEMCLC,   @V_MNVPROD,       @V_MNMPRODUTO,    @V_MSGUNIDADE,    @P_SEQUMOVI,
                                          @V_MVRUNILANCTO,  @V_MVRTOTLANCTO,  @V_MVRTOTALANTE,  @V_MQTTOTALANTE,  @V_MCDALMOXARIFE,
                                          @V_MCDLOCALESTOQ, @V_MVRCUSTENTRME, @V_MCDTIPORETIME, @V_MNMTIPORETIME, @V_MIDENTRSAIDME,
                                          @V_MCDTIPOOPERME, @V_MVRCUSTLOGLME, @V_MVRCUSTSEGLME, @V_MCUSTLOGESTO,  @V_MCUSTSEGESTO,
                                          @V_MVRPESOBRUTME;

         FETCH NEXT FROM C_IMPLANTACAO INTO @V_MCDFILIAL,    @V_MCDPRODUTO,    @V_MNRLOTEESTQ,   @V_MNRSUBLOTE,    @V_MDTLANCAMEN,
                                            @V_MIDTIPOLANC,  @V_MCDFILLANC,    @V_MNRLANCAMEN,   @V_MNRSEQULANC,   @V_MQTDEESTO,
                                            @V_MCUSTMEDI,    @V_MCUSTESTO,     @V_MQTLANCAMEN,   @V_MCUSTBRUT,     @V_MCUSTMEES,
                                            @V_MCUSTMEBR,    @V_MIDALTCMEDMV,  @V_MQTLANCTOEST,  @V_MVRLANCTOEST,  @V_MVRLANCTOBRUT,
                                            @V_MIDORDEMCLC,  @V_MNVPROD,       @V_MNMPRODUTO,    @V_MSGUNIDADE,    @V_MSEQUMOVI,
                                            @V_MVRUNILANCTO, @V_MVRTOTLANCTO,  @V_MVRTOTALANTE,  @V_MQTTOTALANTE,  @V_MCDALMOXARIFE,
                                            @V_MCDLOCALESTOQ,@V_MVRCUSTENTRME, @V_MCDTIPORETIME, @V_MNMTIPORETIME, @V_MIDENTRSAIDME,
                                            @V_MCDTIPOOPERME, @V_MVRCUSTLOGLME, @V_MVRCUSTSEGLME, @V_MCUSTLOGESTO,  @V_MCUSTSEGESTO,
                                            @V_MVRPESOBRUTME;
      END;
      CLOSE C_IMPLANTACAO;
      DEALLOCATE C_IMPLANTACAO;
   END;

---------------------------------------------------------------------------------
-- INSERE POSIO INICIAL PARA PRODUTOS                                        --
---------------------------------------------------------------------------------
   SET @V_CDPRODUTO    = ' ';
   SET @V_NRLOTEESTQ   = 'X';
   SET @V_NRSUBLOTE    = 'X';
   SET @V_CDALMOXLCEST = ' ';
   SET @V_VRANTEST     = 0;
   SET @V_DIFCUSTSAI   = 0;

   DECLARE C_MOVIMENTA CURSOR FOR
   SELECT R.NRRELATMOVI, R.CDFILIMOVIEST, R.CDFILLANCMEST, R.NRLANCMOVIEST, R.NRSEQUMOVIEST, R.NRLOTEESTQME, R.NRSUBLOTEME, 
          R.CDPRODMOVIEST, R.DTLANCMOVIEST, R.CDALMOXARIRM, R.CDLOCALESTRM, R.IDTIPOMOVIEST, R.QTDEMOVIEST, R.VRCUSTMEDI, 
          R.VRCUSTMOVIEST, R.QTLANCAMENTO, R.VRCUSTBRUT, R.VRCUSTMEES, R.VRCUSTMEBR, R.QTLANCMOVIEST, R.VRLANCMOVIEST, 
          R.VRBRUTMOVIEST, R.CDTOTMOVIEST, R.NMPRODMOVIEST, R.IDORDEMCALC, R.IDALTCMEDMOV, R.VRDIFECUST, R.VRUNILANCEST, 
          R.VRTOTLANCEST, R.QTTOTALANT, R.VRTOTALANT, R.VRCUSTENTRME, R.SGUNIDMOVI, R.IDENTRSAIDME, R.CDTIPOOPERME,
          R.CDTIPORETIME, R.NMTIPORETIME, P.CDPRODUTO, VRCUSTLOGEME, VRCUSTSEGEME, VRPESOBRUTME, VRCUSTLOGLME, VRCUSTSEGLME
     FROM RELAT_MOVIEST R, PRODUTO P
    WHERE R.NRRELATMOVI = @P_SEQUMOVI
      AND R.CDPRODMOVIEST = P.CDARVPROD
      AND R.CDFILIMOVIEST = @P_FILIAL

   ORDER BY CASE @P_CUSTOALMOX WHEN 'S' THEN CDALMOXARIRM ELSE @P_CUSTOALMOX END,
            CASE @P_CUSTOALMOX WHEN 'S' THEN CDLOCALESTRM ELSE @P_CUSTOALMOX END,
            CDPRODMOVIEST, (CASE ISNULL(ISNULL(@P_MOVCONSOLID,'N'),'N') WHEN 'N' THEN NRLOTEESTQME ELSE NULL END),
            (CASE ISNULL(ISNULL(@P_MOVCONSOLID,'N'),'N') WHEN 'N' THEN NRSUBLOTEME ELSE NULL END),
            DTLANCMOVIEST, ISNULL(IDORDEMCALC,IDTIPOMOVIEST),
            (CASE ISNULL(ISNULL(@P_MOVCONSOLID,'N'),'N') WHEN 'S' THEN NRLOTEESTQME ELSE NULL END),
            (CASE ISNULL(ISNULL(@P_MOVCONSOLID,'N'),'N') WHEN 'S' THEN NRSUBLOTEME ELSE NULL END),
            NRLANCMOVIEST, NRSEQUMOVIEST;

   OPEN C_MOVIMENTA;

   FETCH NEXT FROM C_MOVIMENTA INTO @V_NRRELATMOVI,   @V_CDFILIMOVIEST, @V_CDFILLANCMEST, @V_NRLANCMOVIEST, @V_NRSEQUMOVIEST,
                                    @V_NRLOTEESTQME,  @V_NRSUBLOTEME,   @V_CDPRODMOVIEST, @V_DTLANCMOVIEST, @V_CDALMOXARIRM,
                                    @V_CDLOCALESTRM,  @V_IDTIPOMOVIEST, @V_QTDEMOVIEST,   @V_VRCUSTMEDI,    @V_VRCUSTMOVIEST,
                                    @V_QTLANCAMENTO,  @V_VRCUSTBRUT,    @V_VRCUSTMEES,    @V_VRCUSTMEBR,    @V_QTLANCMOVIEST,
                                    @V_VRLANCMOVIEST, @V_VRBRUTMOVIEST, @V_CDTOTMOVIEST,  @V_NMPRODMOVIEST, @V_IDORDEMCALC,
                                    @V_IDALTCMEDMOV,  @V_VRDIFECUST,    @V_VRUNILANCEST,  @V_VRTOTLANCEST,  @V_QTTOTALANT,
                                    @V_VRTOTALANT,    @V_VRCUSTENTRME,  @V_SGUNIDMOVI,    @V_IDENTRSAIDME,  @V_CDTIPOOPERME,
                                    @V_CDTIPORETIME,  @V_NMTIPORETIME,  @V_MOVCDPRODUTO, @V_VRCUSTLOGEME,   @V_VRCUSTSEGEME,
                                    @V_VRPESOBRUTME,  @V_VRCUSTLOGLME,  @V_VRCUSTSEGLME;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      SET @V_DIFCUSTSAI   = 0;
      IF (ISNULL(@P_MOVCONSOLID,'N') = 'N')  BEGIN
         IF (@V_IDTIPOMOVIEST <> '-')          AND
            ((@V_CDPRODUTO  <> @V_CDPRODMOVIEST) OR
             (@V_NRLOTEESTQ <> @V_NRLOTEESTQME)  OR
             (@V_NRSUBLOTE  <> @V_NRSUBLOTEME)   OR
             ((@V_CDALMOXLCEST <> @V_CDALMOXARIRM+@V_CDLOCALESTRM) AND (@P_CUSTOALMOX = 'S')))BEGIN

            EXEC TEKNISA.GRAVA_RELAT_MOVIEST @P_FILIAL, @V_CDPRODMOVIEST, @V_NRLOTEESTQME, @V_NRSUBLOTEME,
                                             @P_DTINICIAL, '-', '----', '------', '0001', 0, 0, 0, 0, 0, 0, 0,
                                             ' ', 0, 0, 0, '-', @V_CDTOTMOVIEST, @V_NMPRODMOVIEST,
                                             @V_SGUNIDMOVI, @P_SEQUMOVI, 0, 0, 0, 0,
                                             @V_CDALMOXARIRM, @V_CDLOCALESTRM, 0, NULL, NULL, NULL, NULL,
                                             0,0,0,0,0;

            SET @V_VRATUAL  = 0;
            SET @V_QTATUAL  = 0;
            SET @V_QTMOVI   = 0;
            SET @V_CUSTMED  = 0;
            SET @V_CUSTANT  = 0;
            SET @V_QTDEANT  = 0;
            SET @V_CUSTZERO = 0;
            SET @V_VRCUSTLOGEME = 0;
            SET @V_VRCUSTSEGEME = 0;
            SET @V_ULTCUSTENT   = 0;
         END;
      END
      ELSE BEGIN
         IF (@V_IDTIPOMOVIEST <> '-') AND (@V_CDPRODUTO <> @V_CDPRODMOVIEST) BEGIN

            EXEC TEKNISA.GRAVA_RELAT_MOVIEST @P_FILIAL, @V_CDPRODMOVIEST, @V_NRLOTEESTQME, @V_NRSUBLOTEME,
                                             @P_DTINICIAL, '-', '----', '------', '0001', 0, 0, 0, 0, 0, 0, 0,
                                             ' ', 0, 0, 0, '-', @V_CDTOTMOVIEST, @V_NMPRODMOVIEST,
                                             @V_SGUNIDMOVI, @P_SEQUMOVI, 0, 0, 0, 0,
                                             @V_CDALMOXARIRM, @V_CDLOCALESTRM, 0, NULL, NULL, NULL, NULL,
                                             @V_VRCUSTLOGLME,
                                             @V_VRCUSTSEGLME,
                                             @V_VRCUSTLOGEME,
                                             @V_VRCUSTSEGEME,
                                             @V_VRPESOBRUTME;
               SET @V_VRATUAL  = 0;
               SET @V_QTATUAL  = 0;
               SET @V_QTMOVI   = 0;
               SET @V_CUSTMED  = 0;
               SET @V_CUSTANT  = 0;
               SET @V_QTDEANT  = 0;
               SET @V_CUSTZERO = 0;
               SET @V_VRCUSTLOGEME = 0;
               SET @V_VRCUSTSEGEME = 0;
               SET @V_ULTCUSTENT   = 0;
         END;

         IF (@V_IDTIPOMOVIEST <> '-')          AND
            ((@V_CDPRODUTO  <> @V_CDPRODMOVIEST) OR
             (@V_NRLOTEESTQ <> @V_NRLOTEESTQME)  OR
             (@V_NRSUBLOTE  <> @V_NRSUBLOTEME)   OR
             ((@V_CDALMOXLCEST <> @V_CDALMOXARIRM+@V_CDLOCALESTRM) AND (@P_CUSTOALMOX = 'S'))) BEGIN
             SET @V_QTDEANT = 0;
             SET @V_VRCUSTLOGEME = 0;
             SET @V_VRCUSTSEGEME = 0;
             SET @V_ULTCUSTENT   = 0;
         END;
      END;

---------------------------------------------------------------------------------
-- ALTERA OS VALORES DE ESTOQUE PARA OS PRODUTOS                               --
---------------------------------------------------------------------------------

      SELECT @V_CDPRODESTO = MAX(CDPRODESTO)
      FROM PRODUTO
      WHERE CDPRODUTO = @V_MOVCDPRODUTO;

      IF (@V_TIPCUSTEST <> 3) BEGIN
         IF (ISNULL(@P_MOVCONSOLID,'N') = 'N')  BEGIN
            IF @V_IDTIPOMOVIEST = '-' BEGIN
               SELECT @V_CUSTESTOQ = TEKNISA.CUSTO_PRODUTO_LCEST(@P_FILIAL, @V_CDPRODESTO, @V_TIPCUSTEST, @V_DTLANCMOVIEST - 1, @V_DATAPROC,
                                                                 @V_CDALMOXARIRM, @V_CDLOCALESTRM, @V_NRLOTEESTQME, @V_NRSUBLOTEME)
            END
            ELSE BEGIN
               SELECT @V_CUSTESTOQ = TEKNISA.CUSTO_PRODUTO_LCEST(@P_FILIAL, @V_CDPRODESTO, @V_TIPCUSTEST, @V_DTLANCMOVIEST, @V_DATAPROC,
                                                                 @V_CDALMOXARIRM, @V_CDLOCALESTRM, @V_NRLOTEESTQME, @V_NRSUBLOTEME)
            END;
         END
         ELSE BEGIN
            IF @V_IDTIPOMOVIEST = '-' BEGIN
               SELECT @V_CUSTESTOQ = TEKNISA.CUSTO_PRODUTO(@P_FILIAL, @V_CDPRODESTO, @V_TIPCUSTEST, @V_DTLANCMOVIEST - 1, @V_DATAPROC)
               FROM PARAMGERAL;
            END
            ELSE BEGIN
              SELECT @V_CUSTESTOQ = TEKNISA.CUSTO_PRODUTO(@P_FILIAL, @V_CDPRODESTO, @V_TIPCUSTEST, @V_DTLANCMOVIEST, @V_DATAPROC)
              FROM PARAMGERAL;
            END;
         END;
      END;

      IF (@V_CUSTESTOQ IS NULL) BEGIN
         SET @V_CUSTESTOQ = 0;
      END;

      IF @V_IDTIPOMOVIEST = '-' BEGIN

         SET @V_QTATUAL  = @V_QTDEMOVIEST;
         SET @V_QTMOVI   = @V_QTLANCAMENTO;
         SET @V_QTDEANT  = @V_QTATUAL;

         SET @V_VRCUSTLOGEME = @V_VRCUSTLOGEME;
         SET @V_VRCUSTSEGEME = @V_VRCUSTSEGEME;

         SET @V_VRCUSTLOGANT = @V_VRCUSTLOGEME;
         SET @V_VRCUSTSEGANT = @V_VRCUSTSEGEME;

         SET @V_VRMOVSEGANT = @V_VRCUSTLOGEME;
         SET @V_VRMOVLOGANT = @V_VRCUSTSEGEME;

         IF (@V_TIPCUSTEST <> 3) BEGIN
            SET @V_CUSTMED   = @V_CUSTESTOQ;
            SET @V_CUSTMEES  = @V_CUSTESTOQ;
            SET @V_CUSTANT   = @V_VRATUAL;

            IF (@V_QTDEMOVIEST > 0) BEGIN
               SET @V_VRATUAL = @V_CUSTESTOQ * @V_QTDEMOVIEST;
            END
            ELSE BEGIN
               SET @V_VRATUAL = @V_CUSTESTOQ;
            END;
         END
         ELSE BEGIN
            IF (@P_IDCUSTO = 1) BEGIN
               SET @V_VRATUAL  = @V_VRCUSTMOVIEST;
               SET @V_CUSTMED  = @V_VRCUSTMEDI;
               SET @V_CUSTMEES = @V_VRCUSTMEES;
               SET @V_CUSTANT  = @V_VRATUAL;
            END
            ELSE IF (@P_IDCUSTO = 2) BEGIN
               SET @V_VRATUAL  = @V_VRCUSTBRUT;
               SET @V_CUSTMED  = @V_VRCUSTMEDI;
               SET @V_CUSTMEES = @V_VRCUSTMEBR;
               SET @V_CUSTANT  = @V_VRATUAL;
            END;
         END;
         IF (@V_QTATUAL > 0) BEGIN
            SET @V_ULTCUSTENT  = @V_VRATUAL/ @V_QTATUAL;
         END;
      END
      ELSE IF (@V_IDTIPOMOVIEST = '0') BEGIN
         IF (@V_QTATUAL <> 0) BEGIN
            SET @V_CUSTOANTCONS = @V_VRATUAL/@V_QTATUAL;
         END;
         SET @V_QTDEAJUSTE = 0;
         SET @V_VLRESTOAJU = 0;
         SET @V_VLRBRUTAJU = 0;

         IF @V_QTATUAL > 0 BEGIN
            SET @V_QTMOVANT = @V_QTATUAL;
         END;

         IF @V_VRATUAL > 0 BEGIN
            SET @V_VRMOVANT  = @V_VRATUAL;
         END;

         IF (ISNULL(@P_MOVCONSOLID,'N') = 'S') BEGIN
            EXEC TEKNISA.CALCULA_SALDO_ANTERIOR @V_CDFILLANCMEST, @V_NRLANCMOVIEST,
                                                @V_CDFILIMOVIEST, @V_MOVCDPRODUTO,
                                                @V_CDALMOXARIRM,  @V_CDLOCALESTRM,
                                                @V_NRLOTEESTQME,  @V_NRSUBLOTEME,
                                                @V_DTLANCMOVIEST, 'S', 
                                                @P_QTESTOQDIA  = @V_QTDEAJUSTE OUTPUT,
                                                @P_VRESTOQDIA  = @V_VLRESTOAJU OUTPUT,
                                                @P_VRESTOQBRUT = @V_VLRBRUTAJU OUTPUT,
                                                @P_QTESTOQANT  = @V_VRQTANT    OUTPUT,
                                                @P_VRESTANT    = @V_VRESTOANT  OUTPUT;

            SET @V_VRCUSTLOGEME = 0;
            SET @V_VRCUSTSEGEME = 0;

            SET @V_QTMOVI  = @V_QTLANCMOVIEST - @V_QTDEAJUSTE;
            SET @V_QTATUAL = @V_QTATUAL + @V_QTLANCMOVIEST - @V_QTDEAJUSTE;

            IF (@P_IDCUSTO = 1) BEGIN
               IF (@V_TIPCUSTEST <> 3) BEGIN
                  SET @V_VRATUAL = @V_VRATUAL + @V_VRLANCMOVIEST - (@V_VLRESTOAJU * @V_QTDEAJUSTE);
               END
               ELSE BEGIN
                  IF (@V_QTDEAJUSTE <> 0) BEGIN
                     SET @V_VRATUAL = @V_VRATUAL + @V_VRLANCMOVIEST - @V_VLRESTOAJU;
                  END
                  ELSE BEGIN
                     SET @V_VRATUAL = @V_VRATUAL + @V_VRLANCMOVIEST;
                  END;
               END;
               IF (@V_QTLANCMOVIEST <> 0) BEGIN
                  IF @V_TIPCUSTEST <> 3 BEGIN
                     SET @V_CUSTMED = @V_VRLANCMOVIEST/@V_QTLANCMOVIEST;
                  END;
                  IF @V_QTATUAL = 0 BEGIN
                     SET @V_DIFCUSTSAI = @V_CUSTOANTCONS;
                  END;
               END
               ELSE BEGIN
                  SET @V_CUSTMED = TEKNISA.CUSTO_PRODUTO_LCEST(@P_FILIAL, @V_CDPRODESTO, @V_TIPCUSTEST, @V_DTLANCMOVIEST,  @V_DATAPROC,
                                                     @V_CDALMOXARIRM, @V_CDLOCALESTRM, @V_NRLOTEESTQME, @V_NRSUBLOTEME);
               END;
            END
            ELSE IF (@P_IDCUSTO = 2) BEGIN
               IF (@V_TIPCUSTEST <> 3) BEGIN
                  SET @V_VRATUAL = @V_VRATUAL + @V_VRBRUTMOVIEST - (@V_VLRBRUTAJU * @V_QTDEAJUSTE);
               END
               ELSE BEGIN
                  IF (@V_QTDEAJUSTE <> 0) BEGIN
                     SET @V_VRATUAL = @V_VRATUAL + @V_VRBRUTMOVIEST - @V_VLRBRUTAJU;
                  END
                  ELSE BEGIN
                     SET @V_VRATUAL = @V_VRATUAL + @V_VRBRUTMOVIEST;
                  END;
               END;
               IF (@V_QTLANCMOVIEST <> 0) BEGIN
                  SET @V_CUSTMED = @V_VRBRUTMOVIEST/@V_QTLANCMOVIEST;
               END
               ELSE BEGIN
                  SET @V_CUSTMED = 0;
               END;
            END;
         END
         ELSE BEGIN
            SET @V_VRCUSTLOGEME = 0;
            SET @V_VRCUSTSEGEME = 0;
            SET @V_QTMOVI  = @V_QTLANCMOVIEST;
            SET @V_QTATUAL = @V_QTLANCMOVIEST;

            IF @V_QTATUAL <> 0 BEGIN
               IF @V_TIPCUSTEST = 3 BEGIN
                  IF @P_IDCUSTO = 1 BEGIN
                     SET @V_VRATUAL = @V_VRLANCMOVIEST;
                  END
                  ELSE IF @P_IDCUSTO = 2 BEGIN
                     SET @V_VRATUAL = @V_VRBRUTMOVIEST;
                  END;

                  SET @V_CUSTMED = @V_VRATUAL/@V_QTATUAL;
               END
               ELSE BEGIN
                  SET @V_CUSTMED = TEKNISA.CUSTO_PRODUTO_LCEST(@P_FILIAL, @V_CDPRODESTO, @V_TIPCUSTEST, @V_DTLANCMOVIEST, @V_DATAPROC,
                                                   @V_CDALMOXARIRM, @V_CDLOCALESTRM, @V_NRLOTEESTQME, @V_NRSUBLOTEME);

                  SET @V_VRATUAL = @V_CUSTMED * @V_QTLANCMOVIEST;
               END;
            END
            ELSE BEGIN
               SET @V_CUSTMED = 0;
            END;
         END;
      END
      ELSE IF @V_IDTIPOMOVIEST = '1' BEGIN

         SET @V_QTDEAJUSTE = 0;
         SET @V_VLRESTOAJU = 0;
         SET @V_VLRBRUTAJU = 0;
         SET @V_VRCUSTLOGANT = @V_VRCUSTLOGEME;
         SET @V_VRCUSTSEGANT = @V_VRCUSTSEGEME;

         IF @V_QTATUAL > 0 BEGIN
            SET @V_QTMOVANT = @V_QTATUAL;
         END;

         IF @V_VRATUAL > 0 BEGIN
            SET @V_VRMOVANT  = @V_VRATUAL;
         END;

         IF ISNULL(@P_MOVCONSOLID,'N') = 'S' BEGIN
            SET @V_CUSTOANTCONS = @V_VRATUAL;
            EXEC TEKNISA.CALCULA_SALDO_ANTERIOR @V_CDFILLANCMEST, @V_NRLANCMOVIEST,
                                                @V_CDFILIMOVIEST, @V_MOVCDPRODUTO,
                                                @V_CDALMOXARIRM,  @V_CDLOCALESTRM,
                                                @V_NRLOTEESTQME,  @V_NRSUBLOTEME,
                                                @V_DTLANCMOVIEST, 'S',                                                 
                                                @P_QTESTOQDIA  = @V_QTDEAJUSTE OUTPUT,
                                                @P_VRESTOQDIA  = @V_VLRESTOAJU OUTPUT,
                                                @P_VRESTOQBRUT = @V_VLRBRUTAJU OUTPUT,
                                                @P_QTESTOQANT  = @V_VRQTANT    OUTPUT,
                                                @P_VRESTANT    = @V_VRESTOANT  OUTPUT;

            SET @V_QTMOVI = (@V_QTLANCMOVIEST - @V_QTDEAJUSTE);

            IF @V_QTMOVI < 0 BEGIN
               IF @V_QTATUAL > 0 BEGIN
                  SET @V_VRCUSTLOGEME = @V_VRCUSTLOGEME - ((@V_VRCUSTLOGEME/@V_QTATUAL) * ABS(@V_QTMOVI));
                  SET @V_VRCUSTSEGEME = @V_VRCUSTSEGEME - ((@V_VRCUSTSEGEME/@V_QTATUAL) * ABS(@V_QTMOVI));
               END;
            END
            ELSE BEGIN
               IF @V_QTMOVI > 0 BEGIN
                  IF @V_QTATUAL > 0 BEGIN
                     SET @V_VRCUSTLOGEME = @V_VRCUSTLOGEME + ((@V_VRCUSTLOGEME/@V_QTATUAL) * ABS(@V_QTMOVI));
                     SET @V_VRCUSTSEGEME = @V_VRCUSTSEGEME + ((@V_VRCUSTSEGEME/@V_QTATUAL) * ABS(@V_QTMOVI));
                  END;
               END;
            END;

            IF @V_IDALTCMEDMOV = 'S' BEGIN
               IF @V_QTMOVI <> 0 BEGIN
                  IF @P_IDCUSTO = 1 BEGIN
                     IF @V_VLRESTOAJU <> 0 BEGIN
                        SET @V_CUSTMED = @V_VLRESTOAJU/(@V_QTDEAJUSTE + @V_QTMOVI);
                     END
                     ELSE BEGIN
                        SET @V_CUSTMED = 0;
                     END;
                  END
                  ELSE BEGIN
                     IF @V_VLRBRUTAJU <> 0 BEGIN
                        SET @V_CUSTMED = @V_VLRBRUTAJU/(@V_QTDEAJUSTE + @V_QTMOVI);
                     END
                     ELSE BEGIN
                        SET @V_CUSTMED = 0;
                     END;
                  END;
               END
               ELSE BEGIN
                  SET @V_CUSTMED = 0;
               END;
            END
            ELSE BEGIN
               IF (@V_QTDEAJUSTE <> 0) BEGIN
                  IF (@V_TIPCUSTEST <> 3) BEGIN
                     SET @V_CUSTMED = @V_VLRESTOAJU;
                  END
                  ELSE BEGIN
                     IF (@P_IDCUSTO = 1) BEGIN
                        SET @V_CUSTMED = @V_VLRESTOAJU/@V_QTDEAJUSTE;
                     END
                     ELSE BEGIN
                        SET @V_CUSTMED = @V_VLRBRUTAJU/@V_QTDEAJUSTE;
                     END;
                  END;
               END
               ELSE BEGIN
                  IF (@V_VLRESTOAJU <> 0) BEGIN
                     IF (@V_TIPCUSTEST <> 3) BEGIN
                        SET @V_CUSTMED = @V_VLRESTOAJU;
                     END
                     ELSE BEGIN
                        IF (@V_VRQTANT <> 0) BEGIN
                           IF (@P_IDCUSTO = 1) BEGIN
                              SET @V_CUSTMED = @V_VLRESTOAJU/@V_VRQTANT;
                           END
                           ELSE BEGIN
                              SET @V_CUSTMED = @V_VLRBRUTAJU/@V_VRQTANT;
                           END;
                        END;
                     END;
                  END;
               END;
            END;
            SET @V_QTATUAL = (@V_QTATUAL + @V_QTMOVI);
            SET @V_VRATUAL = @V_VRATUAL + (@V_CUSTMED * @V_QTMOVI);
            IF @V_QTATUAL = 0 BEGIN
               SET @V_DIFCUSTSAI = ABS(@V_CUSTMED*@V_QTMOVI) - @V_CUSTOANTCONS;
            END;
         END
         ELSE BEGIN
            SET @V_QTMOVI = @V_QTLANCMOVIEST - @V_QTATUAL;
            IF @V_QTMOVI < 0 BEGIN
               IF @V_QTATUAL > 0 BEGIN
                  SET @V_VRCUSTLOGEME = @V_VRCUSTLOGEME - ((@V_VRCUSTLOGEME/@V_QTATUAL) * ABS(@V_QTMOVI));
                  SET @V_VRCUSTSEGEME = @V_VRCUSTSEGEME - ((@V_VRCUSTSEGEME/@V_QTATUAL) * ABS(@V_QTMOVI));
               END;
            END
            ELSE BEGIN
               IF @V_QTMOVI > 0 BEGIN
                  IF @V_QTATUAL > 0 BEGIN
                     SET @V_VRCUSTLOGEME = @V_VRCUSTLOGEME + ((@V_VRCUSTLOGEME/@V_QTATUAL) * ABS(@V_QTMOVI));
                     SET @V_VRCUSTSEGEME = @V_VRCUSTSEGEME + ((@V_VRCUSTSEGEME/@V_QTATUAL) * ABS(@V_QTMOVI));
                  END;
               END;
            END;

            IF @V_IDALTCMEDMOV = 'S' BEGIN
               IF @V_QTLANCMOVIEST <> 0 BEGIN
                  IF @V_VRATUAL <> 0 BEGIN
                     SET @V_CUSTMED = @V_VRATUAL/@V_QTLANCMOVIEST;
                  END
                  ELSE BEGIN
                     SET @V_CUSTMED = @V_VRTOTALANT/@V_QTLANCMOVIEST;
                  END;
               END
               ELSE BEGIN
                  SET @V_CUSTMED = 0;
               END;
            END
            ELSE BEGIN
               IF @V_QTATUAL <> 0 BEGIN
                  IF @V_VRATUAL <> 0 BEGIN
                     SET @V_CUSTMED = @V_VRATUAL/@V_QTATUAL;
                  END
                  ELSE BEGIN
                     SET @V_CUSTMED = @V_CUSTZERO;
                     IF (@V_VRCUSTLOGEME + @V_VRCUSTSEGEME) = 0 BEGIN
                        IF @V_QTMOVANT > 0 BEGIN
                           SET @V_CUSTMED =  (((@V_QTLANCMOVIEST*@V_CUSTZERO) - @V_VRMOVANT)- (@V_VRMOVLOGANT + @V_VRMOVSEGANT))/@V_QTMOVANT;
                        END;
                     END;
                  END;
               END
               ELSE BEGIN
                  SET @V_CUSTMED = @V_CUSTZERO;
                  /*Se quantidade zero e CL zero, busca o custo mdio sem logistica*/
                  IF ((@V_VRCUSTLOGEME + @V_VRCUSTSEGEME) = 0) and ((@V_VRMOVLOGANT + @V_VRMOVSEGANT)> 0)  BEGIN
                        IF @V_QTMOVANT > 0 BEGIN
                           SET @V_CUSTMED = (@V_VRMOVANT - (@V_VRMOVLOGANT + @V_VRMOVSEGANT))/@V_QTMOVANT;
                        END;
                  END;

                  IF (@V_QTMOVANT - @V_QTMOVI) > 0 BEGIN
                     IF @V_QTMOVANT > 0 BEGIN
                        SET @V_VRCUSTLOGEME = @V_VRCUSTLOGEME - ((@V_VRCUSTLOGEME/@V_QTMOVANT) * ABS(@V_QTMOVI));
                        SET @V_VRCUSTSEGEME = @V_VRCUSTSEGEME - ((@V_VRCUSTSEGEME/@V_QTMOVANT) * ABS(@V_QTMOVI));
                     END;
                  END
                  ELSE BEGIN
                     IF (@V_QTMOVANT - @V_QTMOVI) < 0 BEGIN
                        IF @V_QTMOVANT > 0 BEGIN
                           SET @V_VRCUSTLOGEME = @V_VRCUSTLOGEME + ((@V_VRCUSTLOGEME/@V_QTMOVANT) * ABS(@V_QTMOVI));
                           SET @V_VRCUSTSEGEME = @V_VRCUSTSEGEME + ((@V_VRCUSTSEGEME/@V_QTMOVANT) * ABS(@V_QTMOVI));
                        END;
                     END;
                  END;
               END;
            END;
            SET @V_QTATUAL    = @V_QTLANCMOVIEST;
            SET @V_VRATUAL    = @V_CUSTMED * @V_QTATUAL;
            SET @V_ULTCUSTENT = @V_CUSTMED;
         END;
         IF ((@V_QTLANCMOVIEST > 0 ) AND (@V_QTMOVI >  0)) OR (@V_QTMOVANT = 0)  BEGIN
            IF (@V_VRCUSTLOGEME+ @V_VRCUSTSEGEME) <= (@V_VRCUSTSEGANT+@V_VRCUSTLOGANT) BEGIN
               SET @V_DIFCUSTSAI = (@V_VRCUSTSEGANT+@V_VRCUSTLOGANT)*(-1);
            END;
         END;
      END
      ELSE IF @V_IDTIPOMOVIEST = '2' BEGIN
         SET @V_QTMOVI = @V_QTLANCMOVIEST;

         SET @V_VRCUSTLOGEME = @V_VRCUSTLOGEME + @V_VRCUSTLOGLME;
         SET @V_VRCUSTSEGEME = @V_VRCUSTSEGEME + @V_VRCUSTSEGLME;

         SET @V_QTMOVANT = @V_QTATUAL;
         IF (@V_QTLANCMOVIEST <> 0)  OR (@V_CDTIPOOPERME = '03') BEGIN
            IF @V_VRATUAL > 0 BEGIN
               SET @V_VRMOVANT  = @V_VRATUAL;
            END;

            IF (@V_TIPCUSTEST <> 3) AND (@V_TIPCUSTEST <> 4) AND
               (@V_TIPCUSTEST <> 42) AND (@V_TIPCUSTEST <> 43) BEGIN
               SET @V_CUSTMED = TEKNISA.CUSTO_PRODUTO_LCEST(@P_FILIAL, @V_CDPRODESTO, @V_TIPCUSTEST, @V_DTLANCMOVIEST,  @V_DATAPROC,
                                               @V_CDALMOXARIRM, @V_CDLOCALESTRM, @V_NRLOTEESTQME, @V_NRSUBLOTEME);
            END
            ELSE BEGIN
               IF (@P_IDCUSTO = 1) AND (@V_TIPCUSTEST <> 4) AND (@V_TIPCUSTEST <> 43) BEGIN
                  SET @V_CUSTMED = @V_VRLANCMOVIEST;
               END
               ELSE IF (@P_IDCUSTO = 2) OR (@V_TIPCUSTEST = 4) OR (@V_TIPCUSTEST = 43) BEGIN
                  SET @V_CUSTMED = @V_VRBRUTMOVIEST;
               END;
            END;

            IF (@V_QTATUAL = 0)  BEGIN
               SET @V_VRATUAL = @V_VRATUAL + ISNULL(@V_VRCUSTLOGEME,0) + ISNULL(@V_VRCUSTSEGEME,0);
            END;

            SET @V_VRCUSTLOGEME = @V_VRCUSTLOGEME + @V_VRCUSTLOGLME;
            SET @V_VRCUSTSEGEME = @V_VRCUSTSEGEME + @V_VRCUSTSEGLME;

            SET @V_VRATUEST = @V_QTATUAL * @V_CUSTMED;
            SET @V_VRANTEST = @V_VRATUAL;
            SET @V_QTATUAL = @V_QTATUAL + @V_QTMOVI;

            IF (@V_TIPCUSTEST <> 3) AND (@V_TIPCUSTEST <> 4) BEGIN
               IF (@V_QTMOVI <> 0) BEGIN
                  IF (@V_CUSTMED > 0) BEGIN
                     SET @V_VRATUAL = @V_QTATUAL * @V_CUSTMED;
                  END;
               END;
            END
            ELSE BEGIN
               IF (@V_QTMOVI = 0) BEGIN
                  SET @V_VRATUAL = @V_VRATUAL + @V_CUSTMED;
               END
               ELSE BEGIN
                  SET @V_VRATUAL = @V_VRATUAL + (@V_QTMOVI * @V_CUSTMED);
               END;
            END;
            SET @V_VRATUAL = @V_VRATUAL + @V_VRCUSTLOGLME + @V_VRCUSTSEGLME;

            IF (@V_TIPCUSTEST <> 3) AND (@V_TIPCUSTEST <> 4) BEGIN
               IF (@V_QTMOVI > 0) BEGIN
                  SET @V_DIFCUSTSAI = @V_VRATUEST - @V_VRANTEST;
               END;
            END;
            IF @V_QTATUAL > 0 BEGIN
               SET @V_ULTCUSTENT = @V_VRATUAL/@V_QTATUAL;
            END;
         END
         ELSE BEGIN
          SET @V_CUSTMED = 0;
         END;
      END
      ELSE IF @V_IDTIPOMOVIEST = '3' BEGIN

         SET @V_VRCUSTLOGANT = @V_VRCUSTLOGEME;
         SET @V_VRCUSTSEGANT = @V_VRCUSTSEGEME;

         SET @V_QTMOVI = @V_QTLANCMOVIEST;

         SET @V_QTMOVANT = @V_QTATUAL;
         IF @V_VRATUAL > 0 BEGIN
            SET @V_VRMOVANT  = @V_VRATUAL;
         END;
         /*Para calculo do valor sem logistica no ajuste*/

         IF (@V_VRCUSTLOGEME+@V_VRCUSTSEGEME) > 0 BEGIN
            SET @V_VRMOVSEGANT = @V_VRCUSTLOGEME;
            SET @V_VRMOVLOGANT = @V_VRCUSTSEGEME;
         END;

         IF ISNULL(@P_MOVCONSOLID,'N') = 'S' BEGIN
            IF (@V_QTATUAL <> 0) BEGIN
               SET @V_CUSTOANTCONS = @V_VRATUAL/@V_QTATUAL;
            END;
            EXEC TEKNISA.CALCULA_SALDO_ANTERIOR @V_CDFILLANCMEST, @V_NRLANCMOVIEST,
                                                @V_CDFILIMOVIEST, @V_MOVCDPRODUTO,
                                                @V_CDALMOXARIRM,  @V_CDLOCALESTRM,
                                                @V_NRLOTEESTQME,  @V_NRSUBLOTEME,
                                                @V_DTLANCMOVIEST, 'S',
                                                @P_QTESTOQDIA  = @V_QTDEAJUSTE OUTPUT,
                                                @P_VRESTOQDIA  = @V_VLRESTOAJU OUTPUT,
                                                @P_VRESTOQBRUT = @V_VLRBRUTAJU OUTPUT,
                                                @P_QTESTOQANT  = @V_VRQTANT    OUTPUT,
                                                @P_VRESTANT    = @V_VRESTOANT  OUTPUT;

            SELECT @V_CUSTESTOQ = TEKNISA.CUSTO_PRODUTO_LCEST(@P_FILIAL, @V_CDPRODESTO, @V_TIPCUSTEST, @V_DTLANCMOVIEST , @V_DATAPROC,
                                                                @V_CDALMOXARIRM, @V_CDLOCALESTRM, @V_NRLOTEESTQME, @V_NRSUBLOTEME)
            IF (@V_QTATUAL <> 0) BEGIN
               SET @V_VRCUSTLOGEME = @V_VRCUSTLOGEME - ((@V_VRCUSTLOGEME/@V_QTATUAL) * @V_QTMOVI);
               SET @V_VRCUSTSEGEME = @V_VRCUSTSEGEME - ((@V_VRCUSTSEGEME/@V_QTATUAL) * @V_QTMOVI);
            END;

            IF @V_QTDEAJUSTE <> 0 BEGIN
               IF @V_TIPCUSTEST <> 3 BEGIN
                  SET @V_CUSTMED = @V_CUSTESTOQ;
                  SET @V_VRATUAL = @V_VRATUAL - (@V_QTMOVI * @V_CUSTMED);
               END
               ELSE BEGIN
                  IF @P_IDCUSTO = 1 BEGIN
                     SET @V_VRATUAL = @V_VRATUAL - (@V_QTMOVI * (@V_VLRESTOAJU/@V_QTDEAJUSTE));
                     SET @V_CUSTMED = @V_VLRESTOAJU/@V_QTDEAJUSTE;
                  END
                  ELSE IF @P_IDCUSTO = 2 BEGIN
                     SET @V_VRATUAL = @V_VRATUAL - (@V_QTMOVI * (@V_VLRBRUTAJU/@V_QTDEAJUSTE));
                     SET @V_CUSTMED = @V_VLRBRUTAJU/@V_QTDEAJUSTE;
                  END;
               END;
               SET @V_QTATUAL = @V_QTATUAL - @V_QTMOVI;
            END
            ELSE BEGIN
               IF @V_VLRESTOAJU <> 0 BEGIN
                  IF (@V_TIPCUSTEST <> 3 OR @V_VLRESTOAJU = 0)  BEGIN
                     SET @V_CUSTMED = @V_CUSTESTOQ;
                  END
                  ELSE BEGIN
                     IF @P_IDCUSTO = 1 BEGIN
                        SET @V_CUSTMED = @V_VLRESTOAJU;
                     END
                     ELSE BEGIN
                        SET @V_CUSTMED = @V_VLRBRUTAJU;
                     END;
                  END;
               END
               ELSE BEGIN
                  SET @V_CUSTMED = 0;
               END;

               SET @V_VRATUAL = @V_VRATUAL - (@V_CUSTMED * @V_QTMOVI);
               SET @V_QTATUAL = @V_QTATUAL - @V_QTMOVI;
               IF @V_QTATUAL = 0 BEGIN
                  SET @V_DIFCUSTSAI = @V_CUSTOANTCONS;
               END;
            END;
         END
         ELSE BEGIN
            IF @V_QTATUAL <> 0 BEGIN
               SET @V_VRCUSTLOGEME = @V_VRCUSTLOGEME - ((@V_VRCUSTLOGEME/@V_QTATUAL) * @V_QTMOVI);
               SET @V_VRCUSTSEGEME = @V_VRCUSTSEGEME - ((@V_VRCUSTSEGEME/@V_QTATUAL) * @V_QTMOVI);

               IF @V_TIPCUSTEST <> 3 BEGIN
                  SET @V_CUSTMED = @V_CUSTESTOQ;
               END
               ELSE BEGIN
                  SET @V_CUSTMED = @V_VRATUAL/@V_QTATUAL;
               END;
            END
            ELSE BEGIN
               SET @V_CUSTMED = 0;
            END;

            IF ((@V_QTATUAL - @V_QTMOVI) < 0) AND (@V_QTATUAL <= 0) BEGIN
               SET @V_CUSTMED = @V_CUSTZERO;
            END;

            SET @V_VRANTEST = @V_VRATUAL;
            SET @V_VRATUAL = (@V_QTATUAL - @V_QTMOVI)*@V_CUSTMED;
--            SET @V_VRATUAL = @V_VRATUAL - (@V_CUSTMED * @V_QTMOVI);
            SET @V_QTATUAL = @V_QTATUAL - @V_QTMOVI;
            IF ABS(@V_ULTCUSTENT - @V_CUSTMED)> 0.0001 BEGIN
               IF @V_QTMOVI > 0 BEGIN
                  SET @V_DIFCUSTSAI = (@V_VRANTEST - @V_VRATUAL)/@V_QTMOVI;
               END;
            END;
         END;
      END
      ELSE IF @V_IDTIPOMOVIEST = '4' BEGIN
         IF (@V_QTATUAL <> 0) BEGIN
            SET @V_CUSTOANTCONS = @V_VRATUAL/@V_QTATUAL;
         END;
         SET @V_QTMOVI = @V_QTLANCMOVIEST;

         SET @V_VRCUSTLOGANT = @V_VRCUSTLOGEME;
         SET @V_VRCUSTSEGANT = @V_VRCUSTSEGEME;
         SET @V_QTMOVANT     = @V_QTATUAL;

         /*Para calculo do valor sem logistica no ajuste*/

         IF (@V_VRCUSTLOGEME+@V_VRCUSTSEGEME) > 0 BEGIN
            SET @V_VRMOVSEGANT = @V_VRCUSTLOGEME;
            SET @V_VRMOVLOGANT = @V_VRCUSTSEGEME;
         END;

         IF @V_VRATUAL > 0 BEGIN
            SET @V_VRMOVANT  = @V_VRATUAL;
         END;

         IF ISNULL(@P_MOVCONSOLID,'N') = 'S' BEGIN
            EXEC TEKNISA.CALCULA_SALDO_ANTERIOR @V_CDFILLANCMEST, @V_NRLANCMOVIEST,
                                                @V_CDFILIMOVIEST, @V_MOVCDPRODUTO,
                                                @V_CDALMOXARIRM,  @V_CDLOCALESTRM,
                                                @V_NRLOTEESTQME,  @V_NRSUBLOTEME,
                                                @V_DTLANCMOVIEST, 'S',
                                                @P_QTESTOQDIA  = @V_QTDEAJUSTE OUTPUT,
                                                @P_VRESTOQDIA  = @V_VLRESTOAJU OUTPUT,
                                                @P_VRESTOQBRUT = @V_VLRBRUTAJU OUTPUT,
                                                @P_QTESTOQANT  = @V_VRQTANT    OUTPUT,
                                                @P_VRESTANT    = @V_VRESTOANT  OUTPUT;

            IF (@V_QTMOVI <> 0)  OR (@V_CDTIPOOPERME = '03') BEGIN
               IF @V_QTDEAJUSTE <> 0 BEGIN

                  IF (@V_TIPCUSTEST <> 3) BEGIN
                     SET @V_VRATUAL = @V_VRATUAL - (@V_QTMOVI * @V_CUSTESTOQ);
                     SET @V_CUSTMED = @V_CUSTESTOQ;
                  END
                  ELSE BEGIN
                     IF @P_IDCUSTO = 1 BEGIN
                        SET @V_VRATUAL = @V_VRATUAL - (@V_QTMOVI * (@V_VLRESTOAJU/@V_QTDEAJUSTE));
                        SET @V_CUSTMED = @V_VLRESTOAJU/@V_QTDEAJUSTE;
                     END
                     ELSE IF @P_IDCUSTO = 2 BEGIN
                        SET @V_VRATUAL = @V_VRATUAL - (@V_QTMOVI * (@V_VLRBRUTAJU/@V_QTDEAJUSTE));
                        SET @V_CUSTMED = @V_VLRBRUTAJU/@V_QTDEAJUSTE;
                     END;
                     SET @V_QTATUAL = @V_QTATUAL - @V_QTMOVI;
                  END;
               END
               ELSE BEGIN
                  IF @V_VLRESTOAJU <> 0 BEGIN
                     IF @V_QTATUAL <> 0 BEGIN
                        SET @V_VRCUSTLOGEME = @V_VRCUSTLOGEME - ((@V_VRCUSTLOGEME/@V_QTATUAL) * @V_QTMOVI);
                        SET @V_VRCUSTSEGEME = @V_VRCUSTSEGEME - ((@V_VRCUSTSEGEME/@V_QTATUAL) * @V_QTMOVI);
                     END;
                     IF @P_IDCUSTO = 1 BEGIN
                        SET @V_CUSTMED = @V_VLRESTOAJU;
                     END
                     ELSE BEGIN
                        SET @V_CUSTMED = @V_VLRBRUTAJU;
                     END;
                  END
                  ELSE BEGIN
                     SET @V_CUSTMED = 0;
                  END;

                  SET @V_VRATUAL = @V_VRATUAL - (@V_CUSTMED * @V_QTMOVI);
                  SET @V_QTATUAL = @V_QTATUAL - @V_QTMOVI;
               END;
               IF @V_QTATUAL = 0 BEGIN
                  SET @V_DIFCUSTSAI = @V_CUSTOANTCONS;
               END;
            END
            ELSE BEGIN
               SET @V_CUSTMED = 0;
            END;
         END
         ELSE BEGIN

            IF @V_QTATUAL <> 0 BEGIN

               SET @V_VRCUSTLOGEME = @V_VRCUSTLOGEME - ((@V_VRCUSTLOGEME/@V_QTATUAL) * @V_QTMOVI);
               SET @V_VRCUSTSEGEME = @V_VRCUSTSEGEME - ((@V_VRCUSTSEGEME/@V_QTATUAL) * @V_QTMOVI);

               IF (@V_TIPCUSTEST <> 3) BEGIN
                  SET @V_CUSTMED = @V_CUSTESTOQ;
               END
               ELSE BEGIN
                  SET @V_CUSTMED = @V_VRATUAL/@V_QTATUAL;
               END;

            END
            ELSE BEGIN
               SET @V_CUSTMED = 0;
            END;

            IF ((@V_QTATUAL - @V_QTMOVI) < 0) AND (@V_QTATUAL <= 0) BEGIN
               SET @V_CUSTMED = @V_CUSTZERO;
            END;

            SET @V_VRANTEST = @V_VRATUAL;
            SET @V_QTATUAL  = @V_QTATUAL - @V_QTMOVI;

            SET @V_VRATUAL  = @V_QTATUAL * @V_CUSTMED;

            IF ABS(@V_ULTCUSTENT - @V_CUSTMED) > 0.0001 BEGIN /*Alterado por problemas com varivel numrica em SQLSERVER, qdo valores decimais*/
               IF @V_QTMOVI > 0 BEGIN
                  SET @V_DIFCUSTSAI = (@V_VRANTEST - @V_VRATUAL)/@V_QTMOVI;
               END;
               SET @V_ULTCUSTENT  = @V_CUSTMED;
            END;
         END;
      END
      ELSE IF @V_IDTIPOMOVIEST = '5' BEGIN
         IF (@V_QTATUAL <> 0) BEGIN
            SET @V_CUSTOMEDIO   = @V_VRATUAL/@V_QTATUAL;
         END;
         SET @V_VRCUSTLOGANT = @V_VRCUSTLOGEME;
         SET @V_VRCUSTSEGANT = @V_VRCUSTSEGEME;
         SET @V_VRANTEST     = @V_VRATUAL;
         SET @V_QTMOVI  = @V_QTLANCMOVIEST;

         IF ISNULL(@P_MOVCONSOLID,'N') = 'S' BEGIN
            EXEC TEKNISA.CALCULA_SALDO_ANTERIOR @V_CDFILLANCMEST, @V_NRLANCMOVIEST,
                                                @V_CDFILIMOVIEST, @V_MOVCDPRODUTO,
                                                @V_CDALMOXARIRM,  @V_CDLOCALESTRM,
                                                @V_NRLOTEESTQME,  @V_NRSUBLOTEME,
                                                @V_DTLANCMOVIEST, 'S',
                                                @P_QTESTOQDIA  = @V_QTDEAJUSTE OUTPUT,
                                                @P_VRESTOQDIA  = @V_VLRESTOAJU OUTPUT,
                                                @P_VRESTOQBRUT = @V_VLRBRUTAJU OUTPUT,
                                                @P_QTESTOQANT  = @V_VRQTANT    OUTPUT,
                                                @P_VRESTANT    = @V_VRESTOANT  OUTPUT;

            IF @P_IDCUSTO = 1 BEGIN
               SET @V_CUSTMED =  @V_VLRESTOAJU;
            END
            ELSE BEGIN
              SET  @V_CUSTMED = @V_VLRBRUTAJU;
            END;
         END
         ELSE BEGIN

            IF @V_QTATUAL <> 0 BEGIN
               IF @P_IDCUSTO = 1 BEGIN
                  IF (@V_VRATUAL - (@V_QTMOVI * @V_VRLANCMOVIEST)) >= 0 BEGIN
                     SET @V_CUSTMED = @V_VRLANCMOVIEST;
                  END
                  ELSE BEGIN
                     IF (@V_VRATUAL - (@V_QTMOVI * @V_CUSTMED)) < 0 BEGIN
                        SET @V_CUSTMED = @V_VRATUAL / @V_QTATUAL;
                     END;
                  END;
               END
               ELSE IF @P_IDCUSTO = 2  BEGIN
                  IF (@V_VRATUAL - (@V_QTMOVI * @V_VRBRUTMOVIEST)) >= 0 BEGIN
                     SET @V_CUSTMED = @V_VRBRUTMOVIEST;
                  END
                  ELSE BEGIN
                     IF (@V_VRATUAL - (@V_QTMOVI * @V_CUSTMED)) < 0 BEGIN
                        SET @V_CUSTMED = @V_VRATUAL / @V_QTATUAL;
                     END;
                  END;
               END;
            END
            ELSE BEGIN

               SELECT @V_CUSTMED = TEKNISA.CUSTO_PRODUTO_LCEST(@P_FILIAL, @V_CDPRODESTO, @V_TIPCUSTEST, @V_DTLANCMOVIEST , @V_DATAPROC,
                                                                @V_CDALMOXARIRM, @V_CDLOCALESTRM, @V_NRLOTEESTQME, @V_NRSUBLOTEME)            
            END;
         END;

         SET @V_QTATUAL = @V_QTATUAL - @V_QTMOVI;

         /*Se o custo da devoluo for diferente do custo mdio no dia,
          guarda o valor do custo mdio para depois calcular a diferena*/
         IF (@V_ULTCUSTENT <> @V_CUSTMED) AND ((@V_VRATUAL - (@V_QTMOVI * @V_VRLANCMOVIEST)) >= 0)  BEGIN
            IF @V_QTMOVI > 0 BEGIN
               SET @V_DIFCUSTSAI = @V_ULTCUSTENT;
            END;
         END;

         IF(@V_VRLANCMOVIEST*@V_QTMOVI > @V_VRATUAL) BEGIN
            SET @V_CUSTMED = @V_CUSTOMEDIO;
         END
         ELSE BEGIN
            IF  @P_IDCUSTO = 2 BEGIN
               SET @V_CUSTMED = @V_VRBRUTMOVIEST;
            END
            ELSE BEGIN
               SET @V_CUSTMED = @V_VRLANCMOVIEST;
            END;
         END;

         IF @V_QTMOVI = 0 BEGIN
            SET @V_VRATUAL = @V_VRATUAL - @V_CUSTMED;
         END
         ELSE BEGIN
            SET @V_VRATUAL = @V_VRATUAL - (@V_QTMOVI * @V_CUSTMED);
         END;

         IF (@V_QTATUAL = 0) AND (@V_VRATUAL < 0) BEGIN
            IF (@V_QTMOVI <> 0) BEGIN
               SET @V_CUSTMED = @V_CUSTMED + (@V_VRATUAL/@V_QTMOVI);
            END;
         END;
      END;

      IF @V_QTATUAL = 0 BEGIN
         IF @V_CUSTMEES <> 0 BEGIN
            SET @V_CUSTZERO = @V_CUSTMEES;
         END;

         IF @V_CUSTZERO = 0 BEGIN
            SET @V_CUSTZERO = @V_VRCUSTMEES;
         END;
      END;

      IF @V_IDTIPOMOVIEST <> '-' BEGIN
         IF @V_QTATUAL = 0 BEGIN
            SET @V_CUSTMEES = 0;
         END
         ELSE BEGIN
            IF @V_TIPCUSTEST = 3 BEGIN
               IF (@V_QTATUAL <> 0) BEGIN
                  SET @V_CUSTMEES = @V_VRATUAL/@V_QTATUAL;
               END;
            END
            ELSE BEGIN
                SET @V_CUSTMEES =  TEKNISA.CUSTO_PRODUTO_LCEST(@P_FILIAL, @V_CDPRODESTO, @V_TIPCUSTEST, @V_DTLANCMOVIEST, @V_DATAPROC,
                                                 @V_CDALMOXARIRM, @V_CDLOCALESTRM, @V_NRLOTEESTQME, @V_NRSUBLOTEME);
            END;
         END;
      END;

      IF @V_QTATUAL = 0 BEGIN
         SET @V_VRATUAL = 0;
      END;

      IF (@V_QTATUAL <> 0) BEGIN
         SET @V_CUSTZERO = @V_CUSTMED;
      END;

      UPDATE RELAT_MOVIEST
         SET QTLANCAMENTO = @V_QTMOVI,
             VRCUSTMEDI = @V_CUSTMED,
             VRCUSTMOVIEST = @V_VRATUAL,
             QTDEMOVIEST = @V_QTATUAL,
             VRCUSTMEES = @V_CUSTMEES,
             VRDIFECUST = CASE @V_IDTIPOMOVIEST WHEN '1' THEN  (@V_QTMOVI * @V_CUSTMED) ELSE (@V_VRATUAL - @V_CUSTANT) END,
             VRTOTALANT = @V_CUSTANT,
             QTTOTALANT = @V_QTDEANT,
             VRCUSTLOGEME = @V_VRCUSTLOGEME,
             VRCUSTSEGEME = @V_VRCUSTSEGEME,
             VRDIFCUSTEME = ISNULL(@V_DIFCUSTSAI,0)
       WHERE NRRELATMOVI = @P_SEQUMOVI
         AND CDFILIMOVIEST = @P_FILIAL
         AND CDFILLANCMEST = @V_CDFILLANCMEST 
         AND NRLANCMOVIEST = @V_NRLANCMOVIEST 
         AND NRSEQUMOVIEST = @V_NRSEQUMOVIEST 
         AND CDPRODMOVIEST = @V_CDPRODMOVIEST 
         AND DTLANCMOVIEST = @V_DTLANCMOVIEST 
         AND CDALMOXARIRM = @V_CDALMOXARIRM  
         AND CDLOCALESTRM = @V_CDLOCALESTRM  
         AND NRLOTEESTQME = @V_NRLOTEESTQME  
         AND NRSUBLOTEME  = @V_NRSUBLOTEME
         AND CDFILLANCMEST =@V_CDFILLANCMEST 
         AND IDTIPOMOVIEST =@V_IDTIPOMOVIEST;

---------------------------------------------------------------------------------
-- ATUALIZA TABELA DE DESCRICAO DOS LANCAMENTOS                                --
---------------------------------------------------------------------------------
      IF (ISNULL(@P_DELMOVIMEN, 'S') = 'S') BEGIN
         IF @V_IDTIPOMOVIEST <> '-' BEGIN
            IF @P_IDLANCTO = 1 BEGIN   --GERAL
               SELECT @V_COUNT = COUNT(NRLANCDESCMOVI)
               FROM RELAT_DESCMOVI
               WHERE CDFILLANCDMOVI = @V_CDFILLANCMEST AND
                     NRLANCDESCMOVI = @V_NRLANCMOVIEST AND
                     CDPRODDESCMOVI = ' '              AND
                     NRRELATDESC    = @P_SEQUMOVI;

               IF @V_COUNT = 0 BEGIN
                  INSERT INTO RELAT_DESCMOVI
                  (DTLANCDESCMOVI, IDTIPODESCMOVI, CDFILLANCDMOVI,
                   NRLANCDESCMOVI, CDPRODDESCMOVI, NRRELATDESC)
                  VALUES
                  (@V_DTLANCMOVIEST, @V_IDTIPOMOVIEST,
                   @V_CDFILLANCMEST, @V_NRLANCMOVIEST, ' ', @P_SEQUMOVI);
               END;
            END
            ELSE IF @P_IDLANCTO = 2 BEGIN --QUEBRA POR PRODUTO
               SELECT @V_COUNT = COUNT(NRLANCDESCMOVI)
               FROM RELAT_DESCMOVI
               WHERE CDFILLANCDMOVI = @V_CDFILLANCMEST AND
                     NRLANCDESCMOVI = @V_NRLANCMOVIEST AND
                     CDPRODDESCMOVI = @V_CDPRODMOVIEST AND
                     NRRELATDESC    = @P_SEQUMOVI;

               IF @V_COUNT = 0 BEGIN
                  INSERT INTO RELAT_DESCMOVI
                  (DTLANCDESCMOVI, IDTIPODESCMOVI, CDFILLANCDMOVI, NRLANCDESCMOVI,
                   CDPRODDESCMOVI, NMPRODDESCMOVI, NRRELATDESC)
                  VALUES
                  (@V_DTLANCMOVIEST, @V_IDTIPOMOVIEST, @V_CDFILLANCMEST,
                   @V_NRLANCMOVIEST, @V_CDPRODMOVIEST, @V_NMPRODMOVIEST, @P_SEQUMOVI);
               END;
            END;
         END;
      END;

      SET @V_CUSTANT    = @V_VRATUAL;
      SET @V_QTDEANT    = @V_QTATUAL;
      SET @V_CDPRODUTO  = @V_CDPRODMOVIEST;
      SET @V_NRLOTEESTQ = @V_NRLOTEESTQME;
      SET @V_NRSUBLOTE  = @V_NRSUBLOTEME;
      SET @V_CDALMOXLCEST = @V_CDALMOXARIRM+@V_CDLOCALESTRM;

      FETCH NEXT FROM C_MOVIMENTA INTO @V_NRRELATMOVI,   @V_CDFILIMOVIEST, @V_CDFILLANCMEST, @V_NRLANCMOVIEST, @V_NRSEQUMOVIEST,
                                       @V_NRLOTEESTQME,  @V_NRSUBLOTEME,   @V_CDPRODMOVIEST, @V_DTLANCMOVIEST, @V_CDALMOXARIRM,
                                       @V_CDLOCALESTRM,  @V_IDTIPOMOVIEST, @V_QTDEMOVIEST,   @V_VRCUSTMEDI,    @V_VRCUSTMOVIEST,
                                       @V_QTLANCAMENTO,  @V_VRCUSTBRUT,    @V_VRCUSTMEES,    @V_VRCUSTMEBR,    @V_QTLANCMOVIEST,
                                       @V_VRLANCMOVIEST, @V_VRBRUTMOVIEST, @V_CDTOTMOVIEST,  @V_NMPRODMOVIEST, @V_IDORDEMCALC,
                                       @V_IDALTCMEDMOV,  @V_VRDIFECUST,    @V_VRUNILANCEST,  @V_VRTOTLANCEST,  @V_QTTOTALANT,
                                       @V_VRTOTALANT,    @V_VRCUSTENTRME,  @V_SGUNIDMOVI,    @V_IDENTRSAIDME,  @V_CDTIPOOPERME,
                                       @V_CDTIPORETIME,  @V_NMTIPORETIME,  @V_MOVCDPRODUTO,  @V_VRCUSTLOGEME,   @V_VRCUSTSEGEME,
                                       @V_VRPESOBRUTME,  @V_VRCUSTLOGLME,  @V_VRCUSTSEGLME;
   END;

   CLOSE C_MOVIMENTA;
   DEALLOCATE C_MOVIMENTA;

---------------------------------------------------------------------------------
-- ATUALIZA TABELA DE TOTALIZACAO                                              --
---------------------------------------------------------------------------------
   SET @V_INSERT = '1';
   IF  (ISNULL(@P_DELMOVIMEN, 'S') = 'S') BEGIN
      DECLARE C_TOTALMOVI CURSOR FOR
         (SELECT CDTOTMOVIEST, IDTIPOMOVIEST,
                 SUM(QTLANCAMENTO * (CASE 0 WHEN  0 THEN  VRCUSTMEDI ELSE VRDIFCUSTEME END )) +
                 SUM((CASE QTLANCAMENTO WHEN  0 THEN(CASE IDTIPOMOVIEST WHEN  '-' THEN ISNULL(VRCUSTLOGEME,0)+ISNULL(VRCUSTSEGEME,0) ELSE 0 END) ELSE 0 END)) AS VRCUSTTOTAL,
                 SUM(QTLANCAMENTO) AS VRQTDETOTAL,
                 CDTIPORETIME, NMTIPORETIME, IDENTRSAIDME, CDTIPOOPERME,
                 SUM(CASE IDTIPOMOVIEST WHEN '-' THEN VRCUSTLOGEME ELSE 0 END)  AS VRCUSTLOGLME,
                 SUM(CASE IDTIPOMOVIEST WHEN '-' THEN VRCUSTSEGEME ELSE 0 END)  AS VRCUSTSEGLME,
                 SUM(VRDIFCUSTEME) VRDIFCUSTEME,
                 SUM(ISNULL(CASE VRDIFCUSTEME WHEN 0 THEN 0 ELSE (VRCUSTMEDI*QTLANCAMENTO)-(VRDIFCUSTEME*QTLANCAMENTO)END,0)) AS VRDIFCUSSAID
            FROM RELAT_MOVIEST
           WHERE NOT(IDTIPOMOVIEST IN ('0','1','2')) 
             AND NRRELATMOVI = @P_SEQUMOVI
           GROUP BY CDTOTMOVIEST, IDTIPOMOVIEST, CDTIPORETIME, NMTIPORETIME, IDENTRSAIDME, CDTIPOOPERME)
           UNION ALL
         (SELECT CDTOTMOVIEST, IDTIPOMOVIEST,
                 SUM(VRDIFECUST)   AS VRCUSTTOTAL,
                 SUM(QTLANCAMENTO) AS VRQTDETOTAL,
                 CDTIPORETIME, NMTIPORETIME, IDENTRSAIDME, CDTIPOOPERME,
                 0 AS VRCUSTLOGLME,
                 0 AS VRCUSTSEGLME,
                 SUM(VRDIFCUSTEME) VRDIFCUSTEME,
                 SUM(VRDIFCUSTEME)  AS VRDIFCUSSAID
            FROM RELAT_MOVIEST
           WHERE IDTIPOMOVIEST IN ('0','1')
             AND NRRELATMOVI  =  @P_SEQUMOVI
           GROUP BY CDTOTMOVIEST, IDTIPOMOVIEST, CDTIPORETIME, NMTIPORETIME, IDENTRSAIDME, CDTIPOOPERME)
           UNION ALL
         (SELECT CDTOTMOVIEST, IDTIPOMOVIEST,
                 SUM(VRCUSTENTRME) AS VRCUSTTOTAL,
                 SUM(QTLANCAMENTO) AS VRQTDETOTAL,
                 CDTIPORETIME, NMTIPORETIME, IDENTRSAIDME, CDTIPOOPERME,
                 SUM(VRCUSTLOGLME) AS VRCUSTLOGLME,
                 SUM(VRCUSTSEGLME) AS VRCUSTSEGLME,
                 SUM(VRDIFCUSTEME) VRDIFCUSTEME,
                 SUM(VRDIFCUSTEME) AS VRDIFCUSSAID
            FROM RELAT_MOVIEST
           WHERE IDTIPOMOVIEST = '2'
             AND NRRELATMOVI = @P_SEQUMOVI 
             AND ((@P_IDCUSTO = '1') AND (@V_TIPCUSTEST <> 4) AND (@V_TIPCUSTEST <> 43))
             AND QTLANCAMENTO  > 0
           GROUP BY CDTOTMOVIEST, IDTIPOMOVIEST, CDTIPORETIME, NMTIPORETIME, IDENTRSAIDME, CDTIPOOPERME
           UNION ALL
          SELECT CDTOTMOVIEST, IDTIPOMOVIEST,
                 SUM(CASE @V_TIPCUSTEST WHEN 3 THEN QTLANCMOVIEST * VRBRUTMOVIEST ELSE
                     CASE @V_TIPCUSTEST WHEN 4 THEN QTLANCMOVIEST * VRBRUTMOVIEST ELSE
                     CASE @V_TIPCUSTEST WHEN 43 THEN QTLANCMOVIEST * VRBRUTMOVIEST ELSE
                     VRCUSTENTRME END END END) AS VRCUSTTOTAL,
                 SUM(QTLANCAMENTO) AS VRQTDETOTAL,
                 CDTIPORETIME, NMTIPORETIME, IDENTRSAIDME, CDTIPOOPERME,
                 SUM(VRCUSTLOGLME) AS VRCUSTLOGLME,
                 SUM(VRCUSTSEGLME) AS VRCUSTSEGLME,
                 SUM(VRDIFCUSTEME) VRDIFCUSTEME,
                 SUM(CASE @V_TIPCUSTEST WHEN 3 THEN 0 ELSE VRDIFCUSTEME END) AS VRDIFCUSSAID
            FROM RELAT_MOVIEST
           WHERE IDTIPOMOVIEST = '2'
             AND NRRELATMOVI = @P_SEQUMOVI
             AND ((@P_IDCUSTO  = '2') OR (@V_TIPCUSTEST = 4) OR (@V_TIPCUSTEST = 43)) 
             AND QTLANCAMENTO  > 0
           GROUP BY CDTOTMOVIEST, IDTIPOMOVIEST, CDTIPORETIME, NMTIPORETIME, IDENTRSAIDME, CDTIPOOPERME)
           UNION ALL
          SELECT CDTOTMOVIEST, IDTIPOMOVIEST,
                 SUM((CASE QTDEMOVIEST WHEN 0 THEN (CASE CDTIPORETIME WHEN '03' THEN VRCUSTMEDI ELSE 0 END)  ELSE VRCUSTMEDI END)) AS VRCUSTTOTAL,
                 SUM(QTLANCAMENTO) AS VRQTDETOTAL,
                 CDTIPORETIME, NMTIPORETIME, IDENTRSAIDME, CDTIPOOPERME,
                 SUM(VRCUSTLOGLME) AS VRCUSTLOGLME,
                 SUM(VRCUSTSEGLME) AS VRCUSTSEGLME,
                 SUM(VRDIFCUSTEME) VRDIFCUSTEME,
                 0 AS VRDIFCUSSAID
            FROM RELAT_MOVIEST
           WHERE IDTIPOMOVIEST = '2'
             AND NRRELATMOVI = @P_SEQUMOVI  
             AND QTLANCAMENTO  = 0
           GROUP BY CDTOTMOVIEST, IDTIPOMOVIEST, CDTIPORETIME, NMTIPORETIME, IDENTRSAIDME, CDTIPOOPERME

      OPEN C_TOTALMOVI;
      FETCH NEXT FROM C_TOTALMOVI INTO @V_CDTOTMOVIEST, @V_IDTIPOMOVIEST, @V_VRCUSTTOTAL,
                                       @V_VRQTDETOTAL,  @V_CDTIPORETIME,  @V_NMTIPORETIME,
                                       @V_IDENTRSAIDME, @V_CDTIPOOPERME,  @V_VRCUSTLOGLME, @V_VRCUSTSEGLME,
                                       @V_VRDIFCUSTEME, @V_VRDIFCUSSAID;
      WHILE (@@FETCH_STATUS = 0)   BEGIN

         SELECT @V_COUNT = COUNT(*)
           FROM RELAT_TOTAMOVI
          WHERE CDPRODTOTAMOVI = @V_CDTOTMOVIEST AND
                NRRELATTOTA = @P_SEQUMOVI;

         SET @V_SGUNIDADE = 'X';

         SELECT @V_TAMARV = LEN(MAX(CDARVPROD))
           FROM PRODUTO;

         DECLARE C_UNIDADE CURSOR FOR
            SELECT SGUNIDMOVI
              FROM RELAT_MOVIEST
             WHERE NRRELATMOVI  = @P_SEQUMOVI 
               AND CDTOTMOVIEST = @V_CDTOTMOVIEST
             GROUP BY SGUNIDMOVI
         OPEN C_UNIDADE;
         FETCH NEXT FROM C_UNIDADE INTO @V_SGUNIDMOVI;

         WHILE (@@FETCH_STATUS = 0) BEGIN
            IF @V_SGUNIDADE = 'X' BEGIN
               SET @V_SGUNIDADE = @V_SGUNIDMOVI;
            END
            ELSE BEGIN
               IF @V_SGUNIDADE <> @V_SGUNIDMOVI BEGIN
                  IF (@P_TAMNIVEL <> @V_TAMARV) BEGIN
                     SET @V_SGUNIDADE = ' ';
                  END;
               END;
            END;
            FETCH NEXT FROM C_UNIDADE INTO @V_SGUNIDMOVI;
         END;

         CLOSE C_UNIDADE;
         DEALLOCATE C_UNIDADE;

         IF @V_SGUNIDADE = 'X' BEGIN
            SET @V_SGUNIDADE = ' ';
         END;

         IF (@V_SGUNIDADE <> ' ') OR (@V_TAMARV = @P_TAMNIVEL) BEGIN
            SET @V_VALORQTTOT = @V_VRQTDETOTAL;
         END
         ELSE BEGIN
            SET @V_VALORQTTOT = 0;
         END;

         IF @V_COUNT = 0 BEGIN
            INSERT INTO RELAT_TOTAMOVI
               (IDTIPOTOTAMOVI, CDPRODTOTAMOVI, VRSOMPINI, VRSOMAINV, VRSOMINVE,
                VRSOMENTR, VRSOMRETI, VRSOMSAID, VRSOMDFOR, VRSOMSATU, NRRELATTOTA,
                VRQTDEPINIME, VRQTDEAINVME, VRQTDEINVEME, VRQTDEENTRME, VRQTDERETIME,
                VRQTDESAIDME, VRQTDEDFORME, VRQTDESATUME, VRSOMCUSTLOG, VRSOMCUSTSEG,
                VRSOMDIFSAID)
            VALUES
               ('P', @V_CDTOTMOVIEST, 0, 0, 0, 0, 0, 0, 0, 0, @P_SEQUMOVI,
                0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
         END;

         IF @V_INSERT = '1' BEGIN

            SET @V_INSERT = '2';

            INSERT INTO RELAT_ANALMOVI
               (NRRELATANAL, CDTIPORETIAN, NMTIPORETIAN, IDENTRSAIDAN, CDTIPOOPERAN,
                IDSALDOESTAN, VRSALDOESTAN, QTSALDOESTAN)
            VALUES
               (@P_SEQUMOVI, '-', '-', '-', '-', 'SA', 0, 0);

            INSERT INTO RELAT_ANALMOVI
               (NRRELATANAL, CDTIPORETIAN, NMTIPORETIAN, IDENTRSAIDAN, CDTIPOOPERAN,
                IDSALDOESTAN, VRSALDOESTAN, QTSALDOESTAN)
            VALUES
               (@P_SEQUMOVI, '-', '-','-', '-', 'SI', 0, 0);

            INSERT INTO RELAT_ANALMOVI
               (NRRELATANAL, CDTIPORETIAN, NMTIPORETIAN, IDENTRSAIDAN, CDTIPOOPERAN,
                IDSALDOESTAN, VRSALDOESTAN, QTSALDOESTAN)
            VALUES
               (@P_SEQUMOVI, '-', '-', '-', '-', 'SJ', 0, 0);

            INSERT INTO RELAT_ANALMOVI
               (NRRELATANAL, CDTIPORETIAN, NMTIPORETIAN, IDENTRSAIDAN, CDTIPOOPERAN,
                IDSALDOESTAN, VRSALDOESTAN, QTSALDOESTAN)
            (SELECT NRRELATMOVI, '-', '-', ISNULL(IDENTRSAIDME,'-'), ISNULL(CDTIPOOPERME,'-'),'SE', 0, 0
              FROM RELAT_MOVIEST
              WHERE IDTIPOMOVIEST   =  '2'       AND
                    NRRELATMOVI     =  @P_SEQUMOVI
              GROUP BY NRRELATMOVI,  ISNULL(IDENTRSAIDME,'-'), ISNULL(CDTIPOOPERME,'-'));

              INSERT INTO RELAT_ANALMOVI
               (NRRELATANAL, CDTIPORETIAN, NMTIPORETIAN, IDENTRSAIDAN, CDTIPOOPERAN,
                IDSALDOESTAN, VRSALDOESTAN, QTSALDOESTAN)
               VALUES
               (@P_SEQUMOVI, '-', '-', '-', '-', 'SP', 0, 0);

            INSERT INTO RELAT_ANALMOVI
               (NRRELATANAL, CDTIPORETIAN, NMTIPORETIAN, IDENTRSAIDAN, CDTIPOOPERAN,
                IDSALDOESTAN, VRSALDOESTAN, QTSALDOESTAN)
            (SELECT NRRELATMOVI, ISNULL(CDTIPORETIME,'-'), ISNULL(NMTIPORETIME,'-'),
                    '-', '-', 'SR', 0, 0
              FROM RELAT_MOVIEST
              WHERE IDTIPOMOVIEST = '3' AND
                    NRRELATMOVI  =  @P_SEQUMOVI
              GROUP BY NRRELATMOVI, ISNULL(CDTIPORETIME,'-'), ISNULL(NMTIPORETIME,'-'));

            INSERT INTO RELAT_ANALMOVI
               (NRRELATANAL, CDTIPORETIAN, NMTIPORETIAN, IDENTRSAIDAN, CDTIPOOPERAN,
                IDSALDOESTAN, VRSALDOESTAN, QTSALDOESTAN)
            (SELECT NRRELATMOVI, '-', '-', ISNULL(IDENTRSAIDME,'-'), ISNULL(CDTIPOOPERME,'-'), 'SS', 0, 0
              FROM RELAT_MOVIEST
              WHERE (IDTIPOMOVIEST = '4' OR  IDTIPOMOVIEST = '5') AND
                     NRRELATMOVI  =  @P_SEQUMOVI
              GROUP BY NRRELATMOVI, ISNULL(IDENTRSAIDME,'-'), ISNULL(CDTIPOOPERME,'-'));


            INSERT INTO RELAT_ANALMOVI
               (NRRELATANAL, CDTIPORETIAN, NMTIPORETIAN,  IDENTRSAIDAN, CDTIPOOPERAN,
                IDSALDOESTAN, VRSALDOESTAN, QTSALDOESTAN)
            VALUES
               (@P_SEQUMOVI, '-', '-', '-', '-', 'ST',0, 0);

            INSERT INTO RELAT_ANALMOVI
               (NRRELATANAL, CDTIPORETIAN, NMTIPORETIAN, IDENTRSAIDAN, CDTIPOOPERAN,
                IDSALDOESTAN, VRSALDOESTAN, QTSALDOESTAN)
            VALUES
               (@P_SEQUMOVI, '-', '-', '-', '-', 'SL', 0, 0);

            INSERT INTO RELAT_ANALMOVI
               (NRRELATANAL, CDTIPORETIAN, NMTIPORETIAN, IDENTRSAIDAN, CDTIPOOPERAN,
                IDSALDOESTAN, VRSALDOESTAN, QTSALDOESTAN)
            VALUES
               (@P_SEQUMOVI, '-', '-', '-', '-', 'SG', 0, 0);
         END;

         IF (@V_IDTIPOMOVIEST = '-') AND (@V_VRCUSTTOTAL <> 0) BEGIN
            UPDATE RELAT_TOTAMOVI
               SET VRSOMPINI = VRSOMPINI + @V_VRCUSTTOTAL,
                   VRSOMSATU = VRSOMSATU + @V_VRCUSTTOTAL,
                   VRQTDEPINIME = VRQTDEPINIME + @V_VRQTDETOTAL,
                   VRQTDESATUME = VRQTDESATUME + @V_VRQTDETOTAL,
                   SGUNIDTOTAME = @V_SGUNIDADE
             WHERE CDPRODTOTAMOVI = @V_CDTOTMOVIEST 
               AND NRRELATTOTA = @P_SEQUMOVI;
         END;

         IF (@V_IDTIPOMOVIEST = '0') BEGIN
            UPDATE RELAT_TOTAMOVI
               SET VRSOMINVE = VRSOMINVE + @V_VRCUSTTOTAL,
                   VRSOMSATU = VRSOMSATU + @V_VRCUSTTOTAL,
                   VRQTDEINVEME = VRQTDEINVEME + @V_VRQTDETOTAL,
                   VRQTDESATUME = VRQTDESATUME + @V_VRQTDETOTAL,
                   SGUNIDTOTAME = @V_SGUNIDADE
             WHERE CDPRODTOTAMOVI = @V_CDTOTMOVIEST 
               AND NRRELATTOTA    = @P_SEQUMOVI;
         END;

         IF (@V_IDTIPOMOVIEST = '1') AND (@V_VRCUSTTOTAL <> 0) BEGIN
            UPDATE RELAT_TOTAMOVI
               SET VRSOMAINV = VRSOMAINV + @V_VRCUSTTOTAL,
                   VRSOMSATU = VRSOMSATU + @V_VRCUSTTOTAL+ ISNULL(@V_VRDIFCUSSAID,0),
                   VRQTDEAINVME = VRQTDEAINVME + @V_VRQTDETOTAL,
                   VRQTDESATUME = VRQTDESATUME + @V_VRQTDETOTAL,
                   SGUNIDTOTAME = @V_SGUNIDADE,
                   VRSOMDIFSAID = VRSOMDIFSAID + @V_VRDIFCUSSAID
             WHERE CDPRODTOTAMOVI = @V_CDTOTMOVIEST 
               AND NRRELATTOTA = @P_SEQUMOVI;
         END;

         IF (@V_IDTIPOMOVIEST = '2') BEGIN
            UPDATE RELAT_TOTAMOVI
               SET VRSOMENTR = VRSOMENTR + @V_VRCUSTTOTAL,
                   VRSOMSATU = VRSOMSATU + @V_VRCUSTTOTAL+ @V_VRCUSTLOGLME+ @V_VRCUSTSEGLME + @V_VRDIFCUSSAID,
                   VRQTDEENTRME = VRQTDEENTRME + @V_VRQTDETOTAL,
                   VRQTDESATUME = VRQTDESATUME + @V_VRQTDETOTAL,
                   SGUNIDTOTAME = @V_SGUNIDADE,
                   VRSOMCUSTLOG = VRSOMCUSTLOG + @V_VRCUSTLOGLME,
                   VRSOMCUSTSEG = VRSOMCUSTSEG + @V_VRCUSTSEGLME,
                   VRSOMDIFSAID = VRSOMDIFSAID + @V_VRDIFCUSSAID
             WHERE CDPRODTOTAMOVI = @V_CDTOTMOVIEST 
               AND NRRELATTOTA = @P_SEQUMOVI;
         END;

         IF (@V_IDTIPOMOVIEST = '3') AND (@V_VRCUSTTOTAL <> 0) BEGIN
            UPDATE RELAT_TOTAMOVI
               SET VRSOMRETI = VRSOMRETI + @V_VRCUSTTOTAL,
                   VRSOMSATU = (VRSOMSATU - @V_VRCUSTTOTAL)+ @V_VRDIFCUSSAID,
                   VRQTDERETIME = VRQTDERETIME + @V_VRQTDETOTAL,
                   VRQTDESATUME = VRQTDESATUME - @V_VRQTDETOTAL,
                   SGUNIDTOTAME = @V_SGUNIDADE
             WHERE CDPRODTOTAMOVI = @V_CDTOTMOVIEST 
               AND NRRELATTOTA = @P_SEQUMOVI;
         END;

         IF (@V_IDTIPOMOVIEST = '4') AND (@V_VRCUSTTOTAL <> 0) BEGIN
            UPDATE RELAT_TOTAMOVI
               SET VRSOMSAID = VRSOMSAID + @V_VRCUSTTOTAL,
                   VRSOMSATU = (VRSOMSATU - @V_VRCUSTTOTAL) + @V_VRCUSTLOGLME + @V_VRCUSTSEGLME + @V_VRDIFCUSSAID,
                   VRQTDESAIDME = VRQTDESAIDME + @V_VRQTDETOTAL,
                   VRQTDESATUME = VRQTDESATUME - @V_VRQTDETOTAL,
                   SGUNIDTOTAME = @V_SGUNIDADE,
                   VRSOMDIFSAID = VRSOMDIFSAID + @V_VRDIFCUSSAID
             WHERE CDPRODTOTAMOVI = @V_CDTOTMOVIEST 
               AND NRRELATTOTA = @P_SEQUMOVI;
         END;

         IF (@V_IDTIPOMOVIEST = '5') AND (@V_VRCUSTTOTAL <> 0) BEGIN
            UPDATE RELAT_TOTAMOVI
               SET VRSOMDFOR = VRSOMDFOR + @V_VRCUSTTOTAL,
                   VRSOMSATU = VRSOMSATU - @V_VRCUSTTOTAL,
                   VRQTDEDFORME = VRQTDEDFORME + @V_VRQTDETOTAL,
                   VRQTDESATUME = VRQTDESATUME - @V_VRQTDETOTAL,
                   SGUNIDTOTAME = @V_SGUNIDADE
             WHERE CDPRODTOTAMOVI = @V_CDTOTMOVIEST 
               AND NRRELATTOTA = @P_SEQUMOVI;
         END;

         --- Inserir total moviventao (Dados Anliticos) ---

         SET @V_VRSOMSATUAN  = 0;
         SET @V_VRQTDESATUAN = 0;

         -- Saldo Anterior

         IF (@V_IDTIPOMOVIEST = '-') AND (@V_VRCUSTTOTAL <> 0) BEGIN
            UPDATE RELAT_ANALMOVI
               SET VRSALDOESTAN = VRSALDOESTAN + @V_VRCUSTTOTAL,
                   QTSALDOESTAN = QTSALDOESTAN + @V_VRQTDETOTAL,
                   IDSALDOESTAN = 'SA'
             WHERE NRRELATANAL = @P_SEQUMOVI
               AND IDSALDOESTAN  = 'SA';

             SET @V_VRQTDESATUAN   = @V_VRQTDESATUAN + @V_VRQTDETOTAL;
             SET @V_VRSOMSATUAN    = @V_VRSOMSATUAN  + @V_VRCUSTTOTAL ;
         END;

         -- Saldo Implantacao

         IF (@V_IDTIPOMOVIEST = '0') BEGIN
            UPDATE RELAT_ANALMOVI
               SET VRSALDOESTAN = VRSALDOESTAN + @V_VRCUSTTOTAL,
                   QTSALDOESTAN = QTSALDOESTAN + @V_VRQTDETOTAL,
                   IDSALDOESTAN = 'SI'
             WHERE NRRELATANAL = @P_SEQUMOVI
               AND IDSALDOESTAN  = 'SI';

             SET @V_VRSOMSATUAN    = @V_VRSOMSATUAN  + @V_VRCUSTTOTAL;
             SET @V_VRQTDESATUAN   = @V_VRQTDESATUAN + @V_VRQTDETOTAL;
         END;

         -- Saldo Ajuste

         IF (@V_IDTIPOMOVIEST = '1') AND (@V_VRCUSTTOTAL <> 0) BEGIN
            UPDATE RELAT_ANALMOVI
               SET VRSALDOESTAN = VRSALDOESTAN + @V_VRCUSTTOTAL,
                   QTSALDOESTAN = QTSALDOESTAN + @V_VRQTDETOTAL,
                   IDSALDOESTAN = 'SJ'
             WHERE NRRELATANAL = @P_SEQUMOVI
               AND IDSALDOESTAN  = 'SJ';

            UPDATE RELAT_ANALMOVI
               SET VRSALDOESTAN = VRSALDOESTAN + @V_VRDIFCUSSAID
             WHERE NRRELATANAL = @P_SEQUMOVI 
               AND IDSALDOESTAN = 'SP';

             SET @V_VRSOMSATUAN = @V_VRSOMSATUAN  + @V_VRCUSTTOTAL+ ISNULL(@V_VRDIFCUSSAID,0);
             SET @V_VRQTDESATUAN = @V_VRQTDESATUAN + @V_VRQTDETOTAL;

         END;

         -- Saldo Entrada

         IF (@V_IDTIPOMOVIEST = '2') BEGIN

            UPDATE RELAT_ANALMOVI
               SET VRSALDOESTAN = VRSALDOESTAN + @V_VRCUSTTOTAL,
                   QTSALDOESTAN = QTSALDOESTAN + @V_VRQTDETOTAL,
                   IDSALDOESTAN = 'SE'
             WHERE NRRELATANAL = @P_SEQUMOVI
               AND IDSALDOESTAN = 'SE'
               AND IDENTRSAIDAN = @V_IDENTRSAIDME 
               AND CDTIPOOPERAN = @V_CDTIPOOPERME;

            UPDATE RELAT_ANALMOVI
               SET VRSALDOESTAN = VRSALDOESTAN + @V_VRDIFCUSSAID
             WHERE NRRELATANAL = @P_SEQUMOVI 
               AND IDSALDOESTAN = 'SP';

             SET @V_VRSOMSATUAN = @V_VRSOMSATUAN  + @V_VRCUSTTOTAL + @V_VRCUSTLOGLME + @V_VRCUSTSEGLME + @V_VRDIFCUSSAID;
             SET @V_VRQTDESATUAN = @V_VRQTDESATUAN + @V_VRQTDETOTAL;
         END;

         -- Saldo Retirada

         IF (@V_IDTIPOMOVIEST = '3') AND (@V_VRCUSTTOTAL <> 0) BEGIN
            UPDATE RELAT_ANALMOVI
               SET VRSALDOESTAN = VRSALDOESTAN + @V_VRCUSTTOTAL,
                   QTSALDOESTAN = QTSALDOESTAN + @V_VRQTDETOTAL,
                   IDSALDOESTAN = 'SR'
             WHERE NRRELATANAL = @P_SEQUMOVI
               AND IDSALDOESTAN = 'SR'
               AND CDTIPORETIAN   = @V_CDTIPORETIME;

            UPDATE RELAT_ANALMOVI
               SET VRSALDOESTAN = VRSALDOESTAN + @V_VRDIFCUSSAID
             WHERE NRRELATANAL = @P_SEQUMOVI 
               AND IDSALDOESTAN = 'SP';

             SET @V_VRSOMSATUAN = @V_VRSOMSATUAN  - @V_VRCUSTTOTAL+ @V_VRDIFCUSSAID;
             SET @V_VRQTDESATUAN = @V_VRQTDESATUAN - @V_VRQTDETOTAL;
         END;

         -- Saldo Sada

         IF (@V_IDTIPOMOVIEST = '4' ) AND (@V_VRCUSTTOTAL <> 0) BEGIN
            UPDATE RELAT_ANALMOVI
               SET VRSALDOESTAN = VRSALDOESTAN + @V_VRCUSTTOTAL,
                   QTSALDOESTAN = QTSALDOESTAN + @V_VRQTDETOTAL,
                   IDSALDOESTAN = 'SS'
             WHERE NRRELATANAL = @P_SEQUMOVI
               AND IDSALDOESTAN = 'SS'
               AND IDENTRSAIDAN = @V_IDENTRSAIDME 
               AND CDTIPOOPERAN = @V_CDTIPOOPERME;

            UPDATE RELAT_ANALMOVI
               SET VRSALDOESTAN = VRSALDOESTAN + @V_VRDIFCUSSAID
             WHERE NRRELATANAL = @P_SEQUMOVI 
               AND IDSALDOESTAN = 'SP';

             SET @V_VRSOMSATUAN = @V_VRSOMSATUAN  - @V_VRCUSTTOTAL+ @V_VRDIFCUSSAID;
             SET @V_VRQTDESATUAN = @V_VRQTDESATUAN - @V_VRQTDETOTAL;

         END;

         IF (@V_IDTIPOMOVIEST = '5') AND (@V_VRCUSTTOTAL <> 0) BEGIN
            UPDATE RELAT_ANALMOVI
               SET VRSALDOESTAN = VRSALDOESTAN + @V_VRCUSTTOTAL,
                   QTSALDOESTAN = QTSALDOESTAN + @V_VRQTDETOTAL,
                   IDSALDOESTAN = 'SS'
             WHERE NRRELATANAL = @P_SEQUMOVI
               AND IDSALDOESTAN = 'SS'
               AND IDENTRSAIDAN = @V_IDENTRSAIDME 
               AND CDTIPOOPERAN = @V_CDTIPOOPERME;

            UPDATE RELAT_ANALMOVI
               SET VRSALDOESTAN = VRSALDOESTAN
             WHERE NRRELATANAL = @P_SEQUMOVI 
               AND IDSALDOESTAN = 'SP';

             SET @V_VRSOMSATUAN    = @V_VRSOMSATUAN  - @V_VRCUSTTOTAL;
             SET @V_VRQTDESATUAN   = @V_VRQTDESATUAN - @V_VRQTDETOTAL;
         END;
         -- Saldo Atual

         UPDATE RELAT_ANALMOVI
            SET VRSALDOESTAN = VRSALDOESTAN + @V_VRSOMSATUAN,
                QTSALDOESTAN = QTSALDOESTAN + @V_VRQTDESATUAN,
                IDSALDOESTAN = 'ST'
          WHERE NRRELATANAL = @P_SEQUMOVI
            AND IDSALDOESTAN = 'ST';

         IF ((@V_IDTIPOMOVIEST = '-') AND (@V_VRCUSTTOTAL = 0)) OR (@V_IDTIPOMOVIEST <> '-') BEGIN
            -- Custo de Logstica
            UPDATE RELAT_ANALMOVI
               SET VRSALDOESTAN = VRSALDOESTAN + @V_VRCUSTLOGLME
             WHERE NRRELATANAL = @P_SEQUMOVI 
               AND IDSALDOESTAN = 'SL';

            -- Custo de Seguro
            UPDATE RELAT_ANALMOVI
               SET VRSALDOESTAN = VRSALDOESTAN + @V_VRCUSTSEGLME
             WHERE NRRELATANAL  = @P_SEQUMOVI 
               AND IDSALDOESTAN = 'SG';
         END;

      FETCH NEXT FROM C_TOTALMOVI INTO @V_CDTOTMOVIEST, @V_IDTIPOMOVIEST, @V_VRCUSTTOTAL,
                                       @V_VRQTDETOTAL,  @V_CDTIPORETIME,  @V_NMTIPORETIME,
                                       @V_IDENTRSAIDME, @V_CDTIPOOPERME,  @V_VRCUSTLOGLME,
                                       @V_VRCUSTSEGLME, @V_VRDIFCUSTEME,  @V_VRDIFCUSSAID;
      END;

      CLOSE C_TOTALMOVI;
      DEALLOCATE C_TOTALMOVI;
/*Quando o saldo de um produto  zerado por NF's de devoluo ocorre um divergencia na evoluo do custo,
  segue abaixo tratamento para igualar a totalizao do saldo em estoque qdo houver NF's de devoluo com
  custo diferente do custo mdio do dia.
  */

      DECLARE C_DEVOLUCAO CURSOR FOR
         SELECT CDPRODTOTAMOVI
         FROM RELAT_TOTAMOVI
         WHERE NRRELATTOTA    = @P_SEQUMOVI;

      OPEN C_DEVOLUCAO;
      FETCH NEXT FROM C_DEVOLUCAO INTO @V_CDPRODTOTAMOVI;

      WHILE (@@FETCH_STATUS = 0) BEGIN
         DECLARE C_DIFERENCA CURSOR FOR
            SELECT DTLANCMOVIEST
              FROM RELAT_MOVIEST
             WHERE QTLANCAMENTO <> 0
               AND IDTIPOMOVIEST = '5'
               AND CDTOTMOVIEST = @V_CDPRODTOTAMOVI
               AND QTDEMOVIEST = 0
               AND NRRELATMOVI = @P_SEQUMOVI
             GROUP BY DTLANCMOVIEST;
         OPEN C_DIFERENCA;
         FETCH NEXT FROM C_DIFERENCA INTO @V_DTLANCMOVIESTD;

         WHILE (@@FETCH_STATUS = 0) BEGIN
            SELECT @V_VRDIFSAID = SUM(CASE VRDIFCUSTEME WHEN 0 THEN 0 ELSE ((VRCUSTMEDI*QTLANCAMENTO)-(VRDIFCUSTEME*QTLANCAMENTO)) END)
              FROM RELAT_MOVIEST
             WHERE QTLANCAMENTO <> 0
               AND IDTIPOMOVIEST = '5'
               AND CDTOTMOVIEST = @V_CDPRODTOTAMOVI
               AND DTLANCMOVIEST  = @V_DTLANCMOVIESTD
               AND NRRELATMOVI = @P_SEQUMOVI;

            UPDATE RELAT_TOTAMOVI
               SET VRSOMSATU = VRSOMSATU + @V_VRDIFSAID,
                   VRSOMDIFSAID = ISNULL(VRSOMDIFSAID,0) + @V_VRDIFSAID
             WHERE CDPRODTOTAMOVI = @V_CDPRODTOTAMOVI 
               AND NRRELATTOTA    = @P_SEQUMOVI;

            UPDATE RELAT_ANALMOVI
               SET VRSALDOESTAN = VRSALDOESTAN + @V_VRDIFSAID
             WHERE NRRELATANAL = @P_SEQUMOVI 
               AND IDSALDOESTAN = 'SP';

            UPDATE RELAT_ANALMOVI
               SET VRSALDOESTAN = VRSALDOESTAN + @V_VRDIFSAID
             WHERE NRRELATANAL = @P_SEQUMOVI 
               AND IDSALDOESTAN = 'ST';

            FETCH NEXT FROM C_DIFERENCA INTO @V_DTLANCMOVIESTD;
         END;
         CLOSE C_DIFERENCA;
         DEALLOCATE C_DIFERENCA;

         FETCH NEXT FROM C_DEVOLUCAO INTO @V_CDPRODTOTAMOVI;

      END;
      CLOSE C_DEVOLUCAO;
      DEALLOCATE C_DEVOLUCAO;

      INSERT INTO RELAT_TOTAMOVI
         (IDTIPOTOTAMOVI, CDPRODTOTAMOVI, VRSOMPINI, VRSOMAINV, VRSOMINVE,
          VRSOMENTR, VRSOMRETI, VRSOMSAID, VRSOMDFOR, VRSOMSATU, NRRELATTOTA,
          VRSOMCUSTLOG, VRSOMCUSTSEG)
         (SELECT 'T', 'TOTALGERAL', SUM(VRSOMPINI),
          SUM(VRSOMAINV), SUM(VRSOMINVE), SUM(VRSOMENTR),
          SUM(VRSOMRETI), SUM(VRSOMSAID), SUM(VRSOMDFOR),
          SUM(VRSOMSATU), @P_SEQUMOVI AS NRRELATTOTA,
          SUM(VRSOMCUSTLOG),  SUM(VRSOMCUSTSEG)
          FROM RELAT_TOTAMOVI
          WHERE NRRELATTOTA = @P_SEQUMOVI);
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'MOVIMENTACAO_ESTOQUE','5.05.148';
GO